{
    

  .
    -   
    -         
    -     ,   ..
    -        
    -     
    -       
    -         
    -      
    -     
    -  -  (Splitter)
    -         (TrayIcon)
    - ,     (  
         10ms  )
    -    (CheckList)
    -    (CheckTree)
    -           *.exe,
      *.dll, *.cpl, *.ico, *.cur, *.ani
    -        .
    -    
    - ,    ,  
       Delphi.
    -  -  TUpDown,   SCROLLBAR.
    -      .

   . 
  E-mail: roman@sar.nnov.ru
}

unit Ex_Controls;

interface

{$I EX.INC}

uses
  Windows, ShellAPI, ShlObj, SysUtils, Messages, Classes, Graphics, Math,
  Controls, Forms, Dialogs, Menus, StdCtrls, ExtCtrls, CommCtrl, ComCtrls,
  {$IFDEF EX_D4_UP} ImgList, {$ENDIF} Registry, ExtUtils;

type

{ TFormSizer }

  {
       .     ,
       .     
     ,     ""
         .

    :

    ScreenHeight -     (   
                   ).
    ScreenWidth -      (   
                   ).

    :

    Enabled -           .
    MinWidth -        .
    MinHeight -       .
    MaxWidth -        .
    MaxHeight -       .
    Options -          .  
                   :
                     soSetMinWidth -          
                                           .
                     soSetMinHeight -         
                                           .
                     soSetMaxWidth -          
                                           .
                     soSetMaxHeight -         
                                           .
                     soAlwaysOnDisplay -       
                                          .
                     soMaximizeToScreen -      
                                           .
                     soSnapScreen -            
                                          ,    
                                            
                                              .
    SnapSize -     ,      
                    .

    :

    OnGetSnapRect -   .   
                       .
    OnMaximized -    .
    OnMinimized -    .
    OnMoving -       .   
                       ,  
                     .
    OnRestored -        .
    OnSizing -          . 
                        (,
                      ,  Object Inspector).
  }

  TSizeOption = (soSetMinWidth, soSetMinHeight, soSetMaxWidth, soSetMaxHeight,
    soAlwaysOnDisplay, soMaximizeToScreen, soSnapToScreen);
  TSizeOptions = set of TSizeOption;

  TSizingEvent = procedure(Sender: TObject; Side: Integer; var Rect: TRect) of object;
  TSnapRectEvent = procedure(Sender: TObject; Rect: TRect; var SnapRect: TRect) of object;                                                                     

  TFormSizer = class(TComponent)
  private
    FForm: TForm;
    FFormHook: TWndHook;
    FMinWidth: Integer;
    FMinHeight: Integer;
    FMaxWidth: Integer;
    FMaxHeight: Integer;
    FSnapSize: Integer;
    FOptions: TSizeOptions;
    FEnabled: Boolean;
    FMoveCount: Integer;
    FMoveDX: Integer;
    FMoveDY: Integer;
    FOnMaximized: TNotifyEvent;
    FOnMinimized: TNotifyEvent;
    FOnRestored: TNotifyEvent;
    FOnMoving: TSizingEvent;
    FOnSizing: TSizingEvent;
    FOnGetSnapRect: TSnapRectEvent;
    procedure DoMaximized;
    procedure DoMinimized;
    procedure DoRestored;
    procedure FormProc(var Message: TMessage);
    procedure SetEnabled(Value: Boolean);
    procedure SetMaxHeight(Value: Integer);
    procedure SetMaxWidth(Value: Integer);
    procedure SetMinHeight(Value: Integer);
    procedure SetMinWidth(Value: Integer);
    procedure SetOptions(Value: TSizeOptions);
    procedure UpdateFormBounds;
  protected
    procedure GetBoundsInfo(var Left, Top, Width, Height: Integer); virtual;
    procedure GetMaximizedInfo(var MaxPosition, MaxSize: TPoint); virtual;
    procedure GetMinMaxInfo(var MinSize, MaxSize: TPoint); virtual;
    procedure GetPosInfo(Side: Integer; var Rect: TRect); virtual;
    procedure GetSizeInfo(Side: Integer; var Rect: TRect); virtual;
    procedure GetSnapRect(Rect: TRect; var SnapRect: TRect); virtual;
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function ScreenHeight: Integer;
    function ScreenWidth: Integer;
  published
    property Enabled: Boolean read FEnabled write SetEnabled default True;
    property MinWidth: Integer read FMinWidth write SetMinWidth default 112;
    property MinHeight: Integer read FMinHeight write SetMinHeight default 27;
    property MaxWidth: Integer read FMaxWidth write SetMaxWidth;
    property MaxHeight: Integer read FMaxHeight write SetMaxHeight;
    property Options: TSizeOptions read FOptions write SetOptions;
    property SnapSize: Integer read FSnapSize write FSnapSize default 10;
    property OnGetSnapRect: TSnapRectEvent read FOnGetSnapRect write FOnGetSnapRect;
    property OnMaximized: TNotifyEvent read FOnMaximized write FOnMaximized;
    property OnMinimized: TNotifyEvent read FOnMinimized write FOnMinimized;
    property OnMoving: TSizingEvent read FOnMoving write FOnMoving;
    property OnRestored: TNotifyEvent read FOnRestored write FOnRestored;
    property OnSizing: TSizingEvent read FOnSizing write FOnSizing;
  end;

{ TFormPlacement }

  {
       ,      .

    :

    LoadFromRegistry -      
                       .     -  ,
                          PlacementKey.
    SaveToRegistry   -       .
                           -  , 
                         PlacementKey.

    :

    AutoPlace -             
                           .
    Options -           .   :
                         poOrigin -   .
                         poSize -     .
                         poState -    .
    PlacementKey -          .

    :

    OnLoad -            .    
                       TRegIniFile,      .
    OnSave -            .
  }

  TPlacement = record
    Left: Integer;
    Top: Integer;
    Width: Integer;
    Height: Integer;
    State: Integer;
  end;

  TPlacementOption = (poOrigin, poSize, poState);
  TPlacementOptions = set of TPlacementOption;

  TLoadFromRegistryEvent = procedure(Sender: TObject; IniFile: TRegIniFile) of object;
  TSaveToRegistryEvent = procedure(Sender: TObject; IniFile: TRegIniFile) of object;

  TFormPlacement = class(TComponent)
  private
    FForm: TForm;
    FFormHook: TWndHook;
    FPlacementKey: string;
    FOptions: TPlacementOptions;
    FAutoPlace: Boolean;
    FOnLoad: TLoadFromRegistryEvent;
    FOnSave: TSaveToRegistryEvent;
    procedure FormProc(var Message: TMessage);
    function GetFormPlacement: TPlacement;
    procedure ReadOldKey(Reader: TReader);
    procedure SetFormPlacement(Value: TPlacement);
  protected
    procedure DefineProperties(Filer: TFiler); override;
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure LoadFromRegistry(const Key: string);
    procedure SaveToRegistry(const Key: string);
  published
    property AutoPlace: Boolean read FAutoPlace write FAutoPlace default True;
    property Options: TPlacementOptions read FOptions write FOptions;
    property PlacementKey: string read FPlacementKey write FPlacementKey;
    property OnLoad: TLoadFromRegistryEvent read FOnLoad write FOnLoad;
    property OnSave: TSaveToRegistryEvent read FOnSave write FOnSave;
  end;

{ TPreventer }

  {
         , , 
             , , ,
    ,   Windows,     
    (  D2).      ,
      .      
     MDI  (  ,     ).

    :

    Options -   .   :
                poMove -                , 
                                       ""  .
                poResize -               ,
                                        ""  .
                poResizeLeft -           
                                         .
                poResizeRight -          
                                         .
                poResizeTop -            
                                         .
                poResizeTopLeft -        
                                        .
                poResizeTopRight -       
                                        .
                poResizeBottom -         
                                         .
                poResizeBottomLeft -     
                                        .
                poResizeBottomRight -    
                                        .
                poMinimize -            , 
                                       ""  . 
                                         
                                        BorderIcons .
                poMaximize -            , 
                                       ""  . 
                                         
                                        BorderIcons .
                poClose -               , 
                                       ""  .  
                                           
                                      Alt+F4.
                poExitWindows -         Windows 
                                           
                                      .
                poTaskBar -               
                                      (  D2).
                poDialogMinimize -         
                                       . : 
                                           
                                        .  
                                          
                                        .
                poDialogResize -          
                                        .
                                      :    
                                          
                                      .
                poCaptionBar -            ( 
                                      ).
                poCloseButtonBug -       
                                       MDI  ( 
                                          ,
                                         
                                      ,    ).
    Mode -         .  
              :
                pmHide -       .
                pmDisable -    .
  }

  TPreventOption = (poMove, poResize, poResizeLeft, poResizeRight,
    poResizeTop, poResizeTopLeft, poResizeTopRight, poResizeBottom,
    poResizeBottomLeft, poResizeBottomRight, poMinimize, poMaximize,
    poRestore, poClose, poExitWindows, poTaskBar, poDialogMinimize,
    poDialogResize, poCaptionBar, poCloseButtonBug);

  TPreventOptions = set of TPreventOption;
  TPreventMode = (pmHide, pmDisable);

  TPreventer = class(TComponent)
  private
    FOptions: TPreventOptions;
    FMode: TPreventMode;
    procedure SetOptions(Value: TPreventOptions);
  protected
    procedure Loaded; override;
    function PreventMenu(Menu: HMENU; Position, Flags: Integer): Boolean; virtual;
    function PreventSeparator(Menu: HMENU; Index: Integer): Boolean; virtual;
  public
    procedure Prevent; virtual;
  published
    property Options: TPreventOptions read FOptions write SetOptions;
    property Mode: TPreventMode read FMode write FMode default pmHide;
  end;

{ TFormPreventer }

  {  XXX  (.  TPreventer). }

  TExitWindowsEvent = procedure(Sender: TObject; var AllowExit: Boolean) of object;
  TInitSysMenuEvent = procedure(Sender: TObject; SysMenu: HMENU) of object;

  TFormPreventer = class(TPreventer)
  private
    FForm: TForm;
    FFormHook: TWndHook;
    FOnExitWindows: TExitWindowsEvent;
    FOnInitSysMenu: TInitSysMenuEvent;
    procedure FormProc(var Message: TMessage);
  protected
    procedure ExitWindows(var AllowExit: Boolean); virtual;
    procedure InitSysMenu(SysMenu: HMENU); virtual;
    procedure Loaded; override;
  public
    destructor Destroy; override;
    procedure Prevent; override;
  published
    property OnExitWindows: TExitWindowsEvent read FOnExitWindows write FOnExitWindows;
    property OnInitSysMenu: TInitSysMenuEvent read FOnInitSysMenu write FOnInitSysMenu;
  end;

{ TAppPreventer }

  {  XXX  (.  TPreventer). }

  TInitAppMenuEvent = procedure(Sender: TObject; AppMenu: HMENU) of object;

  TAppPreventer = class(TPreventer)
  private
    FAppHook: TWndHook;
    FOnExitWindows: TExitWindowsEvent;
    FOnInitAppMenu: TInitAppMenuEvent;
    procedure AppProc(var Message: TMessage);
  protected
    procedure ExitWindows(var AllowExit: Boolean); virtual;
    procedure InitAppMenu(AppMenu: HMENU); virtual;
    procedure Loaded; override;
  public
    destructor Destroy; override;
    procedure Prevent; override;
  published
    property OnExitWindows: TExitWindowsEvent read FOnExitWindows write FOnExitWindows;
    property OnInitAppMenu: TInitAppMenuEvent read FOnInitAppMenu write FOnInitAppMenu;
  end;

{ TFormHook }

  {
      .

    :

    OnEnter -     .
    OnExit -      .

  }

  THookEvent = procedure(var Message: TMessage; var Handled: Boolean) of object;

  TFormHook = class(TComponent)
  private
    FForm: TForm;
    FFormHook: TWndHook;
    FOnEnter: THookEvent;
    FOnExit: THookEvent;
    procedure FormProc(var Message: TMessage);
  protected
    procedure Enter(var Message: TMessage; var Handled: Boolean); virtual;
    procedure Exit(var Message: TMessage; var Handled: Boolean); virtual;
    procedure Loaded; override;
  public
    destructor Destroy; override;
  published
    property OnEnter: THookEvent read FOnEnter write FOnEnter;
    property OnExit: THookEvent read FOnExit write FOnExit;
  end;

{ TFormEdge }

  {
        .    
        MDI    MDI  
           ( 
           Align = alClient).

    :      , .   
      StatusBar, ToolBar (align = alTop, alBottom),  
      .
  }

  TFormEdge = class(TComponent)
  private
    FVisible: Boolean;
    procedure SetVisible(Value: Boolean);
    procedure UpdateEdge;
  protected
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Visible: Boolean read FVisible write SetVisible default True;
  end;

{ TAppHook }

  {
            TApplcication.

    :

    Options -    .   :
                 ahEvents -     .
                 ahMessages -    .

    :

    OnAppXXX -    TApplication.
    OnEnter -      .
    OnExit -       .
  }

  TAppHookOption = (ahEvents, ahMessages);
  TAppHookOptions = set of TAppHookOption;

  TAppHook = class(TComponent)
  private
    FAppHook: TWndHook;
    FOptions: TAppHookOptions;
    FOnAppException: TExceptionEvent;
    FOnAppMessage: TMessageEvent;
    FOnAppIdle: TIdleEvent;
    FOnAppDeactivate: TNotifyEvent;
    FOnAppActivate: TNotifyEvent;
    FOnAppShowHint: TShowHintEvent;
    FOnAppMinimize: TNotifyEvent;
    FOnAppRestore: TNotifyEvent;
    FOnEnter: THookEvent;
    FOnExit: THookEvent;
    procedure AppProc(var Message: TMessage);
  protected
    procedure Enter(var Message: TMessage; var Handled: Boolean); virtual;
    procedure Exit(var Message: TMessage; var Handled: Boolean); virtual;
    procedure Loaded; override;
  public
    destructor Destroy; override;
  published
    property Options: TAppHookOptions read FOptions write FOptions;
    property OnAppActivate: TNotifyEvent read FOnAppActivate write FOnAppActivate;
    property OnAppDeactivate: TNotifyEvent read FOnAppDeactivate write FOnAppDeactivate;
    property OnAppException: TExceptionEvent read FOnAppException write FOnAppException;
    property OnAppIdle: TIdleEvent read FOnAppIdle write FOnAppIdle;
    property OnAppMessage: TMessageEvent read FOnAppMessage write FOnAppMessage;
    property OnAppMinimize: TNotifyEvent read FOnAppMinimize write FOnAppMinimize;
    property OnAppRestore: TNotifyEvent read FOnAppRestore write FOnAppRestore;
    property OnAppShowHint: TShowHintEvent read FOnAppShowHint write FOnAppShowHint;
    property OnEnter: THookEvent read FOnEnter write FOnEnter;
    property OnExit: THookEvent read FOnExit write FOnExit;
  end;

{ TAppInstance }

  {
       .

    :

    Active -         .
    AppName -        ,    
                   .      
                    .    AppName 
                   RunTime      
                    ( Active).

    :

    Activate -           
                   .   (  OnActive 
                   )  Application.BringToFront.
    ActivatePrev -    .
    Halt -            .  
                   (  OnHalt  ) 
                   System.Halt.
    Update -           . 
                         Active.

    :

    OnActivate -   ,       
                     .
    OnHalt -       ,     
                        .
  }

  TAppInstance = class(TComponent)
  private
    FAppName: string;
    FAppMessage: Cardinal;
    FAppMutex: THandle;
    FActive: Boolean;
    FOnActivate: TNotifyEvent;
    FOnHalt: TNotifyEvent;
    function AppHook(var Message: TMessage): Boolean;
    procedure SetActive(Value: Boolean);
    procedure UpdateInstance;
  protected
    procedure Activate; dynamic;
    procedure ActivatePrev; dynamic;
    procedure Halt; dynamic;
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Active: Boolean read FActive write SetActive default True;
    property AppName: string read FAppName write FAppName;
    property OnActivate: TNotifyEvent read FOnActivate write FOnActivate;
    property OnHalt: TNotifyEvent read FOnHalt write FOnHalt;
  end;

{ TAppHelp }

  {
      .     
        (Windows      
           ).

    :

    Options -    .  :
                hoDefaultContains -    
                                      (.. HelpContext) 
                                     .
                hoContextAsPopup -      
                                     popup  (   "?" 
                                    ).
                hoPopupAsContext -    popup   
                                      (  
                                    ).
                hoIgnoreZeroID -      ,  
                                    Data   ( ,  
                                     ).   
                                       " 
                                       ...".

    :

    OnHelp -       (Application.OnHelp).
    OnHint -      (Application.OnHint).
  }

  THelpOption = (hoDefaultContains, hoContextAsPopup, hoPopupAsContext, hoIgnoreZeroID);
  THelpOptions = set of THelpOption;

  TAppHelp = class(TComponent)
  private
    FOptions: THelpOptions;
    FInHelp: Boolean;
    FOnHelp: THelpEvent;
    FOnHint: TNotifyEvent;
    function AppHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;
    function GetHelpFile: string;
  protected
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Options: THelpOptions read FOptions write FOptions default [hoDefaultContains, hoIgnoreZeroID];
    property OnHelp: THelpEvent read FOnHelp write FOnHelp;
    property OnHint: TNotifyEvent read FOnHint write FOnHint;
  end;

{ TSplitPanel }

  TSplitBorderStyle = (bsNone, bsRaised, bsLowered);

  TSplitMode = (spUnknown, spLeft, spTop, spRight, spBottom);
  TSplitInverseMode = (imNew, imClear, imMove);

  TSplitPanel = class(TCustomControl)
  private
    FControl: TControl;
    FMin: Integer;
    FMax: Integer;
    FIndent: Integer;
    FBorderStyle: TSplitBorderStyle;
    FLimits: TRect;
    FSaveX: Integer;
    FSaveY: Integer;
    FSplitMode: TSplitMode;
    FSplitting: Boolean;
    FPrevOrg: TPoint;
    FOnSplit: TNotifyEvent;
    procedure CheckPosition(var X, Y: Integer);
    function GetMode: TSplitMode;
    function GetSplitRect: TRect;
    procedure SetBorderStyle(Value: TSplitBorderStyle);
    procedure SetControl(Value: TControl);
    procedure SetIndent(Value: Integer);
    procedure ShowSplitRect(X, Y: Integer; Mode: TSplitInverseMode);
    procedure StartSplit(X, Y: Integer);
    procedure StepSplit(X, Y: Integer);
    procedure StopSplit(X, Y: Integer);
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Notification(AComponent: TComponent; AOperation: TOperation); override;
    procedure Paint; override;
    procedure Split; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Align;
    property Enabled;
    property BorderStyle: TSplitBorderStyle read FBorderStyle write SetBorderStyle default bsNone;
    property Color;
    property Control: TControl read FControl write SetControl;
    property Cursor;
    property Indent: Integer read FIndent write SetIndent default 4;
    property Max: Integer read FMax write FMax default 0;
    property Min: Integer read FMin write fMin default 0;
    property ParentColor;
    property ParentShowHint;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnSplit: TNotifyEvent read FOnSplit write FOnSplit;
  end;

{ TThreadedTimer }

  {
    ,     .   
        10 .

    :

    Enabled -    (/).
    Interval -  .
    Priority -  .

    :

    OnTimer: - .
  }

  TThreadedTimer = class;

  TTimerThread = class(TThread)
  private
    FInterval: DWORD;
    FOwner: TThreadedTimer;
    procedure DoSleep;
    procedure DoTimer;
  protected
    procedure Execute; override;
  public
    constructor Create(ATimer: TThreadedTimer);
    property Owner: TThreadedTimer read FOwner;
  end;

  TThreadedTimer = class(TComponent)
  private
    FEnabled: Boolean;
    FInterval: DWORD;
    FThread: TTimerThread;
    FPriority: TThreadPriority;
    FOnTimer: TNotifyEvent;
    procedure SetEnabled(Value: Boolean);
    procedure SetInterval(Value: DWORD);
    procedure SetOnTimer(Value: TNotifyEvent);
    procedure SetPriority(Value: TThreadPriority);
    procedure UpdateTimer;
  protected
    procedure Loaded; override;
    procedure Timer; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Enabled: Boolean read FEnabled write SetEnabled default True;
    property Interval: DWORD read FInterval write SetInterval default 1000;
    property Priority: TThreadPriority read FPriority write SetPriority default tpNormal;
    property OnTimer: TNotifyEvent read FOnTimer write SetOnTimer;
  end;

{ TTrayIcon }

  {
         .

    :
      -  AnimationImages -  
      -  AnimationInterval -  
      -  AnimationIndex -   
      -  Animated -    
      -  ,    

    :

    Icon -       .     16x16.
    IconID -        (    
                   ).
    Hint -        .
    PopupMenu -    .     
                   .
    Visible -     .

    :

    OnClick -         .
    OnDblClick -       .
  }

  TTrayPopupEvent = procedure(Sender: TObject; var AllowPopup: Boolean) of object; 

  TTrayIcon = class(TComponent)
  private
    FHandle: HWnd;
    FData: TNotifyIconData;
    FVisible: Boolean;
    FIcon: TIcon;
    FIconID: Integer;
    FHint: string;
    FPopupMenu: TPopupMenu;
    FOnClick: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
    FOnPopup: TTrayPopupEvent;
    procedure IconChange(Sender: TObject);
    procedure SetIcon(Value: TIcon);
    procedure SetIconID(Value: Integer);
    procedure SetHint(Value: string);
    procedure SetPopupMenu(Value: TPopupMenu);
    procedure SetVisible(Value: Boolean);
    procedure WndProc(var Message: TMessage);
    procedure UpdateIcon;
  protected
    function AllowPopup: Boolean; dynamic;
    procedure Click; dynamic;
    procedure DblClick; dynamic;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Popup; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Icon: TIcon read FIcon write SetIcon;
    property IconID: Integer read FIconID  write SetIconID default 0;
    property Hint: string read FHint write SetHint;
    property PopupMenu: TPopupMenu read FPopupMenu write SetPopupMenu;
    property Visible: Boolean read FVisible write SetVisible default False;
    property OnClick: TNotifyEvent read FOnClick write FOnClick;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnPopup: TTrayPopupEvent read FOnPopup write FOnPopup;
  end;

{ TCheckList }

  {
       (CheckBox).     , 
         (   " Windows").

    :

    Checked -      /    .
    Colors -       /   .
    ImageIndex -   /    .
    State -        /    .

    Check3D -          3D ().
    Check95 -          Windows 95 (  ).
    CheckVisible -  .

    Images -        .

    :

    OnChecked -      
    OnChecking -     
  }

  TCheckingItemEvent = procedure(Sender: TObject; Index: Integer; var State: TCheckBoxState) of object;
  TCheckedItemEvent = procedure(Sender: TObject; Index: Integer; State: TCheckBoxState) of object;

  TCheckState = class
  public
    Checked: Boolean;
    State: TCheckBoxState;
    ImageIndex: Integer;
    Color: TColor;
  end;

  TCheckList = class(TCustomListBox)
  private
    FStateList: TList;
    FBitmap: TBitmap;
    FBitmap95: TBitmap;
    FBitmap3D: TBitmap;
    FCheck3D: Boolean;
    FCheck95: Boolean;
    FCheckVisible: Boolean;
    FHideSelection: Boolean;
    FImages: TImageList;
    FImagesLink: TChangeLink;
    FOnChecking: TCheckingItemEvent;
    FOnChecked: TCheckedItemEvent;
    procedure ClearStateList;
    procedure ImagesChange(Sender: TObject);
    procedure InvalidateCheck(Index: Integer);
    procedure InvalidateImage(Index: Integer);
    procedure InvalidateItem(Index: Integer);
    function GetChecked(Index: Integer): Boolean;
    function GetCheckRect(Index: Integer): TRect;
    function GetColor(Index: Integer): TColor;
    function GetImageIndex(Index: Integer): Integer;
    function GetImageRect(Index: Integer): TRect;
    function GetState(Index: Integer): TCheckBoxState;
    procedure SetCheck3D(Value: Boolean);
    procedure SetCheck95(Value: Boolean);
    procedure SetCheckVisible(Value: Boolean);
    procedure SetChecked(Index: Integer; Value: Boolean);
    procedure SetColor(Index: Integer; Value: TColor);
    procedure SetImageIndex(Index: Integer; Value: Integer);
    procedure SetImages(Value: TImageList);
    procedure SetHideSelection(Value: Boolean);
    procedure SetState(Index: Integer; Value: TCheckBoxState);
    procedure ValidateIndex(Index: Integer);
    procedure CNDrawItem(var Message: TWMDrawItem); message CN_DRAWITEM;
  protected
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Checked[Index: Integer]: Boolean read GetChecked write SetChecked;
    property Colors[Index: Integer]: TColor read GetColor write SetColor;
    property ImageIndex[Index: Integer]: Integer read GetImageIndex write SetImageIndex;
    property State[Index: Integer]: TCheckBoxState read GetState write SetState;
  published
    property Align;
    {property Anchors;}
    property BorderStyle;
    property Check3D: Boolean read FCheck3D write SetCheck3D default False;
    property Check95: Boolean read FCheck95 write SetCheck95 default True;
    property CheckVisible: Boolean read FCheckVisible write SetCheckVisible default True;
    property Color;
    property Columns;
    {property Constraints;}
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection: Boolean read FHideSelection write SetHideSelection default False;
    property Images: TImageList read FImages write SetImages;
    property IntegralHeight;
    property ItemHeight;
    property Items;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabWidth;
    property Visible;
    property OnClick;
    property OnChecked: TCheckedItemEvent read FOnChecked write FOnChecked;
    property OnChecking: TCheckingItemEvent read FOnChecking write FOnChecking;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

{ TCheckTree }

  {
       (CheckBox).    
     .

    :

    Checked -    /    .
    State -      /    . 
                     nil,   
                  .

    Check3D -        3D ().
    Check95 -        Windows 95 (  ).
    CheckChild -       True 
                   True    .
  }

  TCheckTree = class(TCustomTreeView)
  private
    FImages: TImageList;
    FImages95: TImageList;
    FImages3D: TImageList;
    FCheck3D: Boolean;
    FCheck95: Boolean;
    FCheckChild: Boolean;
    function GetChecked(Node: TTreeNode): Boolean;
    function GetState(Node: TTreeNode): TCheckBoxState;
    procedure SetCheck3D(Value: Boolean);
    procedure SetCheck95(Value: Boolean);
    procedure SetChecked(Node: TTreeNode; Value: Boolean);
    procedure SetState(Node: TTreeNode; Value: TCheckBoxState);
  protected
    procedure ApplyImage(Node: TTreeNode; ImageIndex: Integer);
    procedure CheckChildren(Node: TTreeNode); dynamic;
    procedure CheckParent(Parent: TTreeNode); dynamic;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Checked[Node: TTreeNode]: Boolean read GetChecked write SetChecked;
    property State[Node: TTreeNode]: TCheckBoxState read GetState write SetState;
  published
    property Align;
    property BorderStyle;
    property Check3D: Boolean read FCheck3D write SetCheck3D default False;
    property Check95: Boolean read FCheck95 write SetCheck95 default True;
    property CheckChild: Boolean read FCheckChild write FCheckChild default False;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property Indent;
    property Items;
    property ParentColor;
    property ParentCtl3D;
    property PopupMenu;
    property ParentFont;
    property ParentShowHint;
    property ReadOnly;
    property ShowButtons;
    property ShowHint;
    property ShowLines;
    property ShowRoot;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnChange;
    property OnChanging;
    property OnClick;
    property OnCollapsed;
    property OnCollapsing;
    property OnDblClick;
    property OnDeletion;
    property OnEdited;
    property OnEditing;
    property OnEnter;
    property OnExit;
    property OnExpanded;
    property OnExpanding;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

{ TIconBox }

  {
      .      
    .

    :

    UpdateIcons -       .

    :

    IconCount -      .
    Icons -         ().
    IconsBitmap -  ,   .

    AutoSize -          
                    .
    IconIndex -     .
    IconFile -       .
    IconPath -          "_, ".
                         .
    IconSize -      .  :
                    isLarge -   (32x32).
                    isSmall -   (16x16).

    :

    OnChange -    .
  }

  TIconSize = (isLarge, isSmall);

  TIconBox = class(TCustomListBox)
  private
    FLargeIcons: TImageList;
    FSmallIcons: TImageList;
    FIconFile: string;
    FIconSize: TIconSize;
    FAutoSize: Boolean;
    FHideSelection: Boolean;
    FOnChange: TNotifyEvent;
    procedure CreateList;
    procedure FreeList;
    function GetBitmap: HBITMAP;
    function GetIcon(Index: Integer): HICON;
    function GetIconCount: Integer;
    function GetIconIndex: Integer;
    function GetIconPath: string;
    procedure SetAutoSize(Value: Boolean);
    procedure SetIconIndex(Value: Integer);
    procedure SetIconFile(Value: string);
    procedure SetIconPath(Value: string);
    procedure SetIconSize(Value: TIconSize);
    procedure SetHideSelection(Value: Boolean);
    procedure UpdateBounds;
    procedure UpdateListBox;
    procedure CNDrawItem(var Message: TWMDrawItem); message CN_DRAWITEM;
  protected
    procedure Change; virtual;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure MeasureItem(Index: Integer; var Height: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    procedure UpdateIcons;
    property IconCount: Integer read GetIconCount;
    property Icons[Index: Integer]: HICON read GetIcon;
    property IconsBitmap: HBITMAP read GetBitmap;
  published
    property AutoSize: Boolean read FAutoSize write SetAutoSize default True;
    property Color;
    property Ctl3D;
    property Enabled;
    property Font;
    property IconIndex: Integer read GetIconIndex write SetIconIndex stored False;
    property IconFile: string read FIconFile write SetIconFile stored False;
    property IconPath: string read GetIconPath write SetIconPath;
    property IconSize: TIconSize read FIconSize write SetIconSize default isLarge;
    property HideSelection: Boolean read FHideSelection write SetHideSelection default False;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnDblClick;
    property OnEnter;
    property OnExit;
  end;

{ TRecentFileList }

  {
            .
             
    .

    :

    LoadFromRegistry -      . 
                          -  ,  
                        FilesKey.
    SaveToRegistry   -      . 
                          -  ,  
                        FilesKey.

    :

    AutoSave -              
                         .
    FilesKey -          ,     .
    MaxFiles -            .
    MenuItem -         ,      
                      .
    SubMenu -                 
                       .     
                            .

    :

    OnSelectFile -         .
  }

  TSelectFileEvent = procedure(Sender: TObject; const FileName: string) of object;

  TRecentFileList = class(TComponent)
  private
    FFileList: TStringList;
    FMenuItem: TMenuItem;
    FSubMenu: Boolean;
    FMaxFiles: Integer;
    FAutoSave: Boolean;
    FFilesKey: string;
    FOnSelectFile: TSelectFileEvent;
    function GetFile(Index: Integer): string;
    function GetFileCount: Integer;
    procedure MenuItemClick(Sender: TObject);
    procedure ReadOldKey(Reader: TReader);
    procedure SetMaxFiles(Value: Integer);
    procedure SetSubMenu(Value: Boolean);
    procedure UpdateMenuItems;
  protected
    procedure DefineProperties(Filer: TFiler); override;
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Add(const FileName: string);
    procedure Clear;
    procedure Delete(Index: Integer);
    function IndexOf(const FileName: string): Integer;
    procedure LoadFromRegistry(const Key: string);
    procedure SaveToRegistry(const Key: string);
    procedure Remove(const FileName: string);
    property Files[Index: Integer]: string read GetFile;
    property FileCount: Integer read GetFileCount;
  published
    property AutoSave: Boolean read FAutoSave write FAutoSave default True;
    property FilesKey: string read FFilesKey write FFilesKey;
    property MaxFiles: Integer read FMaxFiles write SetMaxFiles default 5;
    property MenuItem: TMenuItem read FMenuItem write FMenuItem;
    property SubMenu: Boolean read FSubMenu write SetSubMenu default False;
    property OnSelectFile: TSelectFileEvent read FOnSelectFile write FOnSelectFile;
  end;

{ TListButton }

  {
        (,    
       Object Instector).

    :

    GetList -            .
    GetListBounds -     .
    GetText -             .
    Press -               (  
                      bsEllipsis).
    SetText -              .

    CloseUp -                
                      (..   SetText   ).
    DropDown -         .

    :

    List -               ListBox. : 
                         !
    ListVisible -        .
    Pressed -           .

    Alignment -          . 
                       :
                        baLeft -        
                                   ( ).
                        bsRight -      
                                    ( ).
                        baCenter -     .
    DropDownCount -      .
    Style -            .   :
                        bsEllipsis -   .
                        bsPickList -     (  TComboBox).

    :

    OnGetList -          . 
                          .
    OnGetListBounds -   .  , 
                      ,    
                        .    -  .
    OnGetText -           .
    OnSetText -            .
    OnPress -           (  CTRL+ENTER)  
                      (   bsEllipsis).
  }

  TButtonListBox = class(TCustomListBox)
  private
    FSearchText: String;
    FSearchTime: Longint;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure KeyPress(var Key: Char); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  end;

  TButtonGetTextEvent = procedure(Sender: TObject; var Text: string) of object;
  TButtonGetListEvent = procedure(Sender: TObject; Items: TStrings) of object;
  TButtonBoundsEvent = procedure(Sender: TObject; var Rect: TRect) of object;

  TListButtonStyle = (bsEllipsis, bsPickList);
  TListButtonAlignment = (baLeft, baRight, baCenter);

  TListButton = class(TCustomControl)
  private
    FStyle: TListButtonStyle;
    FAlignment: TListButtonAlignment;
    FDropDownCount: Integer;
    FList: TButtonListBox;
    FListVisible: Boolean;
    FTracking: Boolean;
    FPressed: Boolean;
    FControl: TWinControl;
    FOnGetList: TButtonGetListEvent;
    FOnGetListBounds: TButtonBoundsEvent;
    FOnGetText: TButtonGetTextEvent;
    FOnSetText: TButtonGetTextEvent;
    FOnPress: TNotifyEvent;
    procedure ListMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RestoreActiveControl;
    procedure SaveActiveControl;
    procedure SetStyle(Value: TListButtonStyle);
    procedure StartTracking(X, Y: Integer);
    procedure StepTracking(X, Y: Integer);
    procedure StopTracking;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure WMCancelMode(var Message: TMessage); message WM_CANCELMODE;
    procedure WMKillFocus(var Message: TMessage); message WM_KILLFOCUS;
    procedure WMEraseBkgnd(var Message: TWmEraseBkgnd); message WM_ERASEBKGND;
    procedure WMWindowPosChanged(var Message: TWMWindowPosChanged); message WM_WINDOWPOSCHANGED;
    procedure CMCancelMode(var Message: TCMCancelMode); message CM_CANCELMODE;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
  protected
    procedure GetList; virtual;
    procedure GetListBounds; virtual;
    procedure GetText; virtual;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Paint; override;
    procedure Press; virtual;
    procedure SetText; virtual;
    procedure WndProc(var Message: TMessage); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure CloseUp(Accept: Boolean);
    procedure DropDown;
    property List: TButtonListBox read FList;
    property ListVisible: Boolean read FListVisible;
    property Pressed: Boolean read FPressed;
  published
    property Alignment: TListButtonAlignment read FAlignment write FAlignment default baRight;
    property DropDownCount: Integer read FDropDownCount write FDropDownCount default 8;
    property Enabled;
    property Font;
    property ParentFont;
    property ParentShowHint;
    property Style: TListButtonStyle read FStyle write SetStyle default bsPickList;
    property Visible;
    property OnGetList: TButtonGetListEvent read FOnGetList write FOnGetList;
    property OnGetListBounds: TButtonBoundsEvent read FOnGetListBounds write FOnGetListBounds;
    property OnGetText: TButtonGetTextEvent read FOnGetText write FOnGetText;
    property OnSetText: TButtonGetTextEvent read FOnSetText write FOnSetText;
    property OnPress: TNotifyEvent read FOnPress write FOnPress;
  end;

{ TButtonStyler }

  {
    ,     - 
    (  TButtonControl: TButton, TCheckBox, TRadioButton)
     ,   Delphi.

    :  ,  ,   
     RecreateWnd  (,   Ctl3D  RunTime). 
          UpdateButton; 

    :

    UpdateButton -   .

    :

    FlatButton -      .
    HorzAlignment -   .
    PushLike -          .
    TextAlignment -    .
    VertAlignment -   .
    WordWrap -         ( Caption).
  }

  THorzAlignment = (haLeftJustify, haCenterJustify, haRightJustify);
  TVertAlignment = (vaTopJustify, vaCenterJustify, vaBottomJustify);

  TButtonStyler = class(TComponent)
  private
    FButton: TButtonControl;
    FWordWrap: Boolean;
    FHorzAlignment: THorzAlignment;
    FVertAlignment: TVertAlignment;
    FTextAlignment: TLeftRight;
    FFlatButton: Boolean;
    FPushLike: Boolean;
    procedure SetFlatButton(Value: Boolean);
    procedure SetHorzAlignment(Value: THorzAlignment);
    procedure SetPushLike(Value: Boolean);
    procedure SetTextAlignment(Value: TLeftRight);
    procedure SetVertAlignment(Value: TVertAlignment);
    procedure SetWordWrap(Value: Boolean);
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
  protected
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; AOperation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure UpdateButton; virtual;
  published
    property Button: TButtonControl read FButton write FButton;
    property FlatButton: Boolean read FFlatButton write SetFlatButton default False;
    property HorzAlignment: THorzAlignment read FHorzAlignment write SetHorzAlignment default haLeftJustify;
    property PushLike: Boolean read FPushLike write SetPushLike default False;
    property TextAlignment: TLeftRight read FTextAlignment write SetTextAlignment default taRightJustify;
    property VertAlignment: TVertAlignment read FVertAlignment write SetVertAlignment default vaCenterJustify;
    property WordWrap: Boolean read FWordWrap write SetWordWrap default False;
  end;

{ TUpDownBox }

  {
     -  TUpDown,   TScrollBox. 
           ,  
       TUpDown      .

    :

    Change -         .
    Changing -     .
    SetParams -      .

    :

    Associate -    ,    .
    AutoSize -        
                  .
    Increment -       .
    Max -          .
    Min -          .
    Position -     .

    :

    OnChange -       .
    OnChanging -   .
  }

  TUpDownBoxEvent = procedure(Sender: TObject; var Position: Integer) of object;

  TUpDownBox = class(TWinControl)
  private
    FPosition: Integer;
    FMin: Integer;
    FMax: Integer;
    FIncrement: Integer;
    FAssociate: TWinControl;
    FAutoSize: Boolean;
    FOnChanging: TUpDownBoxEvent;
    FOnChange: TNotifyEvent;
    procedure ReadIncriment(Reader: TReader);
    procedure SetAssociate(Value: TWinControl);
    procedure SetAutoSize(Value: Boolean);
    procedure SetMax(Value: Integer);
    procedure SetMin(Value: Integer);
    procedure SetPosition(Value: Integer);
    procedure UpdateControlPos;
    procedure UpdateScrollWnd;
    procedure CNVScroll(var Message: TWMVScroll); message CN_VSCROLL;
  protected
    procedure Change; virtual;
    procedure Changing(var Position: Integer); virtual;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure DefineProperties(Filer: TFiler); override;
    procedure Notification(AComponent: TComponent; AOperation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure SetParams(APosition, AMin, AMax: Integer);
  published
    property Associate: TWinControl read FAssociate write SetAssociate;
    property AutoSize: Boolean read FAutoSize write SetAutoSize default True;
    property Cursor;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Height;
    property Hint;
    property Increment: Integer read FIncrement write FIncrement default 1;
    property Max: Integer read FMax write SetMax default 100;
    property Min: Integer read FMin write SetMin default 0;
    property ParentShowHint;
    property PopupMenu;
    property Position: Integer read FPosition write SetPosition default 0;
    property ShowHint;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnChanging: TUpDownBoxEvent read FOnChanging write FOnChanging;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
  end;

{ TLogView }

  {
         . 
      TRichEdit.      (
    0.5, 2  5 )      
       .

    :

    CopyToClipboard -      .
    SelectAll -        .
    UpdateContents -    (  ).

    :

    AutoScroll -          
                        . 
    FileName -           .
    UpdateSpeed -      .   
                      :
                        usHigh -    (0.5 .).
                        usMedium -  (2 .).
                        usLow -     (5 .).
                        usPause -  .
                        usAuto -      .

    :

    OnInitViewError -       
                           .
                           
                        GetLastError.
    OnFileOpenError -     .  
                          
                       GetLastError.
    OnUpdate -           .

  }

const
  WM_FILECHANGED = WM_USER + 1;

type

  TLogUpdateSpeed = (usHigh, usMedium, usLow, usPause, usAuto);

  TLogErrorEvent = procedure(Sender: TObject; ErrCode: Integer) of object;

  TLogView = class(TCustomRichEdit)
  private
    FFileName: string;
    FUpdateSpeed: TLogUpdateSpeed;
    FAutoScroll: Boolean;
    FFileViewPos: Integer;
    FFileChangeThread: TThread;
    FFileError: Longint;
    FTimer: TTimer;
    FTimerFileSize: Integer;
    FTimerFileAge: Integer;
    FOnInitViewError: TLogErrorEvent;
    FOnFileOpenError: TLogErrorEvent;
    FOnUpdate: TNotifyEvent;
    procedure SetFileName(Value: string);
    procedure SetUpdateSpeed(Value: TLogUpdateSpeed);
    procedure UpdateTime(Sender: TObject);
    procedure WMFileChanged(var Message: TMessage); message WM_FILECHANGED;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure CopyToClipboard;
    procedure SelectAll;
    procedure UpdateContents(ReloadFile: Boolean);
  published
    property Align;
    property Alignment;
    property AutoScroll: Boolean read FAutoScroll write FAutoScroll default True;
    property BorderStyle;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FileName: string read FFileName write SetFileName;
    property Font;
{$IFDEF EX_D3_UP}
    property ImeMode;
    property ImeName;
{$ENDIF}
    property HideSelection;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop default True;
    property UpdateSpeed: TLogUpdateSpeed read FUpdateSpeed write SetUpdateSpeed default usPause;
    property Visible;
    property OnChange;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnInitViewError: TLogErrorEvent read FOnInitViewError write FOnInitViewError;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnFileOpenError: TLogErrorEvent read FOnFileOpenError write FOnFileOpenError;
    property OnResizeRequest;
    property OnSelectionChange;
    property OnStartDrag;
    property OnSaveClipboard;
    property OnUpdate: TNotifyEvent read FOnUpdate write FOnUpdate;
  end;

implementation

{$R *.RES}

{
          
   .

  ! Delphi      CM_RELEASE.
     (..   CallWndHook(...)),   
    ,   ,   .
          
     "Access Violation".
}

function IsReleaseMsg(var Hook: TWndHook; var Message: TMessage): Boolean;
begin
  {     }
  if Message.Msg = CM_RELEASE then
  begin
    CallWndHook(Hook, Message);
    Result := True;
  end
  else
    {   }
    Result := False;
end;

{ TFormSizer }

constructor TFormSizer.Create(AOwner: TComponent);
var
  R: TRect;
begin
  inherited Create(AOwner);
  FMinWidth := GetSystemMetrics(SM_CXMINTRACK);
  FMinHeight := GetSystemMetrics(SM_CYMINTRACK);
  SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
  FMaxWidth := R.Right - R.Left;
  FMaxHeight :=R.Bottom - R.Top;
  FSnapSize := 10;
  FOptions := [soSetMinWidth, soSetMinHeight, soMaximizeToScreen];
  FEnabled := True;
end;

destructor TFormSizer.Destroy;
begin
  FreeWndHook(FFormHook);
  inherited Destroy;
end;
                                                      
procedure TFormSizer.DoMaximized;
begin
  if Assigned(FOnMaximized) then FOnMaximized(Self);
end;

procedure TFormSizer.DoMinimized;
begin
  if Assigned(FOnMinimized) then FOnMinimized(Self);
end;

procedure TFormSizer.DoRestored;
begin
  if Assigned(FOnRestored) then FOnRestored(Self)
end;

procedure TFormSizer.FormProc(var Message: TMessage);
begin
  {   ,  CM_RELEASE }
  if not IsReleaseMsg(FFormHook, Message) then
  try
    {    }
    CallWndHook(FFormHook, Message);
    {     -    }
    {   }
    with Message do
      case Msg of
        WM_GETMINMAXINFO:
          if FEnabled then
            with PMinMaxInfo(LParam)^ do
            begin
              GetMaximizedInfo(ptMaxPosition, ptMaxSize);
              GetMinMaxInfo(ptMinTrackSize, ptMaxTrackSize);
            end;
        WM_WINDOWPOSCHANGING:
          {   }
          if FEnabled then
            with PWindowPos(LParam)^ do
              GetBoundsInfo(X, Y, CX, CY);
        WM_MOVING:
          {   () }
          if FEnabled then
            GetPosInfo(wParam, PRect(lParam)^);
        WM_MOVE:
          {   }
          FMoveCount := 0;
        WM_SIZING:
          {   () }
          if FEnabled then
            GetSizeInfo(wParam, PRect(lParam)^);
        WM_SIZE:
          {   }
          case wParam of
            SIZE_MAXIMIZED: DoMaximized;
            SIZE_MINIMIZED: DoMinimized;
            SIZE_RESTORED: DoRestored;
          end;
      end;
  except
    Application.HandleException(Self);
  end;
end;

procedure TFormSizer.SetEnabled(Value: Boolean);
begin
  if FEnabled <> Value then
  begin
    FEnabled := Value;
    if Value then UpdateFormBounds;
  end;
end;

procedure TFormSizer.SetMaxHeight(Value: Integer);
begin
  if FMaxHeight <> Value then
  begin
    FMaxHeight := Value;
    if FEnabled then UpdateFormBounds;
  end;
end;

procedure TFormSizer.SetMaxWidth(Value: Integer);
begin
  if FMaxWidth <> Value then
  begin
    FMaxWidth := Value;
    if FEnabled then UpdateFormBounds;
  end;
end;

procedure TFormSizer.SetMinHeight(Value: Integer);
begin
  if FMinHeight <> Value then
  begin
    FMinHeight := Value;
    if FEnabled then UpdateFormBounds;
  end;
end;

procedure TFormSizer.SetMinWidth(Value: Integer);
begin
  if FMinWidth <> Value then
  begin
    FMinWidth := Value;
    if FEnabled then UpdateFormBounds;
  end;
end;

procedure TFormSizer.SetOptions(Value: TSizeOptions);
begin
  if FOptions <> Value then
  begin
    FOptions := Value;
    if FEnabled then UpdateFormBounds;
  end;
end;

type
  TFormHookClass = class(TForm);

procedure TFormSizer.UpdateFormBounds;
var
  L, T, W, H: Integer;
begin
  if FForm <> nil then
  begin
    with FForm do
    begin
      {      }
      L := Left;
      T := Top;
      W := Width;
      H := Height;
      {       }
      if soSetMaxWidth in FOptions then W := MinIntValue([FMaxWidth, W]);
      if soSetMaxHeight in FOptions then H := MinIntValue([FMaxHeight, H]);
      if soSetMinWidth in FOptions then W := MaxIntValue([FMinWidth, W]);
      if soSetMinHeight in FOptions then H := MaxIntValue([FMinHeight, H]);
      if soAlwaysOnDisplay in FOptions then GetBoundsInfo(L, T, W, H);
      {      }
      SetBounds(L, T, W, H)
    end;
    TFormHookClass(FForm).Resize;
  end;
end;

procedure TFormSizer.GetBoundsInfo(var Left, Top, Width, Height: Integer);
var
  R: TRect;
begin
  {   "  " }
  if soAlwaysOnDisplay in FOptions then
  begin
    {    }
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    {   }
    if Width > R.Right - R.Left then Width := R.Right - R.Left;
    if Left + Width > R.Right then Left := R.Right - Width;
    if Left < R.Left then Left := R.Left;
    if Height > R.Bottom - R.Top then Height := R.Bottom - R.Top;
    if Top + Height > R.Bottom then Top := R.Bottom - Height;
    if Top < R.Top then Top := R.Top;
  end;
end;

procedure TFormSizer.GetMaximizedInfo(var MaxPosition, MaxSize: TPoint);
var
  R: TRect;
begin
  {      }
  if (soMaximizeToScreen in FOptions) and ((FForm = nil) or (FForm.FormStyle <> fsMDIChild)) then
  begin
    {    }
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    {   }
    MaxPosition.X := R.Left;
    MaxPosition.Y := R.Top;
    MaxSize.X := R.Right - R.Left;
    MaxSize.Y := R.Bottom - R.Top;
  end;
end;

procedure TFormSizer.GetMinMaxInfo(var MinSize, MaxSize: TPoint);
begin
  if soSetMinWidth in FOptions then MinSize.X := FMinWidth;
  if soSetMinHeight in FOptions then MinSize.Y := FMinHeight;
  if soSetMaxWidth in FOptions then MaxSize.X := FMaxWidth;
  if soSetMaxHeight in FOptions then MaxSize.Y := FMaxHeight;
end;

procedure TFormSizer.GetPosInfo(Side: Integer; var Rect: TRect);
var
  R: TRect;
  DX, DY: Integer;
begin
  {   "  " }
  if soAlwaysOnDisplay in FOptions then
  begin
    {    }
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    {     }
    if Rect.Right > R.Right then DX := Rect.Right - R.Right
    else if Rect.Left < R.Left then DX := Rect.Left - R.Left
    else DX := 0;
    {     }
    if Rect.Bottom > R.Bottom then DY := Rect.Bottom - R.Bottom
    else if Rect.Top < R.Top then DY := Rect.Top - R.Top
    else DY := 0;
    {    }
    OffsetRect(Rect, -DX, -DY);
  end;
  {     }
  if soSnapToScreen in FOptions then
  begin
    {    }
    if FMoveCount > 0 then OffsetRect(Rect, -FMoveDX, -FMoveDY);
    Inc(FMoveCount);
    {    }
    GetSnapRect(Rect, R);
    {   }
    FMoveDX := 0;
    FMoveDY := 0;
    {   }
    if Abs(Rect.Left - R.Left) < FSnapSize then FMoveDX := R.Left - Rect.Left;
    if Abs(Rect.Top - R.Top) < FSnapSize then FMoveDY := R.Top - Rect.Top;
    if Abs(R.Right - Rect.Right) < FSnapSize then FMoveDX := R.Right - Rect.Right;
    if Abs(R.Bottom - Rect.Bottom) < FSnapSize then FMoveDY := R.Bottom - Rect.Bottom;
    {  }
    OffsetRect(Rect, FMoveDX, FMoveDY);
  end;
  {   }
  if Assigned(FOnMoving) then FOnMoving(Self, Side, Rect);
end;

procedure TFormSizer.GetSizeInfo(Side: Integer; var Rect: TRect);
var
  R: TRect;
  DL, DT, DR, DB: Integer;

  procedure ResizeRect(var Rect: TRect; L, T, R, B: Integer);
  begin
    Rect.Left := Rect.Left + L;
    Rect.Top := Rect.Top + T;
    Rect.Right := Rect.Right + R;
    Rect.Bottom := Rect.Bottom + B;
  end;

begin
  {     }
  if soSnapToScreen in FOptions then
  begin
    {    }
    GetSnapRect(Rect, R);
    {    }
    DL := 0;
    DT := 0;
    DR := 0;
    DB := 0;
    { :   }
    if Side in [WMSZ_LEFT, WMSZ_BOTTOMLEFT, WMSZ_TOPLEFT] then
      if Abs(Rect.Left - R.Left) < FSnapSize then DL := R.Left - Rect.Left;
    { :   }
    if Side in [WMSZ_TOP, WMSZ_TOPLEFT, WMSZ_TOPRIGHT] then
      if Abs(Rect.Top - R.Top) < FSnapSize then DT := R.Top - Rect.Top;
    { :   }
    if Side in [WMSZ_RIGHT, WMSZ_TOPRIGHT, WMSZ_BOTTOMRIGHT] then
      if Abs(R.Right - Rect.Right) < FSnapSize then DR := R.Right - Rect.Right;
    { :   }
    if Side in [WMSZ_BOTTOM, WMSZ_BOTTOMLEFT, WMSZ_BOTTOMRIGHT] then
      if Abs(R.Bottom - Rect.Bottom) < FSnapSize then DB := R.Bottom - Rect.Bottom;
    {  }
    ResizeRect(Rect, DL, DT, DR, DB);
  end;
  {   }
  if Assigned(FOnSizing) then FOnSizing(Self, Side, Rect);
end;

procedure TFormSizer.GetSnapRect(Rect: TRect; var SnapRect: TRect);
begin
  {    }
  SystemParametersInfo(SPI_GETWORKAREA, 0, @SnapRect, 0);
  {   }
  if Assigned(FOnGetSnapRect) then FOnGetSnapRect(Self, Rect, SnapRect);
end;

procedure TFormSizer.Loaded;
begin
  if not (csDesigning in ComponentState) then
    if (Owner <> nil) and (Owner is TForm) and (FForm = nil) then
    begin
      FForm := TForm(Owner);
      FFormHook := CreateWndHook(FForm, 0, FormProc);
      UpdateFormBounds;
    end;
  inherited Loaded;
end;

function TFormSizer.ScreenHeight: Integer;
var
  R: TRect;
begin
  SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
  Result := R.Bottom - R.Top;
end;

function TFormSizer.ScreenWidth: Integer;
var
  R: TRect;
begin
  SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
  Result := R.Right - R.Left;
end;

{ TFormPlacement }

constructor TFormPlacement.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FOptions := [poOrigin, poSize, poState];
  FAutoPlace := True;
end;

destructor TFormPlacement.Destroy;
begin
  FreeWndHook(FFormHook);
  inherited Destroy;
end;

procedure TFormPlacement.FormProc(var Message: TMessage);

  function IsDestroyMsg: Boolean;
  begin
    Result := (Message.Msg = CM_RELEASE) or (Message.Msg = WM_DESTROY);
  end;

begin
  try
    {   }
    if AutoPlace and IsDestroyMsg then SaveToRegistry(FPlacementKey);
    {    }
    CallWndHook(FFormHook, Message);
  except
    Application.HandleException(Self);
  end;
end;

function TFormPlacement.GetFormPlacement: TPlacement;
var
  Placement: TWindowPlacement;
begin
  Placement.Length := SizeOf(TWindowPlacement);
  GetWindowPlacement(FForm.Handle, @Placement);
  with Placement.rcNormalPosition do
  begin
    Result.Left := Left;
    Result.Top := Top;
    Result.Width := Right - Left;
    Result.Height := Bottom - Top;
  end;
  Result.State := Ord(FForm.WindowState);
end;

procedure TFormPlacement.ReadOldKey(Reader: TReader);
begin
  FPlacementKey := Reader.ReadString;
end;

procedure TFormPlacement.SetFormPlacement(Value: TPlacement);
begin
  with Value do
  begin
    FForm.SetBounds(Left, Top, Width, Height);
    FForm.WindowState := TWindowState(State);
  end;
end;

procedure TFormPlacement.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  {     ,    PlacementKey
      Key  PlaceKey }
  Filer.DefineProperty('Key', ReadOldKey, nil, False);
  Filer.DefineProperty('PlaceKey', ReadOldKey, nil, False);
end;

procedure TFormPlacement.Loaded;
begin
  if not (csDesigning in ComponentState) then
    if (Owner <> nil) and (Owner is TForm) and (FForm = nil) then
    begin
      FForm := TForm(Owner);
      FFormHook := CreateWndHook(FForm, 0, FormProc);
      if AutoPlace then LoadFromRegistry(FPlacementKey);
    end;
  inherited Loaded;
end;

procedure TFormPlacement.LoadFromRegistry(const Key: string);
var
  IniKey: string;
  IniFile: TRegIniFile;
  Placement: TPlacement;
begin
  if FForm <> nil then
  begin
    {   }
    IniKey := Key;
    if IniKey = '' then IniKey := FPlacementKey;
    {   }
    IniFile := TRegIniFile.Create(IniKey);
    try
      {     }
      if Length(IniKey) > 0 then
      begin
        {     }
        Placement := GetFormPlacement;
        {  ,     }
        with Placement do
        begin
          if poOrigin in FOptions then
          begin
            Left := Inifile.ReadInteger('', 'Left', Left);
            Top := Inifile.ReadInteger('', 'Top', Top);
          end;
          if poSize in FOptions then
          begin
            Width := Inifile.ReadInteger('', 'Width', Width);
            Height := Inifile.ReadInteger('', 'Height', Height);
          end;
          if poState in FOptions then
            State := Inifile.ReadInteger('', 'State', State);
        end;
        {   }
        SetFormPlacement(Placement);
      end;
      {   }
      if Assigned(FOnLoad) then FOnLoad(Self, IniFile);
    finally
      Inifile.Free;
    end;
  end;
end;

procedure TFormPlacement.SaveToRegistry(const Key: string);
var
  IniKey: string;
  IniFile: TRegIniFile;
  Placement: TPlacement;
begin
  if FForm <> nil then
  begin
    {   }
    IniKey := Key;
    if IniKey = '' then IniKey := FPlacementKey;
    {   }
    IniFile := TRegIniFile.Create(IniKey);
    try
      {     }
      if Length(IniKey) > 0 then
      begin
        {     }
        Placement := GetFormPlacement;
        {  ,     }
        with Placement do
        begin
          if poOrigin in FOptions then
          begin
            IniFile.WriteInteger('', 'Left', Left);
            IniFile.WriteInteger('', 'Top', Top);
          end;
          if poSize in FOptions then
          begin
            IniFile.WriteInteger('', 'Width', Width);
            IniFile.WriteInteger('', 'Height', Height);
          end;
          if poState in FOptions then
            Inifile.WriteInteger('', 'State', State);
        end;
      end;
      {   }
      if Assigned(FOnSave) then FOnSave(Self, IniFile);
    finally
      IniFile.Free;
    end;
  end;
end;

{ TPreventer }

function NeedPrevent(Permission, Mode: TPreventOptions): Boolean;
begin
  Result := Permission * Mode = Mode;
end;

procedure TPreventer.SetOptions(Value: TPreventOptions);
begin
  if FOptions <> Value then
  begin
    FOptions := Value;
    if ComponentState * [csDesigning, csLoading] = [] then Prevent;
  end;
end;

procedure TPreventer.Loaded;
begin
  if not (csDesigning in ComponentState) then Prevent;
  inherited Loaded;
end;

procedure TPreventer.Prevent;
begin
end;

function TPreventer.PreventMenu(Menu: HMENU; Position, Flags: Integer): Boolean;
begin
  if FMode = pmHide then
    Result := DeleteMenu(Menu, Position, Flags)
  else
    Result := EnableMenuItem(Menu, Position, Flags or MF_DISABLED or MF_GRAYED);
end;

function TPreventer.PreventSeparator(Menu: HMENU; Index: Integer): Boolean;
var
  I: Integer;
  Info: TMenuItemInfo;
  Buffer: array[0..79] of Char;
begin
  I := 0;
  while I < GetMenuItemcount(Menu) do
  begin
    Fillchar(Info, SizeOf(Info), 0);
    Info.cbSize := 44; // Required for Windows 95
    Info.fMask := MIIM_TYPE;
    Info.dwTypeData := Buffer;
    Info.cch := SizeOf(Buffer);
    {     }
    if GetMenuItemInfo(Menu, I, True, Info) then
    begin
      if Info.fType = MFT_SEPARATOR then
      begin
        {    }
        if Index = 0 then
        begin
          {     }
          Result := DeleteMenu(Menu, I, MF_BYPOSITION);
          Exit;
        end;
        {    }
        Dec(Index);
      end;
    end;
    {   }
    Inc(I);
  end;
  {   }
  Result := False;
end;

{ TFormPreventer }

destructor TFormPreventer.Destroy;
begin
  FreeWndHook(FFormHook);
  inherited Destroy;
end;

procedure TFormPreventer.FormProc(var Message: TMessage);
const
  SizeHit = [HTLEFT, HTRIGHT, HTBOTTOM, HTTOP, HTTOPLEFT, HTTOPRIGHT,
    HTBOTTOMRIGHT, HTBOTTOMLEFT];
  PreventAll = [poMove, poResize, poMaximize, poMinimize];
  PreventDlg = [poDialogMinimize, poDialogResize];
var
  AllowExit: Boolean;
  SysMenu: HMENU;
  Style: Longint;
  FX, FY: Integer;
begin
  {   ,  CM_RELEASE }
  if not IsReleaseMsg(FFormHook, Message) then
  try
    {     }
    with Message do
      case Msg of
        WM_CLOSE:
          {   }
          if NeedPrevent(FOptions, [poClose]) then Exit;
        WM_QUERYENDSESSION:
          {  Windows }
          if NeedPrevent(FOptions, [poExitWindows]) then
          begin
            AllowExit := False;
            ExitWindows(AllowExit);
            if not AllowExit then Exit;
          end;
      end;
    {    }
    CallWndHook(FFormHook, Message);
    {       }
    if FForm <> nil then
      case Message.Msg of
        WM_INITMENUPOPUP:
          {    }
          begin
            {   }
            SysMenu := Message.wParam;
            {        }
            if (FForm.BorderStyle <> bsDialog) or (FOptions * PreventDlg <> []) then
            begin
              {   }
              if NeedPrevent(FOptions, [poMove]) then PreventMenu(SysMenu, SC_MOVE, MF_BYCOMMAND);
              if NeedPrevent(FOptions, [poResize]) then PreventMenu(SysMenu, SC_SIZE, MF_BYCOMMAND);
              if NeedPrevent(FOptions, [poMinimize]) then PreventMenu(SysMenu, SC_MINIMIZE, MF_BYCOMMAND);
              if NeedPrevent(FOptions, [poMaximize]) then PreventMenu(SysMenu, SC_MAXIMIZE, MF_BYCOMMAND);
              if NeedPrevent(FOptions, [poRestore]) or NeedPrevent(FOptions, [poMinimize, poMaximize]) then PreventMenu(SysMenu, SC_RESTORE, MF_BYCOMMAND);
              {   "" }
              if NeedPrevent(FOptions, [poClose]) then
                {       -  ,    }
                if (FMode = pmHide) and NeedPrevent(FOptions, PreventAll) then
                begin
                  PreventSeparator(SysMenu, 0);
                  DeleteMenu(SysMenu, SC_CLOSE, MF_BYCOMMAND)
                end
                else
                  EnableMenuItem(SysMenu, SC_CLOSE, MF_BYCOMMAND or MF_GRAYED);
            end
            else
            begin                                              
              {   }
              PreventSeparator(SysMenu, 0);
              DeleteMenu(SysMenu, SC_MAXIMIZE, MF_BYCOMMAND);
              DeleteMenu(SysMenu, SC_MINIMIZE, MF_BYCOMMAND);
              DeleteMenu(SysMenu, SC_SIZE, MF_BYCOMMAND);
              DeleteMenu(SysMenu, SC_RESTORE, MF_BYCOMMAND);
              {   }
              if NeedPrevent(FOptions, [poMove]) then PreventMenu(SysMenu, SC_MOVE, MF_BYCOMMAND);
              if NeedPrevent(FOptions, [poClose]) then PreventMenu(SysMenu, SC_CLOSE, MF_BYCOMMAND);
            end;
            {    "" }
            if FForm.Visible then
              if FForm.WindowState = wsNormal then
                EnableMenuItem(SysMenu, SC_RESTORE, MF_BYCOMMAND or MF_GRAYED)
              else
                EnableMenuItem(SysMenu, SC_RESTORE, MF_BYCOMMAND or MF_ENABLED);
            {         }
            InitSysMenu(SysMenu);
          end;
        WM_NCHITTEST:
          {    }
          with TWMNCHitTest(Message) do
          begin
            {   -  }
            if (Result = HTCAPTION) and NeedPrevent(FOptions, [poMove]) then Result := 0;
            if (Result in SizeHit) and NeedPrevent(FOptions, [poResize]) then Result := 0;
            if (Result = HTLEFT) and NeedPrevent(FOptions, [poResizeLeft]) then Result := 0;
            if (Result = HTRIGHT) and NeedPrevent(FOptions, [poResizeRight]) then Result := 0;
            if (Result = HTTOP) and NeedPrevent(FOptions, [poResizeTop]) then Result := 0;
            if (Result = HTTOPLEFT) and NeedPrevent(FOptions, [poResizeTopLeft]) then
            begin
              FX := GetSystemMetrics(SM_CXFRAME);
              FY := GetSystemMetrics(SM_CYFRAME);
              with FForm.BoundsRect do
                if (YPos >= Top) and (YPos <= Top + FY) then Result := HTTOP
                else if (XPos >= Left) and (XPos <= Left + FX) then Result := HTLEFT
                else Result := 0;
            end;
            if (Result = HTTOPRIGHT) and NeedPrevent(FOptions, [poResizeTopRight]) then
            begin
              FX := GetSystemMetrics(SM_CXFRAME);
              FY := GetSystemMetrics(SM_CYFRAME);
              with FForm.BoundsRect do
                if (YPos >= Top) and (YPos <= Top + FY) then Result := HTTOP
                else if (XPos >= Right - FX) and (XPos <= Right) then Result := HTRIGHT
                else Result := 0;
            end;
            if (Result = HTBOTTOM) and NeedPrevent(FOptions, [poResizeBottom]) then Result := 0;
            if (Result = HTBOTTOMLEFT) and NeedPrevent(FOptions, [poResizeBottomLeft]) then
            begin
              FX := GetSystemMetrics(SM_CXFRAME);
              FY := GetSystemMetrics(SM_CYFRAME);
              with FForm.BoundsRect do
                if (YPos >= Bottom - FY) and (YPos <= Bottom) then Result := HTBOTTOM
                else if (XPos >= Left + FX) and (XPos <= Left) then Result := HTLEFT
                else Result := 0;
            end;
            if (Result = HTBOTTOMRIGHT) and NeedPrevent(FOptions, [poResizeBottomRight]) then
            begin
              FX := GetSystemMetrics(SM_CXFRAME);
              FY := GetSystemMetrics(SM_CYFRAME);
              with FForm.BoundsRect do
                if (YPos >= Bottom - FY) and (YPos <= Bottom) then Result := HTBOTTOM
                else if (XPos >= Right - FX) and (XPos <= Right) then Result := HTRIGHT
                else Result := 0;
            end;
          end;
        WM_SIZE:
          {     [x]   MDI  }
          with Message do
            if (wParam = SIZE_MAXIMIZED) and (FForm.FormStyle = fsMDIChild) then
              {      }
              if NeedPrevent(FOptions, [poCloseButtonBug]) and (not NeedPrevent(FOptions, [poClose])) then
              begin
                Style := GetWindowLong(FForm.Handle, GWL_STYLE);
                SetWindowLong(FForm.Handle, GWL_STYLE, Style or WS_SYSMENU);
              end;
      end;
  except
    Application.HandleException(Self);
  end;
end;

procedure TFormPreventer.ExitWindows(var AllowExit: Boolean);
begin
  if Assigned(FOnExitWindows) then FOnExitWindows(Self, AllowExit);
end;

procedure TFormPreventer.InitSysMenu(SysMenu: HMENU);
begin
  if Assigned(FOnInitSysMenu) then FOnInitSysMenu(Self, SysMenu);
end;

procedure TFormPreventer.Loaded;
begin
  if not (csDesigning in ComponentState) then
    if (Owner <> nil) and (Owner is TForm) and (FForm = nil) then
    begin
      {    }
      FForm := TForm(Owner);
      FFormHook := CreateWndHook(FForm, 0, FormProc);
    end;
  inherited Loaded;
end;

procedure TFormPreventer.Prevent;
const
  PreventMenu = [poMove, poResize, poMaximize, poMinimize, poClose, poDialogMinimize];
  WinFlags = SWP_DRAWFRAME or SWP_FRAMECHANGED or SWP_NOMOVE or SWP_NOSIZE or
    SWP_NOZORDER or SWP_NOACTIVATE or SWP_NOSENDCHANGING;
var
  WinStyle: Longint;
  SysMenu: HMENU;
begin
  if (FForm <> nil) and Hookallocated(FFormHook) then
  begin
    {     }
    if FForm.BorderStyle = bsDialog then
    begin
      {      }
      if NeedPrevent(FOptions, [poDialogMinimize]) then
      begin
        WinStyle := GetWindowLong(FForm.Handle, GWL_STYLE);
        SetWindowLong(FForm.Handle, GWL_STYLE, WinStyle or WS_GROUP);
      end;
      {     }
      if NeedPrevent(FOptions, [poDialogResize]) then
      begin
        {    }
        WinStyle := GetWindowLong(FForm.Handle, GWL_STYLE);
        SetWindowLong(FForm.Handle, GWL_STYLE, WinStyle or WS_THICKFRAME);
        {   }
        with FForm do SetWindowPos(Handle, 0, Left, Top, Width, Height, WinFlags);
      end;
    end;
    {   }
    if FOptions * PreventMenu <> [] then
    begin
      {   }
      if FForm.FormStyle <> fsMDIChild then GetSystemMenu(FForm.Handle, True);
      {   }
      SysMenu := GetSystemMenu(FForm.Handle, False);
      SendMessage(FForm.Handle, WM_INITMENUPOPUP, SysMenu, MakeLong(0, 1));
    end;
  end;
end;

{ TAppPreventer }

destructor TAppPreventer.Destroy;
begin
  FreeWndHook(FAppHook);
  inherited Destroy;
end;

procedure TAppPreventer.AppProc(var Message: TMessage);
const
  PreventAll = [poMinimize];
var
  AllowExit: Boolean;
  AppMenu: HMENU;
begin
  try
    {     }
    with Message do
      case Msg of
        WM_QUERYENDSESSION:
          {  Windows }
          if NeedPrevent(FOptions, [poExitWindows]) then
          begin
            AllowExit := False;
            ExitWindows(AllowExit);
            if not AllowExit then Exit;
          end;
      end;
    {    }
    CallWndHook(FAppHook, Message);
    {   }
    case Message.Msg of
      WM_INITMENUPOPUP:
        {    }
        begin
          {    }
          AppMenu := Message.wParam;
          {  ,   Delphi }
          DeleteMenu(AppMenu, SC_MOVE, MF_BYCOMMAND);
          DeleteMenu(AppMenu, SC_SIZE, MF_BYCOMMAND);
          DeleteMenu(AppMenu, SC_MAXIMIZE, MF_BYCOMMAND);
          {   "" }
          if NeedPrevent(FOptions, [poClose]) then
            {       -  ,    }
            if (FMode = pmHide) and NeedPrevent(FOptions, PreventAll) then
            begin
              PreventSeparator(AppMenu, 0);
              DeleteMenu(AppMenu, SC_CLOSE, MF_BYCOMMAND)
            end
            else
              EnableMenuItem(AppMenu, SC_CLOSE, MF_BYCOMMAND or MF_GRAYED);
          {   "" }
          if NeedPrevent(FOptions, [poMinimize]) then
          begin
            PreventSeparator(AppMenu, 0);
            PreventMenu(AppMenu, SC_MINIMIZE, MF_BYCOMMAND);
            PreventMenu(AppMenu, SC_RESTORE, MF_BYCOMMAND);
          end;
          {      }
          InitAppMenu(AppMenu);
        end;
      end;
  except
    Application.HandleException(Self);
  end;
end;

procedure TAppPreventer.ExitWindows(var AllowExit: Boolean);
begin
  if Assigned(FOnExitWindows) then FOnExitWindows(Self, AllowExit);
end;

procedure TAppPreventer.InitAppMenu(AppMenu: HMENU);
begin
  if Assigned(FOnInitAppMenu) then FOnInitAppMenu(Self, AppMenu);
end;

procedure TAppPreventer.Loaded;
begin
  if not (csDesigning in ComponentState) and (not HookAllocated(FAppHook)) then
  begin
    {    }
    FAppHook := CreateAppHook(AppProc);
    {     }
    if NeedPrevent(FOptions, [poTaskBar]) then ShowWindow(Application.Handle, SW_HIDE);
  end;
  inherited Loaded;
end;

procedure TAppPreventer.Prevent;
const
  PreventMenu = [poMinimize, poClose];
var
  AppMenu: HMENU;
begin
  if HookAllocated(FAppHook) then
  begin
    {   }
    if FOptions * PreventMenu <> [] then
    begin
      {   }
      GetSystemMenu(Application.Handle, True);
      {   }
      AppMenu := GetSystemMenu(Application.Handle, False);
      SendMessage(Application.Handle, WM_INITMENUPOPUP, AppMenu, MakeLong(0, 1));
    end;
  end;
end;

{ TFormHook }

destructor TFormHook.Destroy;
begin
  FreeWndHook(FFormHook);
  inherited Destroy;
end;

procedure TFormHook.FormProc(var Message: TMessage);
var
  Handled: Boolean;
begin
  {   ,  CM_RELEASE }
  if not IsReleaseMsg(FFormHook, Message) then
  try
    Handled := False;
    {     }
    Enter(Message, Handled);
    {     -  }
    if (not Handled) or (Message.Msg = WM_DESTROY) then
    begin
      {    }
      CallWndHook(FFormHook, Message);
      {     }
      Exit(Message, Handled);
    end;
  except
    Application.HandleException(Self);
  end;
end;

procedure TFormHook.Enter(var Message: TMessage; var Handled: Boolean);
begin
  if Assigned(FOnEnter) then FOnEnter(Message, Handled);
end;

procedure TFormHook.Exit(var Message: TMessage; var Handled: Boolean);
begin
  if Assigned(FOnExit) then FOnExit(Message, Handled);
end;

procedure TFormHook.Loaded;
begin
  if not (csDesigning in ComponentState) then
    if (Owner <> nil) and (Owner is TForm) and (FForm = nil) then
    begin
      FForm := TForm(Owner);
      FFormHook := CreateWndHook(FForm, 0, FormProc);
    end;
  inherited Loaded;
end;

{ TFormEdge }

constructor TFormEdge.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FVisible := True;
end;

procedure TFormEdge.SetVisible(Value: Boolean);
begin
  if FVisible <> Value then
  begin
    FVisible := Value;
    UpdateEdge;
  end;
end;

procedure TFormEdge.UpdateEdge;
const
  Flags = SWP_DRAWFRAME or SWP_NOMOVE or SWP_NOSIZE or SWP_NOZORDER;
var
  Handle: THandle;
  ExStyle: Longint;
begin
  if not (csDesigning in ComponentState) and (Owner <> nil) and (Owner is TForm) then
  begin
    if TForm(Owner).FormStyle = fsMDIForm then
      Handle := TForm(Owner).ClientHandle
    else
      Handle := TForm(Owner).Handle;
    ExStyle := GetWindowLong(Handle, GWL_EXSTYLE);
    if Visible then
      SetWindowLong(Handle, GWL_EXSTYLE, ExStyle or WS_EX_CLIENTEDGE)
    else
      SetWindowLong(Handle, GWL_EXSTYLE, ExStyle and not WS_EX_CLIENTEDGE);
    SetWindowPos(Handle, 0, 0, 0, 0, 0, Flags);
  end;
end;

procedure TFormEdge.Loaded;
begin
  UpdateEdge;
  inherited Loaded;
end;

{ TAppHook }

destructor TAppHook.Destroy;
begin
  if (not (csDesigning in ComponentState)) and (ahEvents in FOptions) then
    {    }
    with Application do
    begin
      if Assigned(FOnAppException) then OnException := nil;
      if Assigned(FOnAppMessage) then OnMessage := nil;
      if Assigned(FOnAppIdle) then OnIdle := nil;
      if Assigned(FOnAppDeactivate) then OnDeactivate := nil;
      if Assigned(FOnAppActivate) then OnActivate := nil;
      if Assigned(FOnAppShowHint) then OnShowHint := nil;
      if Assigned(FOnAppMinimize) then OnMinimize := nil;
      if Assigned(FOnAppRestore) then OnRestore := nil;
    end;
  {   }
  FreeWndHook(FAppHook);
  inherited Destroy;
end;

procedure TAppHook.AppProc(var Message: TMessage);
var
  Handled: Boolean;
begin
  try
    Handled := False;
    {     }
    Enter(Message, Handled);
    {     -  }
    if (not Handled) or (Message.Msg = WM_DESTROY) then
    begin
      {    }
      CallWndHook(FAppHook, Message);
      {     }
      Exit(Message, Handled);
    end;
  except
    Application.HandleException(Self);
  end;
end;

procedure TAppHook.Enter(var Message: TMessage; var Handled: Boolean);
begin
  if Assigned(FOnEnter) then FOnEnter(Message, Handled);
end;

procedure TAppHook.Exit(var Message: TMessage; var Handled: Boolean);
begin
  if Assigned(FOnExit) then FOnExit(Message, Handled);
end;

procedure TAppHook.Loaded;
begin
  if not (csDesigning in ComponentState) then
  begin
    {   }
    if ahEvents in FOptions then
      with Application do
      begin
        if Assigned(FOnAppException) then OnException := FOnAppException;
        if Assigned(FOnAppMessage) then OnMessage := FOnAppMessage;
        if Assigned(FOnAppIdle) then OnIdle := FOnAppIdle;
        if Assigned(FOnAppDeactivate) then OnDeactivate := FOnAppDeactivate;
        if Assigned(FOnAppActivate) then OnActivate := FOnAppActivate;
        if Assigned(FOnAppShowHint) then OnShowHint := FOnAppShowHint;
        if Assigned(FOnAppMinimize) then OnMinimize := FOnAppMinimize;
        if Assigned(FOnAppRestore) then OnRestore := FOnAppRestore;
      end;
    {    }
    if (ahMessages in FOptions) and (not HookAllocated(FAppHook)) then
      FAppHook := CreateAppHook(AppProc);
  end;
  inherited Loaded;
end;

{ TAppInstance }

constructor TAppInstance.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FActive := True;
end;

destructor TAppInstance.Destroy;
begin
  SetActive(False);
  inherited Destroy;
end;

function TAppInstance.AppHook(var Message: TMessage): Boolean;
begin
  if Message.Msg <> FAppMessage then
  begin
    Result := False;
    Exit;
  end;
  Activate;
  Result := True;
end;

procedure TAppInstance.SetActive(Value: Boolean);
begin
  if FActive <> Value then
  begin
    FActive := Value;
    UpdateInstance;
  end;
end;

procedure TAppInstance.UpdateInstance;
var
  AppMutex: THandle;

  function AppIdent: string;
  const
    Prefix = 'APP_INSTANCE';
  begin
    Result := Format('%s (%s)', [Prefix, FAppName]);
  end;

begin
  {       }
  if [csDesigning, csLoading] * ComponentState = [] then
  begin
    {   }
    FAppMessage := RegisterWindowMessage(PChar(AppIdent));
    {    }
    if not Active then
    begin
      if FAppMutex <> 0 then
      begin
        CloseHandle(FAppMutex);
        FAppMutex := 0;
      end;
      Application.UnhookMainWindow(AppHook);
    end
    else
    begin
      AppMutex := CreateMutex(nil, False, PChar(AppIdent));
      { ,    }
      if GetLastError <> ERROR_ALREADY_EXISTS then
      begin
        {   -  }
        FAppMutex := AppMutex;
        {    }
        Application.HookMainWindow(AppHook);
      end
      else
      begin
        {  -   }
        CloseHandle(AppMutex);
        {    }
        ActivatePrev;
        {   }
        Halt;
      end;
    end;
  end;
end;

procedure TAppInstance.Activate;
begin
  {      -  }
  if Assigned(FOnActivate) then
  begin
    FOnActivate(Self);
    Exit;
  end;
  {     }
  with Application do
    {       }
    if (MainForm = nil) or MainForm.Visible then
    begin
      Restore;
      BringToFront;
    end;
end;

procedure TAppInstance.ActivatePrev;
var
  Recipients: DWORD;
begin
  Recipients := BSM_APPLICATIONS;
  BroadcastSystemMessage(BSF_IGNORECURRENTTASK or BSF_POSTMESSAGE, @Recipients, FAppMessage, 0, 0);
end;

procedure TAppInstance.Halt;
begin
  {      -  }
  if Assigned(FOnHalt) then
  begin
    FOnHalt(Self);
    Exit;
  end;
  {    }
  System.Halt($FFFF);
end;

procedure TAppInstance.Loaded;
begin
  inherited Loaded;
  UpdateInstance;
end;

{ TAppHelp }

constructor TAppHelp.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FOptions := [hoDefaultContains, hoIgnoreZeroID];
end;

destructor TAppHelp.Destroy;
begin
  Application.OnHelp := nil;
  inherited Destroy;
end;

function TAppHelp.AppHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;
begin
  if not FInHelp then
  begin
    FInHelp := True;
    try
      {    }
      if (Data < 0) and (hoDefaultContains in FOptions) then
      begin
        Application.HelpCommand(HELP_FINDER, Data);
        CallHelp := False;
        Result := True;
        Exit;
      end;
      {     }
      if (Data > 0) and (Command = HELP_CONTEXT) and (hoContextAsPopup in FOptions) then
      begin
        Application.HelpCommand(HELP_CONTEXTPOPUP, Data);
        CallHelp := False;
        Result := True;
        Exit;
      end;
      {     }
      if (Data > 0) and (Command = HELP_CONTEXTPOPUP) and (hoPopupAsContext in FOptions) then
      begin
        Application.HelpCommand(HELP_CONTEXT, Data);
        CallHelp := False;
        Result := True;
        Exit;
      end;
      {    }
      if Data = 0 then
      begin
        CallHelp := False;
        Result := True;
        Exit;
      end;
      {     -   }
      if Assigned(FOnHelp) then
      begin
        Result := FOnHelp(Command, Data, CallHelp); 
        Exit;
      end;
    finally
      FInHelp := False;
    end;
  end;
  Result := False;
end;

function TAppHelp.GetHelpFile: string;
const
  SHelpKey = 'SOFTWARE\Microsoft\Windows\Help';
  SHelpPath = '%s\%s';
var
  HelpPath: string;
begin
  {     }
  Result := Application.HelpFile;
  {     }
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    if OpenKey(SHelpKey, False) then
      if ValueExists(Result) then
      begin
        HelpPath := ReadString(Result);
        Result := Format(SHelpPath, [HelpPath, Result]);
      end;
  finally
    Free;
  end;
end;

procedure TAppHelp.Loaded;
begin
  if not (csDesigning in ComponentState) then
  begin
    {   }
    Application.HelpFile := GetHelpFile;
    {   }
    Application.OnHelp := AppHelp;
    Application.OnHint := OnHint;
  end;
  inherited Loaded;
end;

{ TSplitPanel }

constructor TSplitPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csCaptureMouse, csClickEvents, csDoubleClicks];
  Width := GetSystemMetrics(SM_CXFRAME);
  Height := 185;
  FIndent := 4;
end;

procedure TSplitPanel.CheckPosition(var X, Y: Integer);
begin
  if X < FLimits.Left then X := FLimits.Left;
  if X > FLimits.Right then X := FLimits.Right;
  if Y < FLimits.Top then Y := FLimits.Top;
  if Y > FLimits.Bottom then Y := FLimits.Bottom;
end;

function TSplitPanel.GetMode: TSplitMode;
begin
  Result := spUnknown;
  if HasParent and Assigned(Control) then
  begin
    if (Control.Align = alTop) and (Top > Control.Top) then Result := spTop
    else if (Control.Align = alBottom) and (Top < Control.Top) then Result := spBottom
    else if (Control.Align = alLeft) and (Left > Control.Left) then Result := spLeft
    else if (Control.Align = alRight) and (Left < Control.Left) then Result := spRight;
    if Align <> Control.Align then Result := spUnknown;
  end;
end;

function TSplitPanel.GetSplitRect: TRect;
var
  R: TRect;
  W, H: Integer;
begin
  {      }
  R := Parent.ClientRect;
  {   }
  W := R.Right - R.Left;
  H := R.Bottom - R.Top;
  {   }
  Result := R;
  {     }
  case FSplitMode of
    spLeft:
      with R do
      begin
        Result.Left := Left + Indent;
        if Min > 0 then Result.Left := Left + MinIntValue([W - Indent, Min]);
        Result.Right := Right - Width - Indent;
        if Max > 0 then Result.Right := Left + MinIntValue([W - Width - Indent, Max]);
      end;
    spRight:
      with R do
      begin
        Result.Left := Left + Indent;
        if Max > 0 then Result.Left := Right - MinIntValue([W - Indent, Max]);
        Result.Right := Right - Width - Indent;
        if Min > 0 then Result.Right := Right - MinIntValue([W - Width - Indent, Min]);
      end;
    spTop:
      with R do
      begin
        Result.Top := Top + Indent;
        if Min > 0 then Result.Top := Top + MinIntValue([H - Indent, Min]);
        Result.Bottom := Bottom - Height - Indent;
        if Max > 0 then Result.Bottom := Top + MinIntValue([H - Height - Indent, Max]);
      end;
    spBottom:
      with R do
      begin
        Result.Top := Top + Indent;
        if Max > 0 then Result.Top := Bottom - MinIntValue([H - Indent, Max]);
        Result.Bottom := Bottom - Height - Indent;
        if Min > 0 then Result.Bottom := Bottom - MinIntValue([H - Height - Indent, Min]);
      end;
  end;
end;

procedure TSplitPanel.SetBorderStyle(Value: TSplitBorderStyle);
begin
  if FBorderStyle <> Value then
  begin
    FBorderStyle := Value;
    Refresh;
  end;
end;

procedure TSplitPanel.SetControl(Value: TControl);
begin
  if (FControl <> Value) and (Value <> Self) then
  begin
    FControl := Value;
    case GetMode of
      spUnknown: Cursor := crDefault;
      spLeft, spRight: Cursor := crHSplit;
      spTop, spBottom: Cursor := crVSplit;
    end;
  end;
end;

procedure TSplitPanel.SetIndent(Value: Integer);
begin
  FIndent := MaxIntValue([0, MinIntValue([1024, Value])]);
end;

procedure TSplitPanel.ShowSplitRect(X, Y: Integer; Mode: TSplitInverseMode);
var
  P: TPoint;
  R: TRect;
  MaxRect: TRect;
  Horz: Boolean;
begin
  {     } 
  P := Point(0, 0);
  if FSplitMode in [spTop, spBottom] then
  begin
    P.Y := Y;
    Horz := True;
  end
  else
  begin
    P.X := X;
    Horz := False;
  end;
  P := ClientToScreen(P);
  {       }
  MaxRect := GetSplitRect;
  {   }
  with P, MaxRect do
  begin
    TopLeft := Parent.ClientToScreen(TopLeft);
    BottomRight := Parent.ClientToScreen(BottomRight);
    if X < Left then X := Left;
    if X > Right then X := Right;
    if Y < Top then Y := Top;
    if Y > Bottom then Y := Bottom;
  end;
  { ,    }
  if (Mode <> imMove) or ((P.X <> FPrevOrg.X) and (not Horz)) or ((P.Y <> FPrevOrg.Y) and Horz) then
  begin
    {    }
    if Mode in [imClear, imMove] then
    begin
      R := Rect(FPrevOrg.X, FPrevOrg.Y, FPrevOrg.X + Width, FPrevOrg.Y + Height);
      PaintResizeRect(0, R);
    end;
    {   }
    if Mode in [imNew, imMove] then
    begin
      R := Rect(P.X, P.Y, P.X + Width, P.Y + Height);
      PaintResizeRect(0, R);
      FPrevOrg := P;
    end;
  end;
end;

procedure TSplitPanel.StartSplit(X, Y: Integer);
var
  C: TRect;
begin
  FLimits := GetSplitRect;
  {    }
  with Parent do
  begin
    FLimits.TopLeft := ClientToScreen(FLimits.TopLeft);
    FLimits.BottomRight := ClientToScreen(FLimits.BottomRight); 
  end;
  {     }
  with Control do
  begin
    C.TopLeft := ClientToScreen(Point(0, 0));
    C.BottomRight := ClientToScreen(Point(Width, Height));
  end;
  {   }
  FSaveX := 0;
  FSaveY := 0;
  case FSplitMode of
    spLeft, spRight:
      with FLimits do
      begin
        FLimits.Top := C.Top + 1;
        FLimits.Bottom := C.Bottom - 1;
        FSaveX := X;
      end;
    spTop, spBottom:
      begin
        FLimits.Right := C.Right - 1;
        FLimits.Left := C.Left + 1;
        FSaveY := Y;
      end;
  end;
  {        }
  with FLimits do
  begin
    TopLeft := ScreenToClient(TopLeft);
    BottomRight := ScreenToClient(BottomRight);
  end;
  {   }
  ShowSplitRect(0, 0, imNew);
end;

procedure TSplitPanel.StepSplit(X, Y: Integer);
begin
  CheckPosition(X, Y);
  ShowSplitRect(X, Y, imMove);
end;

procedure TSplitPanel.StopSplit(X, Y: Integer);
const
  DecSize = 3;
var
  R: TRect;
  S: Integer;
begin
  {   }
  ShowSplitRect(0, 0, imClear);
  {    }
  CheckPosition(X, Y);
  {       }
  R := GetSplitRect;
  {    }
  if FSplitMode in [spLeft, spRight] then
  begin
    {    }
    S := Control.Width + X;
    if FSplitMode = spRight then S := Control.Width - X;
    {  }
    Control.Width := S;
  end
  else if FSplitMode in [spTop, spBottom] then
  begin
    {    }
    S := Control.Height + Y;
    if FSplitMode = spBottom then S := Control.Height - Y;
    {  }
    Control.Height := S;
  end
end;

procedure TSplitPanel.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if not (csDesigning in ComponentState) and (Button = mbLeft) then
  begin
    FSplitMode := GetMode;
    if FSplitMode <> spUnknown then
    begin
      SetCapture(Handle);
      StartSplit(X, Y);
      FSplitting := True;
    end;
  end;
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TSplitPanel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  if (GetCapture = Handle) and FSplitting then StepSplit(X - FSaveX, Y - FSaveY);
  inherited MouseMove(Shift, X, Y);
end;

procedure TSplitPanel.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if FSplitting then
  begin
    FSplitting := False;
    ReleaseCapture;
    StopSplit(X - FSaveX, Y - FSaveY);
    Split;
  end;
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TSplitPanel.Notification(AComponent: TComponent; AOperation: TOperation);
begin
  inherited Notification(AComponent, AOperation);
  if (AOperation = opRemove) and (AComponent = FControl) then SetControl(nil);
end;

procedure TSplitPanel.Paint;
var
  R: TRect;
begin
  with Canvas do
  begin
    Brush.Color := Color;
    case FBorderStyle of
      bsNone:
        begin
        end;
      bsRaised:
        begin
          if GetMode in [spTop, spBottom] then
            R := Rect(-2, 0, Width + 2, Height)
          else
            R := Rect(0, -2, Width, Height + 2);
          Windows.DrawEdge(Handle, R, EDGE_RAISED, BF_RECT or BF_MIDDLE);
        end;
      bsLowered:
        begin
          if GetMode in [spTop, spBottom] then
            R := Rect(-2, 0, Width + 2, Height)
          else
            R := Rect(0, -2, Width, Height + 2);
          DrawEdge(Handle, R, EDGE_SUNKEN, BF_RECT or BF_MIDDLE);
        end;
    end;
  end;
  inherited Paint;
end;

procedure TSplitPanel.Split;
begin
  if Assigned(FOnSplit) then FOnSplit(Self);
end;

{ TTimerThread }

constructor TTimerThread.Create(ATimer: TThreadedTimer);
begin
  FOwner := ATimer;
  inherited Create(False);
end;

procedure TTimerThread.DoSleep;
var
  I: Integer;
begin
  I := FInterval;
  {   }
  while I > 0 do
  begin
    {  }
    SleepEx(10, False);
    {   -   }
    if Terminated then Exit;
    {  }
    Dec(I);
  end;
end;

procedure TTimerThread.DoTimer;
begin
  if FOwner <> nil then FOwner.Timer;
end;

procedure TTimerThread.Execute;
begin
  {   }
  while True do
  try
    {  }
    DoSleep;
    {    -  }
    if Terminated then Break;
    {  -  }
    Synchronize(DoTimer);
  except
    Application.HandleException(Self);
  end;
end;

{ TThreadedTimer }

constructor TThreadedTimer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FEnabled := True;
  FInterval := 1000;
  FPriority := tpNormal;
end;

destructor TThreadedTimer.Destroy;
begin
  {   }
  FOnTimer := nil;
  FEnabled := False;
  {   }
  FThread.Free;
  {    }
  inherited Destroy;
end;

procedure TThreadedTimer.SetEnabled(Value: Boolean);
begin
  if FEnabled <> Value then
  begin
     FEnabled := Value;
     UpdateTimer;
  end;
end;

procedure TThreadedTimer.SetInterval(Value: DWORD);
begin
  if FInterval <> Value then
  begin
     FInterval := (Value div 10) * 10;
     UpdateTimer;
  end;
end;

procedure TThreadedTimer.SetOnTimer(Value: TNotifyEvent);
begin
  FOnTimer := Value;
  UpdateTimer;
end;

procedure TThreadedTimer.SetPriority(Value: TThreadPriority);
begin
  if FPriority <> Value then
  begin
     FPriority := Value;
     UpdateTimer;
  end;
end;

procedure TThreadedTimer.UpdateTimer;
begin
  if FThread <> nil then
  begin
    {   }
    if not FThread.Suspended then FThread.Suspend;
    {      }
    FThread.FInterval := FInterval div 10;
    FThread.Priority := FPriority;
    { ,   }
    if (FInterval > 0) and FEnabled and Assigned(FOnTimer) then FThread.Resume;
  end;
end;

procedure TThreadedTimer.Loaded;
begin
  if not (csDesigning in ComponentState) and (FThread = nil) then
  begin
    FThread := TTimerThread.Create(Self);
    UpdateTimer;
  end;
  inherited Loaded;
end;

procedure TThreadedTimer.Timer;
begin
  if (FInterval > 0) and FEnabled and not (csDestroying in ComponentState) then
  try
    if Assigned(FOnTimer) then FOnTimer(Self);
  except
    Application.HandleException(Self);
  end
end;

{ TTrayIcon }

const
  WM_TRAYICON = WM_USER + 1;

constructor TTrayIcon.Create(AOwner: Tcomponent);
begin
  inherited Create(AOwner);
  FHandle := AllocateHWnd(WndProc);
  FIcon := TIcon.Create;
  FIcon.OnChange := IconChange;
end;

destructor TTrayIcon.Destroy;
begin
  SetVisible(False);
  DeallocateHWnd(FHandle);
  FIcon.Free;
  inherited Destroy;
end;

procedure TTrayIcon.IconChange(Sender: TObject);
begin
  UpdateIcon;
end;

procedure TTrayIcon.SetIcon(Value: TIcon);
begin
  FIcon.Assign(Value);
end;

procedure TTrayIcon.SetIconID(Value: Integer);
begin
  if FIconID <> Value then
  begin
    FIconID := Value;
    UpdateIcon;
  end;
end;

procedure TTrayIcon.SetHint(Value: string);
begin
  if FHint <> Value then
  begin
    FHint := Value;
    UpdateIcon;
  end;
end;

procedure TTrayIcon.SetPopupMenu(Value: TPopupMenu);
begin
  FPopupMenu := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

procedure TTrayIcon.SetVisible(Value: Boolean);
begin
  if FVisible <> Value then
  begin
    FVisible := Value;
    if not (csDesigning in ComponentState) then
      if Value then
        Shell_NotifyIcon(NIM_ADD, @FData)
      else
        Shell_NotifyIcon(NIM_DELETE, @FData);
  end;
end;

procedure TTrayIcon.UpdateIcon;
begin
  if not (csDesigning in ComponentState) then
  begin
    FillChar(FData, SizeOf(TNotifyIconData), 0);
    with FData do
    begin
      cbSize := SizeOf(TNotifyIconData);
      Wnd := FHandle;
      uID := FIconID;
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
      hIcon := FIcon.Handle;
      if Length(FHint) <> 0 then StrPLCopy(szTip, GetShortHint(FHint), SizeOf(szTip) - 1);
      uCallbackMessage := WM_TRAYICON;
    end;
    if Visible then Shell_NotifyIcon(NIM_MODIFY, @FData);
  end;
end;

procedure TTrayIcon.WndProc(var Message: TMessage);
begin
  with Message do
    if (Msg = WM_TRAYICON) and (wParam = FIconID) then
      case lParam of
        WM_LBUTTONUP: Click;
        WM_LBUTTONDBLCLK: DblClick;
        WM_RBUTTONUP: Popup;
      end
    else
      Result := DefWindowProc(FHandle, Msg, wParam, lParam);
end;

function TTrayIcon.AllowPopup: Boolean;
begin
  Result := True;
  if Assigned(FOnPopup) then FOnPopup(Self, Result);
end;

procedure TTrayIcon.Click;
begin
  if Assigned(FOnClick) then FOnClick(Self);
end;

procedure TTrayIcon.DblClick;
begin
  if Assigned(FOnDblClick) then FOnDblClick(Self);
end;

procedure TTrayIcon.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (AComponent = PopupMenu) and (Operation = opRemove) then PopupMenu := nil;
end;

procedure TTrayIcon.Popup;
var
  P: TPoint;
begin
  if (PopupMenu <> nil) and PopupMenu.AutoPopup and AllowPopup then
  begin
    GetCursorPos(P);
    SetForegroundWindow(FHandle);
    PopupMenu.PopupComponent := Self;
    PopupMenu.Popup(P.X, P.Y);
  end;
end;

{ TCheckList }

constructor TCheckList.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Style := lbOwnerDrawFixed;
  ItemHeight := 17;
  FStateList := Tlist.Create;
  FBitmap := TBitmap.Create;
  FBitmap.LoadFromResourceName(HInstance, 'BM_CHECK');
  FBitmap95 := TBitmap.Create;
  FBitmap95.LoadFromResourceName(HInstance, 'BM_CHECK95');
  FBitmap3D := TBitmap.Create;
  FBitmap3D.LoadFromResourceName(HInstance, 'BM_CHECK3D');
  FCheck95 := True;
  FCheckVisible := True;
  FImagesLink := TChangeLink.Create;
  FImagesLink.OnChange := ImagesChange;
end;

destructor TCheckList.Destroy;
begin
  ClearStateList;
  FImagesLink.Free;
  FBitmap3D.Free;
  FBitmap95.Free;
  FBitmap.Free;
  FStateList.Free;
  inherited Destroy;
end;

procedure TCheckList.ClearStateList;
var
  I: Integer;
begin
  I := FStateList.Count;
  while I > 0 do
  begin
    Dec(I);
    TCheckState(FStateList[I]).Free;
  end;
  FStateList.Clear;
end;

procedure TCheckList.ImagesChange(Sender: TObject);
begin
  Invalidate;
end;

procedure TCheckList.InvalidateCheck(Index: Integer);
var
  R: TRect;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    R := GetCheckRect(Index);
    InvalidateRect(Handle, @R, False);
  end;
end;

procedure TCheckList.InvalidateImage(Index: Integer);
var
  R: TRect;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    R := GetImageRect(Index);
    InvalidateRect(Handle, @R, False);
  end;
end;

procedure TCheckList.InvalidateItem(Index: Integer);
var
  R: TRect;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    R := ItemRect(Index);
    InvalidateRect(Handle, @R, False);
  end;
end;

function TCheckList.GetChecked(Index: Integer): Boolean;
begin
  Result := False;
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    Result := TCheckState(Items.Objects[Index]).Checked;
  end;
end;

function TCheckList.GetCheckRect(Index: Integer): TRect;
begin
  {    }
  Result := ItemRect(Index);
  {    }
  Result.Right := Result.Left + 16;
end;

function TCheckList.GetColor(Index: Integer): TColor;
begin
  Result := Color;
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    Result := TCheckState(Items.Objects[Index]).Color;
  end;
end;

function TCheckList.GetImageIndex(Index: Integer): Integer;
begin
  Result := -1;
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    Result := TCheckState(Items.Objects[Index]).ImageIndex;
  end;
end;

function TCheckList.GetImageRect(Index: Integer): TRect;
begin
  {    }
  Result := ItemRect(Index);
  {   }
  Result.Left := Result.Left + 16 + 3;
  Result.Right := Result.Left + 16;
  {    }
  if Assigned(Images) then Result.Right := Result.Right + (Images.Width - 16);
end;

function TCheckList.GetState(Index: Integer): TCheckBoxState;
begin
  Result := cbUnchecked;
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    Result := TCheckState(Items.Objects[Index]).State;
  end;
end;

procedure TCheckList.SetCheck3D(Value: Boolean);
begin
  if FCheck3D <> Value then
  begin
    FCheck3D := Value;
    Invalidate;
  end;
end;

procedure TCheckList.SetCheck95(Value: Boolean);
begin
  if FCheck95 <> Value then
  begin
    FCheck95 := Value;
    Invalidate;
  end;
end;

procedure TCheckList.SetCheckVisible(Value: Boolean);
begin
  if FCheckVisible <> Value then
  begin
    FCheckVisible := Value;
    Invalidate;
  end;
end;

procedure TCheckList.SetChecked(Index: Integer; Value: Boolean);
const
  States: array[Boolean] of TCheckBoxState = (cbUnchecked, cbchecked);
begin
  SetState(Index, States[Value]);
end;

procedure TCheckList.SetColor(Index: Integer; Value: TColor);
var
  State: TCheckState;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    State := TCheckState(Items.Objects[Index]);
    if State.Color <> Value then
    begin
      State.Color := Value;
      InvalidateItem(Index);
    end;
  end;
end;

procedure TCheckList.SetImageIndex(Index: Integer; Value: Integer);
var
  State: TCheckState;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    State := TCheckState(Items.Objects[Index]);
    if State.ImageIndex <> Value then
    begin
      State.ImageIndex := Value;
      InvalidateImage(Index);
    end;
  end;
end;

procedure TCheckList.SetImages(Value: TImageList);
begin
  if FImages <> Value then
  begin
    if Assigned(FImages) then FImages.UnRegisterChanges(FImagesLink);
    FImages := Value;
    if Assigned(FImages) then
    begin
      FImages.RegisterChanges(FImagesLink);
      ItemHeight := FImages.Height + 2;
    end;
    Invalidate;
  end;
end;

procedure TCheckList.SetHideSelection(Value: Boolean);
begin
  if FHideSelection <> Value then
  begin
    FHideSelection := Value;
    Invalidate;
  end;
end;

procedure TCheckList.SetState(Index: Integer; Value: TCheckBoxState);
var
  State: TCheckState;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    {    }
    ValidateIndex(Index);
    {    }
    State := TCheckState(Items.Objects[Index]);
    {    }
    if State.State <> Value then
      {    }
      if Assigned(FOnChecking) then FOnChecking(Self, Index, Value);
    {     }
    if State.State <> Value then
    begin
      {   }
      State.State := Value;
      case Value of
        cbChecked: State.Checked := True;
        cbGrayed: State.Checked := True;
        cbUnchecked: State.Checked := False;
      end;
      {   }
      if FCheckVisible then InvalidateCheck(Index);
      {     }
      if Assigned(FOnChecked) then FOnChecked(Self, Index, Value);
    end;
  end;
end;

procedure TCheckList.ValidateIndex(Index: Integer);
var
  State: TCheckState;
begin
  {      }
  if (Index >= 0) and (Index < Items.Count) and (Items.Objects[Index] = nil) then
  begin
    {     }
    State := TCheckState.Create;
    State.Color := Color;
    {     }
    FStateList.Count := Items.Count;
    FStateList[Index] := State;
    {      }
    Items.Objects[Index] := State;
  end;
end;

procedure TCheckList.CNDrawItem(var Message: TWMDrawItem);
var
  State: TOwnerDrawState;
begin
  with Message.DrawItemStruct^ do
  begin
{$IFDEF EX_D5_UP}
    State := TOwnerDrawState(LongRec(itemState).Lo);
{$ELSE}
    State := TOwnerDrawState(WordRec(LongRec(itemState).Lo).Lo);
{$ENDIF}
    Canvas.Handle := hDC;
    Canvas.Font := Font;
    Canvas.Brush := Brush;
    if Integer(itemID) >= 0 then
      DrawItem(itemID, rcItem, State)
    else
      Canvas.FillRect(rcItem);
    Canvas.Handle := 0;
  end;
end;

procedure TCheckList.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  B: TBitmap;
  R, C: TRect;
  I, X, Y: Integer;
begin
  with Canvas do
  begin
    {      }
    if not (odSelected in State) then
      Brush.Color := Colors[Index]
    else if Focused then
    begin
      Brush.Color := clHighlight;
      Font.Color := clHighlightText;
    end
    else if not HideSelection then
    begin
      Brush.Color := clBtnFace;
      Font.Color := Self.Font.Color;
    end;
    {   }
    FillRect(Rect);
    {   }
    if FCheckVisible then
    begin
      {    }
      if not Check3D then
        if not Check95 then
          B := FBitmap
        else
          B := FBitmap95
      else
        B := FBitmap3D;
      {    }
      case Self.State[Index] of
        cbUnchecked: C := Classes.Rect(0, 0, 16, 16);
        cbChecked: C := Classes.Rect(16, 0, 32, 16);
        cbGrayed: C := Classes.Rect(32, 0, 48, 16);
      end;
      {     }
      R := Classes.Rect(Rect.Left, Rect.Top, Rect.Left + 16, Rect.Top + 16);
      {   }
      BrushCopy(R, B, C, clFuchsia);
      {    }
      Rect.Left := Rect.Left + 16;
    end;
    {   }
    X := 5;
    Y := (ItemHeight - TextHeight('A')) div 2;
    {    }
    if Assigned(Images) then
    begin
      I := GetImageIndex(Index);
      {  }
      if I <> -1 then
      begin
        {    }
        R.Left := Rect.Left + 3;
        R.Top := Rect.Top + 1;
        R.Right := R.Left + Images.Width;
        R.Bottom := Rect.Bottom;
        {   }
        Images.DrawingStyle := dsNormal;
        Images.Draw(Canvas, R.Right - Images.Width, R.Top, I);
        {    }
        Rect.Left := Rect.Left + Images.Width + 3;
        {   }
        X := 2;
      end;
    end;
    {   }
    TextRect(Rect, Rect.Left + X, Rect.Top + Y, Items[Index]);
  end;
end;

procedure TCheckList.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (ItemIndex <> -1) and (Key = VK_SPACE) then
  begin
    case State[ItemIndex] of
      cbUnchecked: State[ItemIndex] := cbChecked;
      cbChecked: State[ItemIndex] := cbUnchecked;
      cbGrayed: State[ItemIndex] := cbUnchecked;
    end;
    InvalidateCheck(ItemIndex);
  end;
  inherited;
end;

procedure TCheckList.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FImages) then Images := nil;
end;

procedure TCheckList.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Index: Integer;
  Rect: TRect;
begin
  if (Button = mbLeft) then
  begin
    Index := ItemAtPos(Point(X, Y), True);
    if Index <> -1 then
    begin
      Rect := GetCheckRect(Index);
      if (X >= Rect.Left) and (X < Rect.Right) then
      begin
        case State[Index] of
          cbUnchecked: State[ItemIndex] := cbChecked;
          cbChecked: State[Index] := cbUnchecked;
          cbGrayed: State[Index] := cbUnchecked;
        end;
        InvalidateCheck(Index);
      end;
    end;
  end;
  inherited;
end;

constructor TCheckTree.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FImages := TImageList.Create(Self);
  FImages.ResourceLoad(rtBitmap, 'BM_CHECK', clFuchsia);
  FImages95 := TImageList.Create(Self);
  FImages95.ResourceLoad(rtBitmap, 'BM_CHECK95', clFuchsia);
  FImages3D := TImageList.Create(Self);
  FImages3D.ResourceLoad(rtBitmap, 'BM_CHECK3D', clFuchsia);
  FCheck95 := True;
  Images := FImages95;
end;

destructor TCheckTree.Destroy;
begin
  FImages3D.Free;
  FImages95.Free;
  FImages.Free;
  inherited Destroy;
end;

function TCheckTree.GetChecked(Node: TTreeNode): Boolean;
begin
  Result:= False;
  if Node <> nil then
    case Node.ImageIndex of
      0: Result := False;
      1: Result := True;
      2: Result := True;
    end;
end;

function TCheckTree.GetState(Node: TTreeNode): TCheckBoxState;
begin
  Result := cbUnchecked;
  if Node <> nil then
    case Node.ImageIndex of
      0: Result := cbUnchecked;
      1: Result := cbChecked;
      2: Result := cbGrayed;
    end;
end;

procedure TCheckTree.SetCheck3D(Value: Boolean);
begin
  if FCheck3D <> Value then
  begin
    FCheck3D := Value;
    if not Value then
      if not Check95 then
        Images := FImages
      else
        Images := FImages95
    else
      Images := FImages3D;
    Invalidate;
  end;
end;

procedure TCheckTree.SetCheck95(Value: Boolean);
begin
  if FCheck95 <> Value then
  begin
    FCheck95 := Value;
    if not Check3D then
      if not Value then
        Images := FImages
      else
        Images := FImages95
    else
      Images := FImages3D;
    Invalidate;
  end;
end;

procedure TCheckTree.SetChecked(Node: TTreeNode; Value: Boolean);
const
  States: array[Boolean] of TCheckBoxState = (cbUnchecked, cbchecked);
begin
  SetState(Node, States[Value]);
end;

procedure TCheckTree.SetState(Node: TTreeNode; Value: TCheckBoxState);
begin
  if not ReadOnly then
    if Node = nil then
    begin
      Node := Items.GetFirstNode;
      while Node <> nil do
      begin
        SetState(Node, Value);
        Node := Node.GetNextSibling;
      end;
    end
    else
    begin
      case Value of
        cbUnchecked: ApplyImage(Node, 0);
        cbChecked: ApplyImage(Node, 1);
        cbGrayed: ApplyImage(Node, 2);
      end;
      CheckParent(Node.Parent);
      CheckChildren(Node);
    end;
end;

procedure TCheckTree.ApplyImage(Node: TTreeNode; ImageIndex: Integer);
var
  Rect: TRect;
begin
  if (Node <> nil) and (Node.ImageIndex <> ImageIndex) then
  begin
    Node.ImageIndex := ImageIndex;
    Node.SelectedIndex := ImageIndex;
    if Node.IsVisible then
    begin
      Rect := Node.DisplayRect(False);
      InvalidateRect(Handle, @Rect, True);
    end;
  end;
end;

procedure TCheckTree.CheckChildren(Node: TTreeNode);
var
  I: Integer;
  Child: TTreeNode;
begin
  if (Node <> nil) and CheckChild then
  begin
    I := Node.ImageIndex;
    if (I = 0) or (I = 1) then
    begin
      Child := Node.GetFirstChild;
      while Child <> nil do
      begin
        ApplyImage(Child, I);
        CheckChildren(Child);
        Child := Node.GetNextChild(Child);
      end;
    end;
  end;
end;

procedure TCheckTree.CheckParent(Parent: TTreeNode);
var
  C, U: Integer;
  Node: TTreeNode;
begin
  if Parent <> nil then
  begin
    C := 0;
    U := 0;
    Node := Parent.GetFirstChild;
    while Node <> nil do
    begin
      if Node.ImageIndex > 0 then Inc(C) else Inc(U);
      if (C <> 0) and (U <> 0) and (C <> U) then Break;
      Node := Parent.GetNextChild(Node);
    end;
    if (C = 0) and (U = Parent.Count) then ApplyImage(Parent, 0)
    else if (C = Parent.Count) and (U = 0) then ApplyImage(Parent, 1)
    else ApplyImage(Parent, 2);
    CheckParent(Parent.Parent);
  end;
end;

procedure TCheckTree.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (Selected <> nil) and (Key = VK_SPACE) and (Shift = []) then
  begin
    Checked[Selected] := not Checked[Selected];
    Key := 0;
  end;
  inherited;
end;

procedure TCheckTree.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Node: TTreeNode;
  Rect: TRect;
begin
  if (Button = mbLeft) and (Shift = [ssLeft]) then
  begin
    Node := GetNodeAt(X, Y);
    if Node <> nil then
    begin
      Rect := Node.DisplayRect(True);
      if (X >= Rect.Left - 17) and (X <= Rect.Left - 5) then
      begin
        case State[Node] of
          cbUnchecked: State[Node] := cbChecked;
          cbChecked: State[Node] := cbUnchecked;
          cbGrayed: State[Node] := cbUnchecked;
        end;
      end;
    end;
  end;
  inherited;
end;

{ TIconBox }

constructor TIconBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  {    }
  FLargeIcons := TImageList.Create(nil);
  FLargeIcons.Width := 32;
  FLargeIcons.Height := 32;
  {    }
  FSmallIcons := TImageList.Create(nil);
  FSmallIcons.Width := 16;
  FSmallIcons.Height := 16;
  {     }
  FIconSize := isLarge;
  FAutoSize := True;
  {     }
  Style := lbOwnerDrawFixed;
  UpdateListBox;
  UpdateBounds;
end;

destructor TIconBox.Destroy;
begin
  {   }
  FSmallIcons.Free;
  FLargeIcons.Free;
  {    }
  inherited Destroy;
end;

procedure TIconBox.CreateList;
var
  I, Count: Integer;
  LargeIcon, SmallIcon: HICON;
begin
  {    }
  Count := ExtractIcon(hInstance, PChar(FIconFile), $FFFFFFFF);
  {   }
  for I := 0 to Count - 1 do
  begin
    {   }
    ExtractIconEx(PChar(FIconFile), I, LargeIcon, SmallIcon, 1);
    {   }
    ImageList_AddIcon(FLargeIcons.Handle, LargeIcon);
    ImageList_AddIcon(FSmallIcons.Handle, SmallIcon);
    {     }
    Items.Add('');
  end;
  IconIndex := 0;
end;

procedure TIconBox.FreeList;
begin
  {   }
  Items.Clear;
  {   }
  FLargeIcons.Clear;
  FSmallIcons.Clear;
end;

function TIconBox.GetBitmap: HBITMAP;
begin
  {   }
  Result := 0;
  {   }
  case FIconSize of
    isLarge: Result := FLargeIcons.GetImageBitmap;
    isSmall: Result := FSmallIcons.GetImageBitmap;
  end;
end;

function TIconBox.GetIcon(Index: Integer): HICON;
begin
  {   }
  Result := 0;
  {   }
  case FIconSize of
    isLarge: Result := ImageList_GetIcon(FLargeIcons.Handle, Index, ILD_NORMAL);
    isSmall: Result := ImageList_GetIcon(FSmallIcons.Handle, Index, ILD_NORMAL);
  end;
end;

function TIconBox.GetIconCount: Integer;
begin
  Result := Items.Count;
end;

function TIconBox.GetIconIndex: Integer;
begin
  Result := ItemIndex;
end;

function TIconBox.GetIconPath: string;
begin
  Result := ExpandIconPath(IconFile, IconIndex);
end;

procedure TIconBox.SetAutoSize(Value: Boolean);
begin
  if FAutoSize <> Value then
  begin
    FAutoSize := Value;
    UpdateListBox;
    UpdateBounds;
  end;
end;

procedure TIconBox.SetIconIndex(Value: Integer);
begin
  if ItemIndex <> Value then
  begin
    ItemIndex := Value;
    Change;
  end;
end;

procedure TIconBox.SetIconFile(Value: string);
begin
  if CompareText(FIconFile, Value) <> 0 then
  begin
    FIconFile := Value;
    UpdateIcons;
    Change;
  end;
end;

procedure TIconBox.SetIconPath(Value: string);
begin
  SetIconFile(ExtractIconFile(Value));
  SetIconIndex(ExtractIconIndex(Value));
end;

procedure TIconBox.SetIconSize(Value: TIconSize);
begin
  if FIconSize <> Value then
  begin
    FIconSize := Value;
    UpdateIcons;
    UpdateListBox;
    Change;
  end;
end;

procedure TIconBox.SetHideSelection(Value: Boolean);
begin
  if FHideSelection <> Value then
  begin
    FHideSelection := Value;
    Invalidate;
  end;
end;

procedure TIconBox.UpdateListBox;
begin
  case FIconSize of
    isLarge: ItemHeight := GetSystemMetrics(SM_CYICON) + 6;
    isSmall: ItemHeight := GetSystemMetrics(SM_CYSMICON) + 4;
  end;
  Columns := Width div ItemHeight - 1;
end;

procedure TIconBox.UpdateBounds;
begin
  if FAutoSize then
    case FIconSize of
      isLarge: Height := ItemHeight + GetSystemMetrics(SM_CYHSCROLL) + 1;
      isSmall: Height := ItemHeight + GetSystemMetrics(SM_CYHSCROLL) + 1;
    end;
end;

procedure TIconBox.CNDrawItem(var Message: TWMDrawItem);
var
  State: TOwnerDrawState;
begin
  with Message.DrawItemStruct^ do
  begin
{$IFDEF EX_D5_UP}
    State := TOwnerDrawState(LongRec(itemState).Lo);
{$ELSE}
    State := TOwnerDrawState(WordRec(LongRec(itemState).Lo).Lo);
{$ENDIF}
    Canvas.Handle := hDC;
    Canvas.Font := Font;
    Canvas.Brush := Brush;
    if Integer(itemID) >= 0 then
      DrawItem(itemID, rcItem, State)
    else
      Canvas.FillRect(rcItem);
    Canvas.Handle := 0;
  end;
end;

procedure TIconBox.Change;
begin
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TIconBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or LBS_DISABLENOSCROLL;
end;

procedure TIconBox.CreateWnd;
begin
  inherited CreateWnd;
  CreateList;
end;

procedure TIconBox.DestroyWnd;
begin
  FreeList;
  inherited DestroyWnd;
end;

procedure TIconBox.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  X, Y, W, H: Integer;
begin
  with Canvas do
  begin
    {   }
    if not (odSelected in State) then Brush.Color := Color
    else if Focused then Brush.Color := clHighlight
    else if not HideSelection then Brush.Color := clBtnFace;
    {   }
    FillRect(Rect);
  end;
  {    }
  if FIconSize = isLarge then
  begin
    W := GetSystemMetrics(SM_CXICON);
    H := GetSystemMetrics(SM_CYICON);
  end
  else
  begin
    W := GetSystemMetrics(SM_CXSMICON);
    H := GetSystemMetrics(SM_CYSMICON);
  end;
  {    }
  with Rect do
  begin
    X := Left + (Right - Left - W) div 2 + 1;
    Y := Top + (Bottom - Top - H) div 2;
  end;
  {   }
  case FIconSize of
    isLarge: FLargeIcons.Draw(Canvas, X, Y, Index);
    isSmall: FSmallIcons.Draw(Canvas, X, Y, Index);
  end;
end;

procedure TIconBox.MeasureItem(Index: Integer; var Height: Integer);
begin
  Height := GetSystemMetrics(SM_CYICON);
end;

procedure TIconBox.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
  UpdateListBox;
end;

procedure TIconBox.UpdateIcons;
begin
  FreeList;
  CreateList;
end;

{ TRecentFileList }

{$IFDEF EX_D3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}
  SRecentFileItemHint = '  ';

constructor TRecentFileList.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FFileList := TStringList.Create;
  FMaxFiles := 5;
  FAutoSave := True;
end;

destructor TRecentFileList.Destroy;
begin
  if AutoSave then SaveToRegistry(FFilesKey);
  Clear;
  FFileList.Free;
  FFileList := nil;
  inherited Destroy;
end;

procedure TRecentFileList.MenuItemClick(Sender: TObject);
var
  I: Integer;
  Item: TMenuItem;
begin
  if Assigned(FOnSelectFile) then
    {     }
    for I := 0 to FFileList.Count - 1 do
    begin
      {   ,    }
      Item := TMenuItem(FFileList.Objects[I]);
      if Item = Sender then
      begin
        FOnSelectFile(Self, FFileList[I]);
        Exit;
      end;
    end;  
end;

function TRecentFileList.GetFile(Index: Integer): string;
begin
  Result := FFileList[Index];
end;

function TRecentFileList.GetFileCount: Integer;
begin
  Result := FFileList.Count;
end;

procedure TRecentFileList.ReadOldKey(Reader: TReader);
begin
  FFilesKey := Reader.ReadString;
end;

procedure TRecentFileList.SetMaxFiles(Value: Integer);
var
  I: Integer;
begin
  if (Value >= 0) and (FMaxFiles <> Value) then
  begin
    FMaxFiles := Value;
    {   }
    I := FFileList.Count;
    while I > Value do
    begin
      Dec(I);
      FFileList.Delete(I);
    end;
    {   }
    UpdateMenuItems;
  end;
end;

procedure TRecentFileList.SetSubMenu(Value: Boolean);
begin
  if FSubMenu <> Value then
  begin
    FSubMenu := Value;
    UpdateMenuItems;
  end;
end;

procedure TRecentFileList.UpdateMenuItems;
var
  I, Index: Integer;
  Menu, MenuItem: TMenuItem;

  function NewFileItem: TMenuItem;
  begin
    Result := TMenuItem.Create(nil);
    Result.Tag := Integer(Self);
    Result.OnClick := MenuItemClick;
  end;

  function NewPrefix(Index: Integer): string;
  begin
    if Index < 10 then
      Result := Format('&%d', [Index])
    else
      Result := Format('&%s', [Char(Ord('A') + Index - 10)]);
  end;

begin
  if not (csDesigning in ComponentState) and (FMenuItem <> nil) then
  begin 
    {      }
    Menu := FMenuItem.Parent;
    if FSubMenu and (FMenuItem.Caption <> '-') then Menu := FMenuItem;
    {     }
    if Menu <> nil then
    begin
      Index := -2;
      {     }
      I := Menu.Count;
      while I > 0 do
      begin
        Dec(I);
        MenuItem := Menu[I];
        if MenuItem.Tag = Integer(Self) then
        begin
          MenuItem.Free;
          Index := I;
        end;
      end;
      {      -    }
      if Index = -2 then Index := Menu.IndexOf(FMenuItem);
      if Index = -1 then Index := Menu.Count;
      {   -  }
      if FFileList.Count > 0 then
      begin
        {   }
        for I := 0 to FFileList.Count - 1 do
        begin
          {   }
          MenuItem := NewFileItem;
          MenuItem.Caption := Format('%s %s', [NewPrefix(I + 1), FFileList[I]]);
          MenuItem.Hint := SRecentFileItemHint;
          Menu.Insert(Index + I, MenuItem);
          {   }
          FFileList.Objects[I] := MenuItem;
        end;
        {      }
        if Index + FFileList.Count < Menu.Count then
        begin
          MenuItem := Menu[Index + FFileList.Count];
          if MenuItem.Caption <> '-' then
          begin
            MenuItem := NewFileItem;
            MenuItem.Caption := '-';
            MenuItem.Hint := ' ';
            Menu.Insert(Index + FFileList.Count, MenuItem);
          end;
        end;
        {      }
        if Index > 0 then
        begin
          MenuItem := Menu[Index - 1];
          if MenuItem.Caption <> '-' then
          begin
            MenuItem := NewFileItem;
            MenuItem.Caption := '-';
            MenuItem.Hint := ' ';
            Menu.Insert(Index, MenuItem);
          end;
        end;
      end;
    end;
  end;
end;

procedure TRecentFileList.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  {     ,    FilesKey
      ListKey }
  Filer.DefineProperty('ListKey', ReadOldKey, nil, False);
end;

procedure TRecentFileList.Loaded;
begin
  if AutoSave then LoadfromRegistry(FFilesKey);
  inherited Loaded;
end;

procedure TRecentFileList.Notification(AComponent: TComponent; Operation: TOperation);
var
  I: Integer;
  MenuItem: TMenuItem;
begin
  inherited Notification(AComponent, Operation);
  {     }
  if Operation = opRemove then
  begin
    {    }
    if AComponent = FMenuItem then FMenuItem := nil;
    {     }
    if FFileList <> nil then
      for I := FFileList.Count - 1 downto 0 do
      begin
        MenuItem := TMenuItem(FFileList.Objects[I]);
        if MenuItem = AComponent then FFileList.Objects[I] := nil;
      end;
  end;
end;

procedure TRecentFileList.Add(const FileName: string);
var
  Index: Integer;
begin
  if Length(FileName) > 0 then
  begin
    {      }
    Index := IndexOf(FileName);
    {      ,      }
    if Index <> 0 then
    begin
      {      (   ) }
      Remove(FileName);
      { ,        }
      while FFileList.Count >= FMaxFiles do Delete(FMaxFiles - 1);
      {         -  }
      if IndexOf(FileName) = -1 then
      begin
        FFileList.Insert(0, FileName);
        UpdateMenuItems;
      end;
    end;
  end;
end;

procedure TRecentFileList.Clear;
begin
  FFileList.Clear;
  UpdateMenuItems;
end;

procedure TRecentFileList.Delete(Index: Integer);
begin
  {    }
  if (Index >= 0) and (Index < FFileList.Count) then
  begin
    FFileList.Delete(Index);
    UpdateMenuItems;
  end;
end;

function TRecentFileList.IndexOf(const FileName: string): Integer;
begin
  Result := FFileList.IndexOf(FileName);
end;

procedure TRecentFileList.LoadFromRegistry(const Key: string);
var
  IniKey: string;
  IniFile: TRegIniFile;
  I, Count: Integer;
  FileIdent, FileName: string;
begin
  if not (csDesigning in ComponentState) then
  begin
    {   }
    IniKey := Key;
    if IniKey = '' then IniKey := FFilesKey;
    {   }
    IniFile := TRegIniFile.Create(IniKey);
    try
      {     }
      if Length(IniKey) > 0 then
      begin
        {   }
        Clear;
        {    }
        Count := IniFile.ReadInteger('', 'RecentCount', 0);
        {   }
        if Count > FMaxFiles then Count := FMaxFiles;
        {    }
        for I := 0 to Count - 1 do
        begin
          FileIdent := Format('RecentFile%d', [I]);
          FileName := IniFile.ReadString('', FileIdent, '');
          if Length(FileName) > 0 then FFileList.Add(FileName);
        end;
        {   }
        UpdateMenuItems;
      end;
    finally
      Inifile.Free;
    end;
  end;
end;

procedure TRecentFileList.SaveToRegistry(const Key: string);
var
  IniKey: string;
  IniFile: TRegIniFile;
  I: Integer;
  FileIdent: string;
begin
  if not (csDesigning in ComponentState) then
  begin
    {   }
    IniKey := Key;
    if IniKey = '' then IniKey := FFilesKey;
    {   }
    IniFile := TRegIniFile.Create(IniKey);
    try
      {     }
      if Length(IniKey) > 0 then
      begin
        {    }
        IniFile.WriteInteger('', 'RecentCount', FFileList.Count);
        {    }
        for I := 0 to FFileList.Count - 1 do
        begin
          FileIdent := Format('RecentFile%d', [I]);
          IniFile.WriteString('', FileIdent, FFileList[I]);
        end;
      end;
    finally
      IniFile.Free;
    end;
  end;
end;

procedure TRecentFileList.Remove(const FileName: string);
begin
  Delete(IndexOf(FileName));
end;

{ TButtonListBox }

procedure TButtonListBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    Style := Style or WS_BORDER;
    ExStyle := WS_EX_TOOLWINDOW or WS_EX_TOPMOST;
    WindowClass.Style := CS_SAVEBITS;
  end;
end;

procedure TButtonListBox.CreateWnd;
begin
  inherited CreateWnd;
  Windows.SetParent(Handle, 0);
  CallWindowProc(DefWndProc, Handle, WM_SETFOCUS, 0, 0);
end;

procedure TButtonListBox.Keypress(var Key: Char);
var
  TickCount: Integer;
begin
  case Key of
    #8, #27: FSearchText := '';
    #32..#255:
      begin
        TickCount := GetTickCount;
        if TickCount - FSearchTime > 2000 then FSearchText := '';
        FSearchTime := TickCount;
        if Length(FSearchText) < 32 then FSearchText := FSearchText + Key;
        SendMessage(Handle, LB_SELECTSTRING, WORD(-1), Longint(PChar(FSearchText)));
        Key := #0;
      end;
  end;
  inherited Keypress(Key);
end;

procedure TButtonListBox.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
  TListButton(Owner).CloseUp((X >= 0) and (Y >= 0) and (X < Width) and (Y < Height));
end;

{ TListButton }

constructor TListButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := GetSystemMetrics(SM_CXVSCROLL);
  Height := GetSystemMetrics(SM_CYHSCROLL);
  FStyle := bsPickList;
  FAlignment := baRight;
  FDropDownCount := 8;
end;

procedure TListButton.ListMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then CloseUp(PtInRect(FList.ClientRect, Point(X, Y)));
end;

procedure TListButton.RestoreActiveControl;
var
  F: TForm;
begin
  {     }
  if FControl <> nil then
  begin
    {   }
    F := TForm(GetParentForm(Self));
    {    }
    if (F <> nil) and F.ContainsControl(FControl) then F.ActiveControl := FControl;
    {   }
    FControl := nil;
  end;
end;

procedure TListButton.SaveActiveControl;
var
  F: TForm;
begin
  {   }
  F := TForm(GetParentForm(Self));
  {  }
  if F = nil then
  begin
    FControl := nil;
    Exit;
  end;
  {    }
  FControl := F.ActiveControl;
end;

procedure TListButton.SetStyle(Value: TListButtonStyle);
begin
  if FStyle <> Value then
  begin
    FStyle := Value;
    Repaint;
  end;
end;

procedure TListButton.StartTracking(X, Y: Integer);
begin
  MouseCapture := True;
  FTracking := True;
  StepTracking(X, Y);
end;

procedure TListButton.StepTracking(X, Y: Integer);
var
  R: TRect;
  Pressed: Boolean;
begin
  R := ClientRect;
  Pressed := PtInRect(R, Point(X, Y));
  if FPressed <> Pressed then
  begin
    FPressed := Pressed;
    InvalidateRect(Handle, @R, False);
  end;
end;

procedure TListButton.StopTracking;
begin
  if FTracking then
  begin
    StepTracking(-1, -1);
    FTracking := False;
    MouseCapture := False;
  end;
end;

procedure TListButton.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS + DLGC_WANTCHARS;
end;

procedure TListButton.WMCancelMode(var Message: TMessage);
begin
  StopTracking;
  inherited;
end;

procedure TListButton.WMKillFocus(var Message: TMessage);
begin
  inherited;
  CloseUp(False);
end;

procedure TListButton.WMEraseBkgnd(var Message: TWmEraseBkgnd);
begin
end;

procedure TListButton.WMWindowPosChanged(var Message: TWMWindowPosChanged);
begin
  inherited;
  Invalidate;
end;

procedure TListButton.CMCancelMode(var Message: TCMCancelMode);
begin
  if (Message.Sender <> Self) and (Message.Sender <> FList) then CloseUp(False);
end;

procedure TListButton.CMEnabledChanged(var Message: TMessage); 
begin
  inherited;
  Invalidate;
end;

procedure TListButton.GetList;
begin
  with FList do
  begin
    Items.Clear;
    if Assigned(FOnGetList) then FOnGetList(Self, Items);
  end;
end;

procedure TListButton.GetListBounds;
var
  R: TRect;
begin
  with FList do
  begin
    R := BoundsRect;
    if Assigned(FOnGetListBounds) then FOnGetListBounds(Self, R);
    BoundsRect := R;
  end;
end;

procedure TListButton.GetText;
var
  Text: string;
begin
  if Assigned(FOnGetText) then
  begin
    Text := '';
    FOnGetText(Self, Text);
    SendMessage(FList.Handle, LB_SELECTSTRING, WORD(-1), Longint(PChar(Text)));
  end;
end;

procedure TListButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    if FListVisible then
      CloseUp(False)
    else
    begin
      StartTracking(X, Y);
      if Style = bsPickList then DropDown;
    end;
  end;
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TListButton.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  ListPos: TPoint;
  MousePos: TSmallPoint;
begin
  if FTracking then
  begin
    StepTracking(X, Y);
    if FListVisible then
    begin
      ListPos := FList.ScreenToClient(ClientToScreen(Point(X, Y)));
      if PtInRect(FList.ClientRect, ListPos) then
      begin
        StopTracking;
        MousePos := PointToSmallPoint(ListPos);
        SendMessage(FList.Handle, WM_LBUTTONDOWN, 0, Integer(MousePos));
        Exit;
      end;
    end;
  end;
  inherited MouseMove(Shift, X, Y);
end;

procedure TListButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  SPressed: Boolean;
begin
  SPressed := FPressed;
  StopTracking;
  if (Button = mbLeft) and (Style = bsEllipsis) and SPressed then Press;
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TListButton.Paint;
var
  R: TRect;
  DC: HDC;
  Flags: Integer;
begin
  {   }
  SetRect(R, 0, 0, Width, Height);
  DC := Canvas.Handle;
  Flags := 0;
  {   }
  if Style = bsPickList then
  begin
    {   }
    if Pressed then Flags := DFCS_FLAT or DFCS_PUSHED;
    if (not (csDesigning in ComponentState)) and (not Enabled) then Flags := Flags or DFCS_INACTIVE;	
    DrawFrameControl(DC, R, DFC_SCROLL, Flags or DFCS_SCROLLCOMBOBOX);
  end
  else
  begin
    {    }
    if FPressed then Flags := BF_FLAT;
    DrawEdge(DC, R, EDGE_RAISED, BF_RECT or BF_MIDDLE or Flags);
    Flags := ((R.Right - R.Left) shr 1) - 1 + Ord(FPressed);
    PatBlt(DC, R.Left + Flags, R.Top + Flags, 2, 2, BLACKNESS);
    PatBlt(DC, R.Left + Flags - 3, R.Top + Flags, 2, 2, BLACKNESS);
    PatBlt(DC, R.Left + Flags + 3, R.Top + Flags, 2, 2, BLACKNESS);
  end;
end;

procedure TListButton.Press;
begin
  if Assigned(FOnPress) then FOnPress(Self);
end;

procedure TListButton.SetText;
var
  S: string;
begin
  with FList do
    if ItemIndex <> -1 then
    begin
      S := Items[ItemIndex];
      if Assigned(FOnSetText) then FOnSetText(Self, S);
    end;
end;

procedure TListButton.WndProc(var Message: TMessage);

  procedure DoDropDownKeys(var Key: Word; Shift: TShiftState);
  begin
    case Key of
      VK_RETURN, VK_ESCAPE:
        if FListVisible and not (ssAlt in Shift) then
        begin
          CloseUp(Key = VK_RETURN);
          Key := 0;
        end;
    end;
  end;

begin
  case Message.Msg of
    WM_KEYDOWN,
    WM_SYSKEYDOWN,
    WM_CHAR:
      if Style = bsPickList then
        with TWMKey(Message) do
        begin
          DoDropDownKeys(CharCode, KeyDataToShiftState(KeyData));
          if (CharCode <> 0) and FListVisible then
          begin
            with TMessage(Message) do SendMessage(FList.Handle, Msg, WParam, LParam);
            Exit;
          end;
        end
  end;
  inherited;
end;

procedure TListButton.CloseUp(Accept: Boolean);
const
  Flags = SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_HIDEWINDOW;
begin
  if FListVisible then
  begin
    if GetCapture <> 0 then SendMessage(GetCapture, WM_CANCELMODE, 0, 0);
    {   }
    SetWindowPos(FList.Handle, 0, 0, 0, 0, 0, Flags);
    FListVisible := False;
    Invalidate;
    {    }
    if Accept then SetText;
    {   }
    RestoreActiveControl;
  end;
end;

procedure TListButton.DropDown;
const
  Flags = SWP_NOSIZE or SWP_NOACTIVATE or SWP_SHOWWINDOW;
var
  I, X, W: Integer;
begin
  if not (csDesigning in ComponentState) then
  begin
    {    }
    if Style = bsEllipsis then
    begin
      Press;
      Exit;
    end;
    {    }
    if (Style = bsPickList) and (not FListVisible) then
    begin
      {   }
      if FList = nil then
      begin
        FList := TButtonListBox.Create(Self);
        FList.Parent := Self;
        FList.Visible := False;
        FList.IntegralHeight := True;
        FList.Font := Font;
        FList.OnMouseUp := ListMouseUp;
      end;
      {   }
      GetList;
      GetText;
      {   }
      with FList do
      begin
        Canvas.Font := Font;
        {     }
        if Items.Count > 0 then
        begin
          W := 0;
          for I := 0 to Items.Count - 1 do
          begin
            X := Canvas.TextWidth(Items[I]);
            if W < X then W := X;
          end;
          ClientWidth := W + 6;
        end
        else
          ClientWidth := 100;
        {   }
        if (FDropDownCount < 1) or (Items.Count = 0) then
          ClientHeight := ItemHeight
        else if Items.Count < FDropDownCount then
          ClientHeight := Items.Count * ItemHeight
        else
          ClientHeight := FDropDownCount * ItemHeight;
        {  }
        Left := Self.ClientOrigin.X;
        case FAlignment of
          baCenter: Left := Left - (Width - Self.Width) div 2;
          baRight: Left := Left - (Width - Self.Width);
        end;
        Top := Self.ClientOrigin.Y + Self.Height;
        {       }
        GetListBounds;
      end;
      {   }
      SaveActiveControl;
      {   }
      SetWindowPos(FList.Handle, HWND_TOP, FList.Left, FList.Top, 0, 0, Flags);
      FListVisible := True;
      Invalidate;
      {     }
      Windows.SetFocus(Handle);
    end;
  end;
end;

{ TButtonStyler }

constructor TButtonStyler.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FHorzAlignment := haLeftJustify;
  FVertAlignment := vaCenterJustify;
  FTextAlignment := taRightJustify;
end;

procedure TButtonStyler.SetFlatButton(Value: Boolean);
begin
  if FFlatButton <> Value then
  begin
    FFlatButton := Value;
    UpdateButton;
  end;
end;

procedure TButtonStyler.SetHorzAlignment(Value: THorzAlignment);
begin
  if FHorzAlignment <> Value then
  begin
    FHorzAlignment := Value;
    UpdateButton;
  end;
end;

procedure TButtonStyler.SetPushLike(Value: Boolean);
begin
  if FPushLike <> Value then
  begin
    FPushLike := Value;
    UpdateButton;
  end;
end;

procedure TButtonStyler.SetTextAlignment(Value: TLeftRight);
begin
  if FTextAlignment <> Value then
  begin
    FTextAlignment := Value;
    UpdateButton;
  end;
end;

procedure TButtonStyler.SetVertAlignment(Value: TVertAlignment);
begin
  if FVertAlignment <> Value then
  begin
    FVertAlignment := Value;
    UpdateButton;
  end;
end;

procedure TButtonStyler.SetWordWrap(Value: Boolean);
begin
  if FWordWrap <> Value then
  begin
    FWordWrap := Value;
    UpdateButton;
  end;
end;

procedure TButtonStyler.CMCtl3DChanged(var Message: TMessage);
begin
  inherited;
  UpdateButton;
end;

procedure TButtonStyler.Loaded;
begin
  inherited Loaded;
  UpdateButton;
end;

procedure TButtonStyler.Notification(AComponent: TComponent; AOperation: TOperation);
begin
  inherited Notification(AComponent, AOperation);
  if (AOperation = opRemove) and (AComponent = FButton) then FButton := nil;
end;

procedure TButtonStyler.UpdateButton;
const
  WrapFlags: array[Boolean] of LongInt = (0, BS_MULTILINE);
  HorzFlags: array[THorzAlignment] of LongInt = (BS_LEFT, BS_CENTER, BS_RIGHT);
  VertFlags: array[TVertAlignment] of LongInt = (BS_TOP, BS_VCENTER, BS_BOTTOM);
  TextFlags: array[TLeftRight] of LongInt = (BS_LEFTTEXT, 0);
  FlatFlags: array[Boolean] of LongInt = (0, BS_FLAT);
  PushFlags: array[Boolean] of LongInt = (0, BS_PUSHLIKE);
  AllFlags = BS_MULTILINE or BS_LEFT or BS_CENTER or BS_RIGHT or BS_TOP or
    BS_VCENTER or BS_BOTTOM or BS_LEFTTEXT or BS_FLAT or BS_PUSHLIKE;
var
  Style: Longint;
begin
  if (not (csDesigning in ComponentState)) and (FButton <> nil) then
  begin
    {    }
    Style := GetWindowLong(FButton.Handle, GWL_STYLE);
    {    }
    Style := Style and not AllFlags;
    {   }
    Style := Style or WrapFlags[FWordWrap];
    Style := Style or HorzFlags[FHorzAlignment];
    Style := Style or VertFlags[FVertAlignment];
    Style := Style or TextFlags[FTextAlignment];
    Style := Style or FlatFlags[FFlatButton];
    Style := Style or PushFlags[FPushLike];
    {   }
    SetWindowLong(FButton.Handle, GWL_STYLE, Style);
  end;
end;

{ TUpDownBox }

constructor TUpDownBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := GetSystemMetrics(SM_CXHSCROLL) - 1;
  Height := GetSystemMetrics(SM_CYHSCROLL);
  TabStop := False;
  ControlStyle := [csDoubleClicks];
  FPosition := 0;
  FMin := 0;
  FMax := 100;
  FIncrement := 1;
  FAutoSize := True;
end;

procedure TUpDownBox.ReadIncriment(Reader: TReader);
begin
  FIncrement := Reader.ReadInteger;
end;

procedure TUpDownBox.SetAssociate(Value: TWinControl);
begin
  if (Value <> Self) and (FAssociate <> Value) then
  begin
    FAssociate := Value;
    if FAutoSize then UpdateControlPos;
  end;
end;

procedure TUpDownBox.SetAutoSize(Value: Boolean);
begin
  if FAutoSize <> Value then
  begin
    FAutoSize := Value;
    if Value then UpdateControlPos;
  end;
end;

procedure TUpDownBox.SetMax(Value: Integer);
begin
  SetParams(FPosition, FMin, Value);
end;

procedure TUpDownBox.SetMin(Value: Integer);
begin
  SetParams(FPosition, Value, FMax);
end;

procedure TUpDownBox.SetPosition(Value: Integer);
begin
  SetParams(Value, FMin, FMax);
end;

procedure TUpDownBox.UpdateControlPos;
var
  B: TRect;
begin
  if FAssociate <> nil then
  begin
    {     }
    B := FAssociate.ClientRect;
    {      }
    B.TopLeft := FAssociate.ClientToScreen(B.TopLeft);
    B.BottomRight := FAssociate.ClientToScreen(B.BottomRight);
    {     }
    B.TopLeft := Parent.ScreenToClient(B.TopLeft);
    B.BottomRight := Parent.ScreenToClient(B.BottomRight);
    {    }
    B.Left := B.Right - Width;
    {  }
    BoundsRect := B;
  end;
end;

procedure TUpDownBox.UpdateScrollWnd;
begin
  if HandleAllocated then
  begin
    SetScrollRange(Handle, SB_CTL, FMin, FMax, False);
    SetScrollPos(Handle, SB_CTL, FPosition, True)
  end;
end;

type
  THackControl = class(TWinControl);

procedure TUpDownBox.CNVScroll(var Message: TWMVScroll);
var
  CurPos: Integer;
begin
  {   }
  try
    CurPos := StrToInt(THackControl(FAssociate).Text);
  except
    CurPos := Position;
  end;
  {  }
  case Message.ScrollCode of
    SB_LINELEFT: Position := CurPos + FIncrement;
    SB_LINERIGHT: Position := CurPos - FIncrement;
  end;
end;

procedure TUpDownBox.Change;
begin
  {   }
  if FAssociate <> nil then THackControl(FAssociate).Text := IntToStr(FPosition);
  {   }
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TUpDownBox.Changing(var Position: Integer);
begin
  if Assigned(FOnchanging) then FOnChanging(Self, Position);
end;

procedure TUpDownBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  CreateSubClass(Params, 'SCROLLBAR');
  Params.Style := Params.Style or SBS_VERT;
end;

procedure TUpDownBox.CreateWnd;
begin
  inherited CreateWnd;
  UpdateScrollWnd;
end;

procedure TUpDownBox.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  {     ,     
     Incriment  Increment }
  Filer.DefineProperty('Incriment', ReadIncriment, nil, False);
end;

procedure TUpDownBox.Notification(AComponent: TComponent; AOperation: TOperation);
begin
  inherited Notification(AComponent, AOperation);
  if (AOperation = opRemove) and (AComponent = FAssociate) then FAssociate := nil;
end;

procedure TUpDownBox.SetParams(APosition, AMin, AMax: Integer);

  procedure UpdatePosition;
  begin
    if APosition > FMax then APosition := FMax;
    if APosition < FMin then APosition := FMin;
  end;

begin
  {    }
  if AMax < AMin then AMax := AMin;
  {   }
  UpdatePosition;
  {    }
  if APosition <> FPosition then
  begin
    {   }
    Changing(APosition);                  
    {   }
    UpdatePosition;
  end;
  {     }
  if (FPosition <> APosition) or (FMin <> AMin) or (FMax <> AMax) then
  begin
    {    }
    FMin := AMin;
    FMax := AMax;
    FPosition := APosition;
    {   }
    UpdateScrollWnd;
    {   }
    SetPosition(FPosition);
    {  }
    Change;
  end;
end;

{ TFileChangeThread }

type
  TFileChangeThread = class (TThread)
  private
    FLogView: TLogView;
    FTerminateEvent: THandle;
  public
    constructor Create(LogView: TLogView);
    destructor Destroy; override;
    procedure Execute; override;
  end;

constructor TFileChangeThread.Create(LogView: TLogView);
begin
  inherited Create(True);
  FLogView := LogView;
  FTerminateEvent := CreateEvent(nil, True, False, nil);
end;

destructor TFileChangeThread.Destroy;
begin
  SetEvent(FTerminateEvent);
  inherited Destroy;
  CloseHandle(FTerminateEvent);
end;

procedure TFileChangeThread.Execute;
const
  Filter = FILE_NOTIFY_CHANGE_FILE_NAME or FILE_NOTIFY_CHANGE_SIZE;
var
  ChangeDir: string;
  ChangeHandle: THandle;
  OldFileSize, NewFileSize: Integer;
  OldFileAge, NewFileAge: Integer;
  WaitHandles: array[0..1] of THandle;
  WaitResult: Longint;
begin
  {   }
  ChangeDir := ExtractFileDir(FLogView.FFileName);
  ChangeHandle := FindFirstChangeNotification(PChar(ChangeDir), False, Filter);
  {   }
  if ChangeHandle = INVALID_HANDLE_VALUE then
  begin
    PostMessage(FLogView.Handle, WM_FILECHANGED, 0, GetLastError);
    Exit;
  end;
  {      }
  OldFileSize := FileSize(FLogView.FFileName);
  OldFileAge := FileAge(FLogView.FFileName);
  {    }
  WaitHandles[0] := FTerminateEvent;
  WaitHandles[1] := ChangeHandle;
  {   }
  while not Terminated do
  begin
    {   }
    WaitResult := WaitForMultipleObjects(2, @WaitHandles, False, INFINITE);
    {      }
    if WaitResult = WAIT_OBJECT_0 then Break;
    {        }
    if WaitResult = WAIT_OBJECT_0 + 1 then
    begin
      NewFileSize := FileSize(FLogView.FFileName);
      NewFileAge := FileAge(FLogView.FFileName);
      {    }
      if (OldFileSize <> NewFileSize) or (OldFileAge <> NewFileAge) then
      begin
        OldFileSize := NewFileSize;
        OldFileAge := NewFileAge;
        {   }
        PostMessage(FLogView.Handle, WM_FILECHANGED, 0, 0);
      end;
      {    }
      FindNextChangeNotification(ChangeHandle);
    end;
    {  }
    Sleep(50);
  end;
  {    }
  FindCloseChangeNotification(ChangeHandle);
end;

{ TLogView }

constructor TLogView.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ScrollBars := ssBoth;
  HideScrollBars := False;
  PlainText := True;
  ReadOnly := True;
  WordWrap := False;
  FUpdateSpeed := usPause;
  FAutoScroll := True;
  FTimer := TTimer.Create(nil);
  FTimer.Enabled := False;
  FTimer.Interval := 0;
  FTimer.OnTimer := UpdateTime;
end;

destructor TLogView.Destroy;
begin
  FFileChangeThread.Free;
  FTimer.Free;
  inherited Destroy;
end;

procedure TLogView.SetFileName(Value: string);
begin
  if FFileName <> Value then
  begin
    {   }
    SetUpdateSpeed(usPause);
    {       }
    FFileName := Value;
    UpdateContents(True);
  end;
end;

procedure TLogView.SetUpdateSpeed(Value: TLogUpdateSpeed);
begin
  if FUpdateSpeed <> Value then
  begin
    FUpdateSpeed := Value;
    {      }
    if csDesigning in ComponentState then Exit;
    {    }
    if FUpdateSpeed = usAuto then
    begin
      {   }
      FTimer.Enabled := False;
      FTimer.Interval := 0;
      FFileChangeThread := TFileChangeThread.Create(Self);
      FFileChangeThread.Resume;
    end
    else
    begin
      {    }
      FFileChangeThread.Free;
      FFileChangeThread := nil;
      FTimerFileSize := FileSize(FFileName);
      FTimerFileAge := FileAge(FFileName);
      case FUpdateSpeed of
        usHigh: FTimer.Interval := 500;
        usMedium: FTimer.Interval := 2000;
        usLow: FTimer.Interval := 5000;
        usPause: FTimer.Interval := 0;
      end;
      FTimer.Enabled := True;
    end;
  end;
end;

procedure TLogView.UpdateTime(Sender: TObject);
var
  NewFileSize: Integer;
  NewFileAge: Integer;
begin
  FTimer.Enabled := False;
  try
    {      }
    NewFileSize := FileSize(FFileName);
    NewFileAge := FileAge(FFileName);
    {   - }
    if (NewFileSize <> FTimerFileSize) or (NewFileAge <> FTimerFileAge) then
    begin
      FTimerFileSize := NewFileSize;
      FTimerFileAge := NewFileAge;
      {   }
      UpdateContents(False);
    end;
  finally
    FTimer.Enabled := True;
  end;
end;

procedure TLogView.WMFileChanged(var Message: TMessage); 
begin
  {   }
  if Message.lParam <> 0 then
  begin
    FFileViewPos := 0;
    Lines.Clear;
    {  }
    FFileError := Message.lParam;
    if Assigned(FOnInitViewError) then FOnInitViewError(Self, Message.lParam);
    Exit;
  end;
  {   }
  UpdateContents(False);
end;

procedure TLogView.CopyToClipboard;
begin
  Perform(WM_COPY, 0, 0);
end;

procedure TLogView.SelectAll;
begin
  Perform(EM_SETSEL, 0, -1);
end;


procedure TLogView.UpdateContents(ReloadFile: Boolean);
var
  S: string;
  L, SS, R1, C1, F1, R2, C2, F2: Integer;
  T: TStringList;
  SI: TScrollInfo;

  function PrepareText(var S: string): Integer;
  var
    I: Integer;
  begin
    Result := Length(S);
    {   ,      }
    while (Result > 0) and (not (S[Result] in [#13, #10])) do Dec(Result);
    {      }
    while (Result > 0) and (S[Result] in [#13, #10]) do Dec(Result);
    {     }
    SetLength(S, Result);
    {    (  ) }
    for I := 1 to Result do
      if (S[I] < ' ') and (not (S[I] in [#13, #10] )) then S[I] := ' ';
    {      }
    with TStringList.Create do
    try
      Text := S;
      for I := 0 to Count - 1 do Strings[I] := TrimRight(Strings[I]);
      S := Text;
    finally
      Free;
    end;
  end;

begin
  try
    {   }
    with TFileStream.Create(FFileName, fmOpenRead or fmShareDenyNone) do
    try
      Lines.BeginUpdate;
      try
        {     }
        if FFileError <> 0 then
        begin
          {   }
          FFileError := 0;
          {   }
          FFileViewPos := 0;
          Lines.Clear;
          {   }
          ReloadFile := True;
        end;
        {    }
        SS := SelStart;
        F1 := Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
        {    -    }
        if (FFileViewPos >= Size) or ReloadFile then
        begin
          {   }
          L := Size;
          {   }
          SetString(S, nil, L);
          Read(Pointer(S)^, L);
          {  ,   }
          L := PrepareText(S);
          {   }
          Perform(EM_SETSEL, 0, -1);
          Perform(EM_REPLACESEL, 0, LongInt(PChar(S)));
          {    }
          FFileViewPos := L;
        end
        {    -      }
        else if FFileViewPos < Size then
        begin
          Position := FFileViewPos;
          {   }
          L := Size - FFileViewPos;
          {   }
          SetString(S, nil, L);
          Read(Pointer(S)^, L);
          {  ,   }
          L := PrepareText(S);
          {    }
          T := TStringList.Create;
          try
            T.Text := S;
            {    , ..   -
                   }
            if (FFileViewPos > 0) and (T.Count > 0) and (Length(T[0]) = 0) then T.Delete(0);
            {   }
            Lines.AddStrings(T);
          finally
            T.Free;
          end;
          {    }
          FFileViewPos := FFileViewPos + L;
        end;
        {       
            }
        if not FAutoScroll then
        begin
          R1 := Perform(EM_LINEFROMCHAR, SS, 0);
          C1 := SS - Perform(EM_LINEINDEX, R1, 0);
          SelStart := SS;
          SelLength := 0;
          R2 := Perform(EM_LINEFROMCHAR, SelStart, 0);
          C2 := SelStart - Perform(EM_LINEINDEX, R2, 0);
          Perform(EM_LINESCROLL, C2 - C1, R2 - R1);
          F2 := Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
          Perform(EM_LINESCROLL, 0, F1 - F2);
        end
        else
        begin
          SI.cbSize := SizeOf(SI);
          SI.fMask := SIF_ALL;
          if GetScrollInfo(Handle, SB_VERT, SI) then
          begin
            PostMessage(Handle, WM_VSCROLL, MakeLong(SB_THUMBPOSITION, SI.nMax), 0);
            PostMessage(Handle, WM_VSCROLL, MakeLong(SB_ENDSCROLL, 0), 0);
          end;
        end;
      finally
        Lines.EndUpdate;
      end;
    finally
      Free;
    end;
    {   }
    if Assigned(FOnUpdate) then FOnUpdate(Self);
  except
    FFileViewPos := 0;
    Lines.Clear;
    {  }
    FFileError := GetLastError;
    if Assigned(FOnFileOpenError) then FOnFileOpenError(Self, FFileError);
  end;
end;

end.

