{
    

  
    -  " "
    -  " "   Windows 95
    -   
    -   
    -        ( D3  )
    -    (   )

   . 
  E-mail: roman@sar.nnov.ru
}

unit Ex_Dialogs;

interface

{$I EX.INC}

uses
  Windows, ShellAPI, ShlObj, SysUtils, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, Menus, StdCtrls, ExtCtrls, CommCtrl, ComCtrls,
  Registry, TypInfo;

type

{ TIconDialog }

  {
       " ".

    :

    Execute -     .
    ExecutePos -     .   
                         -1.

    :

    BrowseCaption -     (   "").
    BrowseFilter -     .
    CancelCaption -    (   "").
    Caption -        .
    FileLabel -         .
    IconIndex -      .
    IconFile -        .
    IconPath -           ", ".
    IconsLabel -      .

    :

    OnShow -           .
    OnHide -           .
  }

  TIconDialog = class(TComponent)
  private
    FCaption: TCaption;
    FFileLabel: TCaption;
    FIconsLabel: TCaption;
    FCancelCaption: TCaption;
    FBrowseCaption: TCaption;
    FBrowseFilter: string;
    FIconPath: string;
    FPosition: TPoint;
    FOnShow: TNotifyEvent;
    FOnHide: TNotifyEvent;
    procedure DialogHide(Sender: TObject);
    procedure DialogShow(Sender: TObject);
    function GetIconIndex: Integer;
    function GetIconFile: string;
    function IsCancelCaptionStored: Boolean;
    function IsCaptionStored: Boolean;
    function IsBrowseCaptionStored: Boolean;
    function IsBrowseFilterStored: Boolean;
    function IsIconsLabelStored: Boolean;
    function IsFileLabelStored: Boolean;
    procedure SetIconIndex(Value: Integer);
    procedure SetIconFile(Value: string);
  protected
    procedure DoHide; virtual;
    procedure DoShow; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    function Execute: Boolean;
    function ExecutePos(X, Y: Integer): Boolean;
  published
    property BrowseCaption: TCaption read FBrowseCaption write FBrowseCaption stored IsBrowseCaptionStored;
    property BrowseFilter: string read FBrowseFilter write FBrowseFilter stored IsBrowseFilterStored;
    property CancelCaption: TCaption read FCancelCaption write FCancelCaption stored IsCancelCaptionStored;
    property Caption: TCaption read FCaption write FCaption stored IsCaptionStored;
    property FileLabel: TCaption read FFileLabel write FFileLabel stored IsFileLabelStored;
    property IconIndex: Integer read GetIconIndex write SetIconIndex stored False;
    property IconFile: string read GetIconFile write SetIconFile stored False;
    property IconPath: string read FIconPath write FIconPath;
    property IconsLabel: TCaption read FIconsLabel write FIconsLabel stored IsIconsLabelStored;
    property OnHide: TNotifyEvent read FOnHide write FOnHide;
    property OnShow: TNotifyEvent read FOnShow write FOnShow;
  end;

{ TAboutDialog }

  {
       " ".

    :

    Execute -              .
    ExecutePos -              . 
                                
                             -1.

    :

    Caption -              .    
                          .
    CaptionFormat -          .
    Comments -              (  ).
    Copyright -               ( 
                          ).
    CopyrightFormat -          .
    Picture -               -   32x32. 
                             .
    Product -               (  ).
    ProductFormat -          .
    Version -               (  ).
    VersionFormat -          .
    LicenseLabel -            .
    LicenseKey -              HKLM,  
                             .   
                           ,     .
                               
                           Company -    Name -
                            (   InstallShield
                            ).
    UseResource -             
                               .

    :

    OnShow -                 .
    OnHide -                 .
  }

  TAboutDialog = class(TComponent)
  private
    FProduct: string;
    FProductFormat: string;
    FVersion: string;
    FVersionFormat: string;
    FCopyright: string;
    FCopyrightFormat: string;
    FComments: string;
    FCaption: string;
    FCaptionFormat: string;
    FPicture: TPicture;
    FLicenseLabel: string;
    FLicenseKey: string;
    FUseResource: Boolean;
    FPosition: TPoint;
    FOnShow: TNotifyEvent;
    FOnHide: TNotifyEvent;
    procedure DialogHide(Sender: TObject);
    procedure DialogShow(Sender: TObject);
    function IsCaptionFormatStored: Boolean;
    function IsCopyrightFormatStored: Boolean;
    function IsLicenseLabelStored: Boolean;
    function IsProductFormatStored: Boolean;
    function IsVersionFormatStored: Boolean;
    procedure ReadOldKey(Reader: TReader);
    procedure SetPicture(Value: TPicture);
  protected
    procedure DefineProperties(Filer: TFiler); override;
    procedure DoHide; virtual;
    procedure DoShow; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Execute: Boolean;
    function ExecutePos(X, Y: Integer): Boolean;
  published
    property Caption: string read FCaption write FCaption;
    property CaptionFormat: string read FCaptionFormat write FCaptionFormat stored IsCaptionFormatStored;
    property Comments: string read FComments write FComments;
    property Copyright: string read FCopyright write FCopyright;
    property CopyrightFormat: string read FCopyrightFormat write FCopyrightFormat stored IsCopyrightFormatStored;
    property LicenseLabel: string read FLicenseLabel write FLicenseLabel stored IsLicenseLabelStored;
    property LicenseKey: string read FLicenseKey write FLicenseKey;
    property Picture: TPicture read FPicture write SetPicture;
    property Product: string read FProduct write FProduct;
    property ProductFormat: string read FProductFormat write FProductFormat stored IsProductFormatStored;
    property Version: string read FVersion write FVersion;
    property VersionFormat: string read FVersionFormat write FVersionFormat stored IsVersionFormatStored;
    property UseResource: Boolean read FUseResource write FUseResource default False;
    property OnHide: TNotifyEvent read FOnHide write FOnHide;
    property OnShow: TNotifyEvent read FOnShow write FOnShow;
  end;

{ TFolderDialog }

  {
        (  
    SHBrowseForFolder).

    :

    Execute -     .
    ExecutePos -     .   
                         -1.

    :

    Caption -     .
    Folder -         .
    Root -        .   :
                   brDesktop -     .
                   brMyComputer -  .
                   brNetwork -     .
    Target -      .   :
                   btDomains -     .
                   btComputers -  .
                   btFolders -    .
                   btPrinters -   .
    Title -      .    
                 .
  }

  TBrowseTarget = (btDomains, btComputers, btFolders, btPrinters);
  TBrowseRoot = (brDesktop, brMyComputer, brNetwork);

  TFolderDialog = class(TComponent)
  private
    FCaption: string;
    FTitle: string;
    FFolder: string;
    FRoot: TBrowseRoot;
    FTarget: TBrowseTarget;
    FX: Integer;
    FY: Integer;
  protected
    procedure Change(Wnd: HWND; Item: PItemIDList); virtual;
    procedure Init(Wnd: HWND); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    function Execute: Boolean;
    function ExecutePos(X, Y: Integer): Boolean;
  published
    property Caption: string read FCaption write FCaption;
    property Folder: string read FFolder write FFolder;
    property Root: TBrowseRoot read FRoot write FRoot default brMyComputer;
    property Target: TBrowseTarget read FTarget write FTarget default btFolders;
    property Title: string read FTitle write FTitle;
  end;

{ TFileDialog }

  {       . }


  TCreateFolderEvent = procedure(Sender: TObject; FolderItem: TListItem; var AllowCreate: Boolean) of object;
  TDeleteFileEvent = procedure(Sender: TObject; FileItem: TListItem; var AllowDelete: Boolean) of object;
  TRenamingFileEvent = procedure(Sender: TObject; FileItem: TListItem; var AllowRename: Boolean) of object;
  TRenamedFileEvent = procedure(Sender: TObject; FileItem: TListItem; var S: string) of object;
  TOpenFileEvent = procedure(Sender: TObject; FileItem: TListItem; var AllowOpen: Boolean) of object;

  TFileDialog = class(TComponent)
  private
    FCaption: TCaption;
    FFolderLabel: TCaption;
    FFolder: string;
    FFileNameLabel: TCaption;
    FFileName: string;
    FFileTypeLabel: TCaption;
    FFileType: string;
    FOpenCaption: TCaption;
    FCancelCaption: TCaption;
    FEnableUp: Boolean;
    FEnableCreate: Boolean;
    FEnableOpen: Boolean;
    FEnableRename: Boolean;
    FEnableDelete: Boolean;
    FPopupMenu: TPopupMenu;
    FDialogForm: TForm;
    FX: Integer;
    FY: Integer;
    FOnInitDialog: TNotifyEvent;
    FOnDoneDialog: TNotifyEvent;
    FOnCancelDialog: TNotifyEvent;
    FOnRefreshDialog: TNotifyEvent;
    FOnChangeFolder: TNotifyEvent;
    FOnChangeFileName: TNotifyEvent;
    FOnChangeFileType: TNotifyEvent;
    FOnCreateFolder: TCreateFolderEvent;
    FOnUpFolder: TNotifyEvent;
    FOnDeleteFile: TDeleteFileEvent;
    FOnRenamingFile: TRenamingFileEvent;
    FOnRenamedFile: TRenamedFileEvent;
    FOnOpenFile: TOpenFileEvent;
    FOnShow: TNotifyEvent;
    FOnHide: TNotifyEvent;
    procedure CancelButtonClick(Sender: TObject);
    procedure CreateFolderClick(Sender: TObject);
    procedure DialogHide(Sender: TObject);
    procedure DialogKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DialogShow(Sender: TObject);
    procedure FileListKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FileListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure FileListRenamed(Sender: TObject; Item: TListItem; var S: string);
    procedure FileListRenaming(Sender: TObject; Item: TListItem; var AllowEdit: Boolean);
    procedure FolderComboChange(Sender: TObject);
    function GetFileImages: TImageList;
    function GetFileList: TListItems;
    function GetFileListColumns: TListColumns;
    function GetFileNameItem: TListItem;
    function GetFileSelectedItem: TListItem;
    function GetFileTypeIndex: Integer;
    function GetFileTypeList: TStrings;
    function GetFolderIndex: Integer;
    function GetFolderList: TStrings;
    function GetIsRenaming: Boolean;
    function GetIsVisible: Boolean;
    procedure NameEditChange(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure SetEnableCreate(Value: Boolean);
    procedure SetEnableOpen(Value: Boolean);
    procedure SetEnableUp(Value: Boolean);
    procedure SetFileName(Value: string);
    procedure SetFolder(Value: string);
    procedure TypeComboChange(Sender: TObject);
    procedure UpFolderButtonClick(Sender: TObject);
  protected
    procedure DoCancelDialog; virtual;
    procedure DoChangeFileName; virtual;
    procedure DoDoneDialog; virtual;
    procedure DoInitDialog; virtual;
    procedure DoHide; virtual;
    procedure DoRefreshDialog; virtual;
    procedure DoShow; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    procedure CancelDialog;
    procedure CancelRename;
    procedure CreateFolder;
    procedure DeleteFile;
    function Execute: Boolean;
    function ExecutePos(X, Y: Integer): Boolean;
    procedure OpenFile;
    procedure Popup;
    procedure PopupPos(X, Y: Integer);
    procedure RefreshDialog;
    procedure RenameFile;
    procedure UpFolder;
    property Dialog: TForm read FDialogForm;
    property FileImages: TImageList read GetFileImages;
    property FileList: TListItems read GetFileList;
    property FileListColumns: TListColumns read GetFileListColumns;
    property FileNameItem: TListItem read GetFileNameItem;
    property FileSelectedItem: TListItem read GetFileSelectedItem;
    property FileTypeIndex: Integer read GetFileTypeIndex;
    property FileTypeList: TStrings read GetFileTypeList;
    property FolderIndex: Integer read GetFolderIndex;
    property FolderList: TStrings read GetFolderList;
    property IsRenaming: Boolean read GetIsRenaming;
    property IsVisible: Boolean read GetIsVisible;
  published
    property CancelCaption: TCaption read FCancelCaption write FCancelCaption;
    property Caption: TCaption read FCaption write FCaption;
    property EnableCreate: Boolean read FEnableCreate write SetEnableCreate;
    property EnableDelete: Boolean read FEnableDelete write FEnableDelete;
    property EnableOpen: Boolean read FEnableOpen write SetEnableOpen;
    property EnableRename: Boolean read FEnableRename write FEnableRename;
    property EnableUp: Boolean read FEnableUp write SetEnableUp;
    property FileName: string read FFileName write SetFileName;
    property FileNameLabel: TCaption read FFileNameLabel write FFileNameLabel;
    property FileTypeLabel: TCaption read FFileTypeLabel write FFileTypeLabel;
    property FileType: string read FFileType write FFileType;
    property FolderLabel: TCaption read FFolderLabel write FFolderLabel;
    property Folder: string read FFolder write SetFolder;
    property OpenCaption: TCaption read FOpenCaption write FOpenCaption;
    property PopupMenu: TPopupMenu read FPopupMenu write FPopupMenu;
    property OnCancelDialog: TNotifyEvent read FOnCancelDialog write FOnCancelDialog;
    property OnChangeFileName: TNotifyEvent read FOnChangeFileName write FOnChangeFileName;
    property OnChangeFileType: TNotifyEvent read FOnChangeFileType write FOnChangeFileType;
    property OnChangeFolder: TNotifyEvent read FOnChangeFolder write FOnChangeFolder;
    property OnCreateFolder: TCreateFolderEvent read FOnCreateFolder write FOnCreateFolder;
    property OnDeleteFile: TDeleteFileEvent read FOnDeleteFile write FOnDeleteFile;
    property OnDoneDialog: TNotifyEvent read FOnDoneDialog write FOnDoneDialog;
    property OnInitDialog: TNotifyEvent read FOnInitDialog write FOnInitDialog;
    property OnOpenFile: TOpenFileEvent read FOnOpenFile write FOnOpenFile;
    property OnRefreshDialog: TNotifyEvent read FOnRefreshDialog write FOnRefreshDialog;
    property OnRenamedFile: TRenamedFileEvent read FOnRenamedFile write FOnRenamedFile;
    property OnRenamingFile: TRenamingFileEvent read FOnRenamingFile write FOnRenamingFile;
    property OnUpFolder: TNotifyEvent read FOnUpFolder write FOnUpFolder;
    property OnHide: TNotifyEvent read FOnHide write FOnHide;
    property OnShow: TNotifyEvent read FOnShow write FOnShow;
  end;

{$IFNDEF VER90 }

{ TExportPictureDialog }

  {
            
    (   ).

    :

    PaletteLabel -      .
    PaletteList -     .   
                    : =,    
                       TPixelFormat 
                    : pf1bit, pf4bit, pf8bit, pf15bit,
                   pf16bit, pf24bit  pf32bit.
    PixelFormat -     .
  }

  TPixelFormatEntry = record
    Value: TPixelFormat;
    Name: string;
  end;

  TPixelFormatEntries = array[0..6] of TPixelFormatEntry;

  TPixelFormatList = class(TPersistent)
  private
    FCount: Integer;
    FItems: TPixelFormatEntries;
  protected
    procedure AssignTo(Dest: TPersistent); override;
  public
    function ItemIndex(PixelFormat: TPixelFormat): Integer;
    function PixelFormat(ItemIndex: Integer): TPixelFormat;
  end;

  TExportPictureDialog = class(TSaveDialog)
  private
    FPixelFormat: TPixelFormat;
    FPixelFormats: TPixelFormatList;
    FPaletteList: TStringList;
    FPaletteLabel: TCaption;
    FColorsPanel: TPanel;
    FColorsLabel: TLabel;
    FColorsCombo: TComboBox;
    procedure ColorsComboChange(Sender: TObject);
    procedure PaletteListChange(Sender: TObject);
    procedure SetPaletteList(Value: TStringList);
  protected
    procedure DoClose; override;
    procedure DoShow; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Execute: Boolean; override;
  published
    property PaletteLabel: TCaption read FPaletteLabel write FPaletteLabel;
    property PaletteList: TStringList read FPaletteList write SetPaletteList;
    property PixelFormat: TPixelFormat read FPixelFormat write FPixelFormat default pf8bit;
  end;

{$ELSE}

  TExportPictureDialog = class(TSaveDialog)
  end;

{$ENDIF}

{ TSplashDialog }

  {
      .      
    .    Application    
     Windows , ,     
     .     
            () .

    !       
    Application.OnIdle.       
            .

    :

    Hide -         .
    Show -         .

    :

    AutoHide -         .
    AutoShow -         .
    BorderStyle -    .
    HideDelay -       .    
                  AutoHide = True.
    HideOnClick -  ,     .
    Picture -      .

    :

    OnShow -          (   ,
                     ).
    OnHide -          (  , 
                    ).
  }

  TDialogBorder = (sbNone, sbSingle);

  TSplashDialog = class(TComponent)
  private
    FPicture: TPicture;
    FBorderStyle: TDialogBorder;
    FAutoShow: Boolean;
    FAutoHide: Boolean;
    FHideDelay: Longint;
    FHideOnClick: Boolean;
    FDialog: TForm;
    FTimer: TTimer;
    FOnShow: TNotifyEvent;
    FOnHide: TNotifyEvent;
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure DialogHide(Sender: TObject);
    procedure DialogShow(Sender: TObject);
    procedure HideTime(Sender: TObject);
    procedure PictureChange(Sender: TObject);
    procedure PictureMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SetPicture(Value: TPicture);
  protected
    procedure DoHide; virtual;
    procedure DoShow; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Hide;
    procedure Show;
  published
    property AutoHide: Boolean read FAutoHide write FAutoHide default True;
    property AutoShow: Boolean read FAutoShow write FAutoShow default True;
    property BorderStyle: TDialogBorder read FBorderStyle write FBorderStyle default sbNone;
    property HideDelay: Longint read FHideDelay write FHideDelay default 0;
    property HideOnClick: Boolean read FHideOnClick write FHideOnClick default False;
    property OnHide: TNotifyEvent read FOnHide write FOnHide;
    property OnShow: TNotifyEvent read FOnShow write FOnShow;
    {         }
    property Picture: TPicture read FPicture write SetPicture;
  end;

implementation

uses
  Ex_About, Ex_Icon, Ex_File, ExtUtils;

{ TIconDialog }

{$IFDEF EX_D3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}
  SIconDialogCaption = ' ';
  SIconDialogFileLabelCaption = '& :';
  SIconDialogIconsLabelCaption = '& :';
  SIconDialogCancelButtonCaption = '';
  SIconDialogBrowseButtonCaption = '&...';
  SIconDialogBrowseFilter = '   (*.exe;*.dll;*.ico)|*.exe;*.dll;*.ico| (*.exe)|*.exe| (*.dll)|*.dll| (*.ico)|*.ico|  (*.*)|*.*';

constructor TIconDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCaption := SIconDialogCaption;
  FFileLabel := SIconDialogFileLabelCaption;
  FIconsLabel := SIconDialogIconsLabelCaption;
  FCancelCaption := SIconDialogCancelButtonCaption;
  FBrowseCaption := SIconDialogBrowseButtonCaption;
  FBrowseFilter := SIconDialogBrowseFilter;
end;

procedure TIconDialog.DialogHide(Sender: TObject);
begin
  DoHide;
end;

procedure TIconDialog.DialogShow(Sender: TObject);
begin
  {   }
  with Sender as TForm do
  begin
    if FPosition.X <> -1 then Left := FPosition.X;
    if FPosition.Y <> -1 then Top := FPosition.Y;
  end;
  {  }
  DoShow;
end;

function TIconDialog.GetIconIndex: Integer;
begin
  Result := ExtractIconIndex(IconPath);
end;

function TIconDialog.GetIconFile: string;
begin
  Result := ExtractIconFile(IconPath);
end;

function TIconDialog.IsCancelCaptionStored: Boolean;
begin
  Result := CancelCaption <> SIconDialogCancelButtonCaption;
end;

function TIconDialog.IsCaptionStored: Boolean;
begin
  Result := Caption <> SIconDialogCaption;
end;

function TIconDialog.IsBrowseCaptionStored: Boolean;
begin
  Result := BrowseCaption <> SIconDialogBrowseButtonCaption;
end;

function TIconDialog.IsBrowseFilterStored: Boolean;
begin
  Result := BrowseFilter <> SIconDialogBrowseFilter;
end;

function TIconDialog.IsIconsLabelStored: Boolean;
begin
  Result := IconsLabel <> SIconDialogIconsLabelCaption;
end;

function TIconDialog.IsFileLabelStored: Boolean;
begin
  Result := FileLabel <> SIconDialogFileLabelCaption;
end;

procedure TIconDialog.SetIconIndex(Value: Integer);
begin
  IconPath := ExpandIconPath(IconFile, Value);
end;

procedure TIconDialog.SetIconFile(Value: string);
begin
  IconPath := ExpandIconPath(Value, IconIndex);
end;

procedure TIconDialog.DoHide;
begin
  if Assigned(FOnHide) then FOnHide(Self);
end;

procedure TIconDialog.DoShow;
begin
  if Assigned(FOnShow) then FOnShow(Self);
end;

function TIconDialog.Execute: Boolean;
begin
  Result := ExecutePos(-1, -1);
end;

function TIconDialog.ExecutePos(X, Y: Integer): Boolean;
begin
  Result := False;
  {   }
  with TIconForm.Create(Application) do
  try
    {     }
    Caption := FCaption;
    FileLabel.Caption := FFileLabel;
    IconsLabel.Caption := FIconsLabel;
    CancelButton.Caption := FCancelCaption;
    BrowseButton.Caption := FBrowseCaption;
    {  }
    OpenDialog.Filter := FBrowseFilter;
    {   }
    FPosition := Point(X, Y);
    {    }
    IconsBox.IconPath := FIconPath;
    {  }
    OnShow := DialogShow;
    OnHide := DialogHide;
    {   }
    if ShowModal = mrOK then
    begin
      FIconPath := IconsBox.IconPath;
      Result := True;
    end;
  finally
    Free;
  end;
end;

{ TAboutDialog }

{$IFDEF EX_D3}
resourcestring
{$ELSE}
const
{$ENDIF}
  SAboutDialogProductFormat = '%s';
  SAboutDialogVersionFormat = ' %s';
  SAboutDialogCopyrightFormat = '%s';
  SAboutDialogCaptionFormat = '  ''%s''';
  SAboutDialogLicenseLabelCaption = '    :';

constructor TAboutDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPicture := TPicture.Create;
  FProductFormat := SAboutDialogProductFormat;
  FVersionFormat := SAboutDialogVersionFormat;
  FCopyrightFormat := SAboutDialogCopyrightFormat;
  FCaptionFormat := SAboutDialogCaptionFormat;
  FLicenseLabel := SAboutDialogLicenseLabelCaption;
end;

destructor TAboutDialog.Destroy;
begin
  FPicture.Free;
  inherited destroy;
end;

procedure TAboutDialog.DialogHide(Sender: TObject);
begin
  DoHide;
end;

procedure TAboutDialog.DialogShow(Sender: TObject);
begin
  {   }
  with Sender as TForm do
  begin
    if FPosition.X <> -1 then Left := FPosition.X;
    if FPosition.Y <> -1 then Top := FPosition.Y;
  end;
  {  }
  DoShow;
end;

function TAboutDialog.IsCaptionFormatStored: Boolean;
begin
  Result := CaptionFormat <> SAboutDialogCaptionFormat;
end;

function TAboutDialog.IsCopyrightFormatStored: Boolean;
begin
  Result := CopyrightFormat <> CopyrightFormat;
end;

function TAboutDialog.IsLicenseLabelStored: Boolean;
begin
  Result := LicenseLabel <> SAboutDialogLicenseLabelCaption;
end;

function TAboutDialog.IsProductFormatStored: Boolean;
begin
  Result := ProductFormat <> SAboutDialogProductFormat;
end;

function TAboutDialog.IsVersionFormatStored: Boolean;
begin
  Result := VersionFormat <> SAboutDialogVersionFormat;
end;

procedure TAboutDialog.ReadOldKey(Reader: TReader);
begin
  FLicenseKey := Reader.ReadString;
end;

procedure TAboutDialog.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
end;

procedure TAboutDialog.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  {     ,    LicenceKey
      Key }
  Filer.DefineProperty('Key', ReadOldKey, nil, False);
end;

procedure TAboutDialog.DoHide;
begin
  if Assigned(FOnHide) then FOnHide(Self);
end;

procedure TAboutDialog.DoShow;
begin
  if Assigned(FOnShow) then FOnShow(Self);
end;

function TAboutDialog.Execute: Boolean;
begin
  Result := ExecutePos(-1, -1);
end;

function TAboutDialog.ExecutePos(X, Y: Integer): Boolean;
var
  I, L, H: Integer;
  F: TForm;
  C: string;
begin
  {    }
  C := FCaption;
  if Length(C) = 0 then C := Application.Title;
  C := Format(FCaptionFormat, [C]);
  {     }
  for I := 0 to Screen.FormCount - 1 do
  begin
    F := Screen.Forms[I];
    if (F.ClassName = TAboutForm.ClassName) and (F.Caption = C) then
    begin
      F.BringToFront;
      Result := True;
      Exit;
    end;
  end;
  {   }
  with TAboutForm.Create(Application) do
  try
    {   }
    Caption := C;
    {  }
    with LogoImage.Picture do
    begin
      Graphic := FPicture.Graphic;
      if Graphic = nil then Graphic := Application.Icon;
    end;
    {  }
    with ProductLabel do
    begin
      Caption := FProduct;
      if FUseResource then Caption := GetVersionStr(ParamStr(0), 'FileDescription', Caption);
      Caption := Format(FProductFormat, [Caption]);
    end;
    {  }
    with VersionLabel do
    begin
      Caption := FVersion;
      if FUseResource then Caption := GetVersionStr(ParamStr(0), 'FileVersion', Caption);
      Caption := Format(FVersionFormat, [Caption]);
    end;
    {   }
    with CopyrightLabel do
    begin
      Caption := FCopyright;
      if FUseResource then Caption := GetVersionStr(ParamStr(0), 'LegalCopyright', Caption);
      Caption := Format(FCopyrightFormat, [Caption]);
    end;
    {  }
    with CommentsLabel do
    begin
      Caption := FComments;
      if FUseResource then Caption := GetVersionStr(ParamStr(0), 'Comments', Caption);
    end;
    {           }
    if Length(FLicenseKey) <> 0 then
    begin
      {    }
      LicenseLabel.Caption := FLicenseLabel;
      {     }
      with TRegistry.Create do
      try
        RootKey := HKEY_LOCAL_MACHINE;
        {   }
        if OpenKey(FLicenseKey, False) then
        begin
          {     }
          if ValueExists('Company') then CompanyLabel.Caption := ReadString('Company');
          if ValueExists('Name') then NameLabel.Caption := ReadString('Name');
        end;
      finally
        Free;
      end;
    end
    else
    begin
      {    }
      LicenseLabel.Visible := False;
      CompanyLabel.Visible := False;
      NameLabel.Visible := False;
      {    ,    }
      L := CommentsLabel.Top - CopyrightLabel.Top;
      H := Divider.Top - LicenseLabel.Top - L * Ord(Length(CommentsLabel.Caption) > 0);
      Divider.Top := Divider.Top - H;
      OKButton.Top := OKButton.Top - H;
      Height := Height - H;
    end;
    {   }
    FPosition := Point(X, Y);
    {  }
    OnShow := DialogShow;
    OnHide := DialogHide;
    {   }
    Result := ShowModal = mrOK;
  finally
    Free;
  end;
end;

{ TFolderDialog }

function CallBack(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer; stdcall;
begin
  Result := 0;
  case uMsg of
    BFFM_INITIALIZED:
      {    }
      if lpData <> 0 then TFolderDialog(lpData).Init(Wnd);
    BFFM_SELCHANGED:
      {    }
      if lpData <> 0 then TFolderDialog(lpData).Change(Wnd, PItemIDList(lParam));
  end;
end;

constructor TFolderDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FRoot := brMyComputer;
  FTarget := btFolders;
end;

procedure TFolderDialog.Change(Wnd: HWND; Item: PItemIDList);
var
  Path: array[0..MAX_PATH] of Char;
  OK: Boolean;
begin
  SHGetPathFromIDList(Item, Path);
  if Target in [btFolders, btPrinters] then
  begin
    OK := StrLen(Path) > 0;
    SendMessage(Wnd, BFFM_ENABLEOK, 0, Longint(OK));
  end;
end;

procedure TFolderDialog.Init(Wnd: HWND);
var
  Rect: TRect;
begin
  {    }
  GetWindowRect(Wnd, Rect);
  if FX = -1 then FX := (Screen.Width - Rect.Right + Rect.Left) div 2;
  if FY = -1 then FY := (Screen.Height - Rect.Bottom + Rect.Top) div 2;
  SetWindowPos(Wnd, 0, FX, FY, 0, 0, SWP_NOACTIVATE or SWP_NOSIZE or SWP_NOZORDER);
  {   }
  if Length(FCaption) <> 0 then
    SendMessage(Wnd, WM_SETTEXT, 0, Longint(PChar(FCaption)));
  {    }
  if Length(FFolder) <> 0 then
    SendMessage(Wnd, BFFM_SETSELECTION, 1, LPARAM(PChar(FFolder)));
end;

function TFolderDialog.Execute: Boolean;
begin
  Result := ExecutePos(-1, -1);
end;

function TFolderDialog.ExecutePos(X, Y: Integer): Boolean;
const
  Folders: array[TBrowseRoot] of Integer = (CSIDL_DESKTOP, CSIDL_DRIVES,
    CSIDL_NETWORK);
  Flags: array[TBrowseTarget] of Integer = (BIF_DONTGOBELOWDOMAIN,
    BIF_BROWSEFORCOMPUTER, BIF_RETURNONLYFSDIRS, BIF_BROWSEFORPRINTER);
var
  Name: array[0..MAX_PATH] of Char;
  Path: array[0..MAX_PATH] of Char;
  BrowseInfo: TBrowseInfo;
  ItemID, BrowseID: PItemIDList;
begin
  {    }
  FX := X;
  FY := Y;
  {    }
  Result := False;
  {     }
  SHGetSpecialFolderLocation(Application.Handle, Folders[FRoot], ItemID);
  {    }
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  {   }
  with BrowseInfo do
  begin
    hwndOwner := Application.Handle;
    pidlRoot  := ItemID;
    pszDisplayName := Name;
    lpszTitle := PChar(FTitle);
    ulFlags := Flags[FTarget];
    lpfn := CallBack;
    lParam := Longint(Self);
  end;
  {   }
  BrowseID := SHBrowseForFolder(BrowseInfo);
  {    }
  if BrowseID <> nil then
  begin
    if SHGetPathFromIDList(BrowseID, Path) then
      SetString(FFolder, Path, StrLen(Path))
    else
      SetString(FFolder, Name, StrLen(Name));
    Result := True;
  end;
end;

{ TFileDialog }

constructor TFileDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCaption := '';
  FFolderLabel := '&';
  FFileNameLabel := '& ';
  FFileTypeLabel := '& ';
  FOpenCaption := '&';
  FCancelCaption := '';
  FEnableUp := True;
  FEnableCreate := True;
  FEnableRename := True;
  FEnableDelete := True;
end;

procedure TFileDialog.CancelButtonClick(Sender: TObject);
begin
  if not IsRenaming then CancelDialog else CancelRename;
end;

procedure TFileDialog.CreateFolderClick(Sender: TObject);
begin
  CreateFolder;
end;

procedure TFileDialog.DialogHide(Sender: TObject);
begin
  DoHide;
end;

procedure TFileDialog.DialogKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if not IsRenaming then
  begin
    if (Shift = []) and (Key = VK_F5) then RefreshDialog;
    if (Shift = [ssShift]) and (Key = VK_F10) then Popup;
  end;
end;

procedure TFileDialog.DialogShow(Sender: TObject);
begin
  with Sender as TFileDialogForm do
  begin
    {     }
    if FX = -1 then FX := (Screen.Width - Width) div 2;
    if FY = -1 then FY := (Screen.Height - Height) div 2;
    {   }
    BoundsRect := Bounds(FX, FY, Width, Height);
  end;
  {  }
  DoShow;
end;

procedure TFileDialog.FileListKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if not IsRenaming then
  begin
    if Shift = [] then
      case Key of
        VK_F2: if FEnableRename then RenameFile;
        VK_DELETE: if FEnableDelete then DeleteFile;
        VK_RETURN: OpenFile;
      end;
    if Shift = [ssShift] then
      case Key of
        VK_F10: Popup;
      end;
  end;
end;

procedure TFileDialog.FileListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  if IsVisible then
    with TFileDialogForm(FDialogForm) do
    begin
      NameEdit.Text := Item.Caption;
      DoChangeFileName;
    end;
end;

procedure TFileDialog.FileListRenamed(Sender: TObject; Item: TListItem; var S: string);
begin
  if Assigned(FOnRenamedFile) then FOnRenamedFile(Self, Item, S);
end;

procedure TFileDialog.FileListRenaming(Sender: TObject; Item: TListItem; var AllowEdit: Boolean);
begin
  if Assigned(FOnRenamingFile) then FOnRenamingFile(Self, Item, AllowEdit);
end;

procedure TFileDialog.FolderComboChange(Sender: TObject);
begin
  if IsVisible then
    with TFileDialogForm(FDialogForm) do
    begin
      FFolder := FolderCombo.Text;
      FolderCombo.Hint := FFolder;
      if Assigned(FOnChangeFolder) then FOnChangeFolder(Self);
    end;
end;

function TFileDialog.GetFileImages: TImageList;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileImages;
end;

function TFileDialog.GetFileList: TListItems;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileList.Items
end;

function TFileDialog.GetFileListColumns: TListColumns;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileList.Columns;
end;

function TFileDialog.GetFileNameItem: TListItem;
var
  I: Integer;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  for I := 0 to FileList.Count - 1 do
  begin
    Result := FileList[I];
    if CompareText(Result.Caption, FileName) = 0 then Exit;
  end;
  Result := nil;
end;

function TFileDialog.GetFileSelectedItem: TListItem;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileList.Selected;
end;

function TFileDialog.GetFileTypeIndex: Integer;
begin
  if FDialogForm = nil then
  begin
    Result := -1;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).TypeCombo.ItemIndex;
end;

function TFileDialog.GetFileTypeList: TStrings;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).TypeCombo.Items;
end;

function TFileDialog.GetFolderIndex: Integer;
begin
  if FDialogForm = nil then
  begin
    Result := -1;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FolderCombo.ItemIndex;
end;

function TFileDialog.GetFolderList: TStrings;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FolderCombo.Items;
end;

function TFileDialog.GetIsRenaming: Boolean;
begin
  if FDialogForm = nil then
  begin
    Result := False;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileList.IsEditing;
end;

function TFileDialog.GetIsVisible: Boolean;
begin
  if FDialogForm = nil then
  begin
    Result := False;
    Exit;
  end;
  Result := IsWindowVisible(FDialogForm.Handle);
end;

procedure TFileDialog.NameEditChange(Sender: TObject);
begin
  FFileName := TFileDialogForm(FDialogForm).NameEdit.Text;
end;

procedure TFileDialog.OpenButtonClick(Sender: TObject);
begin
  if not IsRenaming then OpenFile else CancelRename;
end;

procedure TFileDialog.SetEnableCreate(Value: Boolean);
begin
  FEnableCreate := Value;
  if IsVisible then
    TFileDialogForm(FDialogForm).CreateButton.Enabled := Value;
end;

procedure TFileDialog.SetEnableOpen(Value: Boolean);
begin
  FEnableOpen := Value;
  if IsVisible then
    TFileDialogForm(FDialogForm).OpenButton.Enabled := Value;
end;

procedure TFileDialog.SetEnableUp(Value: Boolean);
begin
  FEnableUp := Value;
  if IsVisible then
    TFileDialogForm(FDialogForm).UpButton.Enabled := Value;
end;

procedure TFileDialog.SetFileName(Value: string);
begin
  FFileName := Value;
  if IsVisible then
    TFileDialogForm(FDialogForm).NameEdit.Text := Value;
end;

procedure TFileDialog.SetFolder(Value: string);
begin
  FFolder := Value;
  if Assigned(FDialogForm) then
    with TFileDialogForm(FDialogForm).FolderCombo do
    begin
      ItemIndex := Items.IndexOf(Value);
    end;
end;

procedure TFileDialog.TypeComboChange(Sender: TObject);
begin
  FFileType := TFileDialogForm(FDialogForm).TypeCombo.Text;
  if Assigned(FOnChangeFileType) then FOnChangeFileType(Self);
end;

procedure TFileDialog.UpFolderButtonClick(Sender: TObject);
begin
  UpFolder;
end;

procedure TFileDialog.DoCancelDialog;
begin
  if Assigned(FOnCancelDialog) then FOnCancelDialog(Self);
end;

procedure TFileDialog.DoChangeFileName;
begin
  if Assigned(FOnChangeFileName) then FOnChangeFileName(Self);
end;

procedure TFileDialog.DoDoneDialog;
begin
  if Assigned(FOnDoneDialog) then FOnDoneDialog(Self);
end;

type
  THackListView = class(TListView);

procedure TFileDialog.DoInitDialog;
begin
  {  ,       }
  with TFileDialogForm(FDialogForm) do
  begin
    InitControlHandle(FDialogForm, True);
{$IFNDEF EX_D5_UP}
    THackListView(FileList).ChangeScale(ClientWidth, 420);
{$ENDIF}
  end;
  {      }
  Application.ProcessMessages;
  {  }
  if Assigned(FOnInitDialog) then FOnInitDialog(Self);
end;

procedure TFileDialog.DoHide;
begin
  if Assigned(FOnHide) then FOnHide(Self);
end;

procedure TFileDialog.DoRefreshDialog;
begin
  if Assigned(FOnRefreshDialog) then FOnRefreshDialog(Self);
end;

procedure TFileDialog.DoShow;
begin
  if Assigned(FOnShow) then FOnShow(Self);
end;

procedure TFileDialog.CancelDialog;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      DoCancelDialog;
      ModalResult := mrCancel;
    end;
end;

procedure TFileDialog.CancelRename;
var
  FileItem: TListItem;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      FileItem := FileList.Selected;
      if FileItem <> nil then FileItem.CancelEdit;
    end;
end;

procedure TFileDialog.CreateFolder;
var
  FolderItem: TListItem;
  AllowCreate: Boolean;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      {   -  }
      with FileList do
      begin
        if Visible then SetFocus;
        FolderItem := Items.Add;
        FolderItem.Caption := '----';
        FolderItem.ImageIndex := 1;
      end;
      {   }
      AllowCreate := True;
      if Assigned(FOnCreateFolder) then
        FOnCreateFolder(Self, FolderItem, AllowCreate);
      {    -   }
      if not AllowCreate then FolderItem.Free;
    end;
end;

procedure TFileDialog.DeleteFile;
var
  FileItem: TListItem;
  AllowDelete: Boolean;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      FileItem := FileList.Selected;
      if FileItem <> nil then
      begin
        AllowDelete := True;
        if Assigned(FOnDeleteFile) then
          FOnDeleteFile(Self, FileItem, AllowDelete);
        if AllowDelete then FileItem.Free;
      end;
    end;
end;

function TFileDialog.Execute: Boolean;
begin
  Result := ExecutePos(-1, -1);
end;

function TFileDialog.ExecutePos(X, Y: Integer): Boolean;
begin
  {    }
  FX := X;
  FY := Y;
  {   }
  FDialogForm := TFileDialogForm.Create(Application);
  try
    {   }
    DoInitDialog;
    {    }
    with TFileDialogForm(FDialogForm) do
    begin
      {    }
      Caption := FCaption;
      OnHide := DialogHide;
      OnKeydown := DialogKeyDown;
      OnShow := DialogShow;
      {   }
      FolderLabel.Caption := FFolderLabel;
      {   }
      with FolderCombo do
      begin
        with Items do
        begin
          if (Count = 0) and (Length(FFolder) > 0) then Add(FFolder);
          ItemIndex := IndexOf(FFolder);
          if (Count > 0) and (ItemIndex = -1) then ItemIndex := 0;
        end;
        Hint := Text;
        OnChange := FolderComboChange;
      end;
      {  "   " }
      with UpButton do
      begin
        Enabled := FEnableUp;
        OnClick := UpFolderButtonClick;
      end;
      {  "  " }
      with CreateButton do
      begin
        Enabled := EnableCreate;
        OnClick := CreateFolderClick;
      end;
      {   }
      with FileList do
      begin
        { :    -      }
        if Items.Count = 0 then Items.Add.Free;
        {   }
        ReadOnly := not FEnableRename;
        PopupMenu := FPopupMenu;
        OnChange := FileListChange;
        OnEditing := FileListRenaming;
        OnEdited := FileListRenamed;
        OnKeyDown := FileListKeyDown;
      end;
      {      }
      NameLabel.Caption := FFileNameLabel;
      with NameEdit do
      begin
        Text := FFileName;
        OnChange := NameEditChange;
      end;
      {      }
      TypeLabel.Caption := FileTypeLabel;
      with TypeCombo do
      begin
        with Items do
        begin
          if (Count = 0) and (Length(FFileType) > 0) then Add(FFileType);
          ItemIndex := IndexOf(FFileType);
          if (Count > 0) and (ItemIndex = -1) then ItemIndex := 0;
        end;
        OnChange := TypeComboChange;
      end;
      {  ""  "" }
      with OpenButton do
      begin
        Caption := FOpenCaption;
        Enabled := FEnableOpen;
        OnClick := OpenButtonClick;
      end;
      with CancelButton do
      begin
        Caption := FCancelCaption;
        OnClick := CancelButtonClick;
      end;
      {   }
      Result := ShowModal = mrOK;
    end;
    {   }
    DoDoneDialog;
  finally
    FDialogForm.Free;
    FDialogForm := nil;
  end;
end;

procedure TFileDialog.OpenFile;
var
  AllowOpen: Boolean;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
      if Length(NameEdit.Text) > 0 then
      begin
        AllowOpen := True;
        if Assigned(FOnOpenFile) then
          FOnOpenFile(Self, FileNameItem, AllowOpen);
        if AllowOpen then ModalResult := mrOK;
      end;
end;

procedure TFileDialog.Popup;
var
  X, Y: Integer;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm).FileList do
    begin
      X := ClientOrigin.X;
      Y := ClientOrigin.Y;
      PopupPos(X, Y);
    end;
end;

procedure TFileDialog.PopupPos(X, Y: Integer);
begin
  if (FPopupMenu <> nil) and (FDialogForm <> nil) then FPopupMenu.Popup(X, Y);
end;

procedure TFileDialog.RefreshDialog;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      {    }
      with FileList do
      begin
        Items.BeginUpdate;
        try
          DoRefreshDialog;
        finally
          Items.EndUpdate;
        end;
      end;
      {    }
      with FolderCombo do
      begin
        ItemIndex := Items.IndexOf(FFolder);
        if ItemIndex = -1 then
        begin
          if (Items.Count = 0) and (Length(FFolder) > 0) then Items.Add(FFolder);
          if Items.Count > 0 then ItemIndex := 0;
        end;
        OnChange := FolderComboChange;
      end;
    end;
end;

procedure TFileDialog.RenameFile;
var
  FileItem: TListItem;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      FileItem := FileList.Selected;
      if FileItem <> nil then
      begin
        FileList.SetFocus;
        FileItem.EditCaption;
      end;
    end;
end;

procedure TFileDialog.UpFolder;
begin
  if FDialogForm <> nil then
    if Assigned(FOnUpFolder) then FOnUpFolder(Self);
end;

{$IFNDEF VER90 }

procedure TPixelFormatList.AssignTo(Dest: TPersistent);
var
  I: Integer;
  Strings: TStrings;
begin
  if Dest is TStrings then
  begin
    Strings := TStrings(Dest);
    with Strings do
    begin
      Clear;
      for I := 0 to FCount - 1 do Add(FItems[I].Name);
    end;
  end
  else
    inherited AssignTo(Dest);
end;

function TPixelFormatList.ItemIndex(PixelFormat: TPixelFormat): Integer;
var
  I: Integer;
begin
  for I := 0 to FCount - 1 do
    if FItems[I].Value = PixelFormat then
    begin
      Result := I;
      Exit;
    end;
  Result := -1;
end;

function TPixelFormatList.PixelFormat(ItemIndex: Integer): TPixelFormat;
var
  I: Integer;
begin
  for I := 0 to FCount - 1 do
  begin
    if ItemIndex = 0 then
    begin
      Result := FItems[I].Value;
      Exit;
    end;
    Dec(ItemIndex);
  end;
  Result := pf8bit;
end;

{ TExportPictureDialog }

constructor TExportPictureDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPixelFormat := pf8bit;
  FPixelFormats := TPixelFormatList.Create;
  FPaletteLabel := '&:';
  FPaletteList := TStringList.Create;
  FPaletteList.OnChange := PaletteListChange;
  {    }
  FPaletteList.Add('pf4bit=16 ');
  FPaletteList.Add('pf8bit=256 ');
  FPaletteList.Add('pf15bit=32768 ');
  FPaletteList.Add('pf16bit=65536 ');
  FPaletteList.Add('pf24bit=16777216 ');
  FPaletteList.Add('pf32bit=True Color');
  {   }
  FColorsPanel := TPanel.Create(Self);
  {    }
  with FColorsPanel do
  begin
    {  }
    Name := 'ColorsPanel';
    Caption := '';
    SetBounds(8, 231, 420, 21);
    BevelOuter := bvNone;
    BorderWidth := 0;
    TabOrder := 1;
    {    }
    FColorsLabel := TLabel.Create(Self);
    {   }
    with FColorsLabel do
    begin
      Name := 'ColorsLabel';
      Caption := '';
      SetBounds(8, 3, 72, 13);
      AutoSize := False;
      Parent := FColorsPanel;
    end;
    {   }
    FColorsCombo := TComboBox.Create(Self);
    {   }
    with FColorsCombo do
    begin
      Name := 'ColorsCombo';
      SetBounds(81, 0, 233, 21);
      Style := csDropdownList;
      Parent := FColorsPanel;
      OnChange := ColorsComboChange;
    end;
  end;
end;

destructor TExportPictureDialog.Destroy;
begin
  FColorsCombo.Free;
  FColorsLabel.Free;
  FColorsPanel.Free;
  FPaletteList.Free;
  FPixelFormats.Free;
  inherited Destroy;
end;

procedure TExportPictureDialog.ColorsComboChange(Sender: TObject);
begin
  FPixelFormat := FPixelFormats.PixelFormat(TComboBox(Sender).ItemIndex);
end;

procedure TExportPictureDialog.PaletteListChange(Sender: TObject);
const
  AllowedFormats = [pf1bit, pf4bit, pf8bit, pf15bit, pf16bit, pf24bit, pf32bit];
var
  I, J, P, Index: Integer;
  S, N, V: string;
  F: TPixelFormat;
  L: TStringList;
  E: TPixelFormatEntry;
begin
  {    }
  FPixelFormats.FCount := 0;
  {    }
  for I := 0 to TStrings(Sender).Count - 1 do
  begin
    {   }
    S := TStrings(Sender)[I];
    {   }
    P := Pos('=', S);
    if P > 0 then
    begin
      {       }
      V := Copy(S, 1, P - 1);
      N := Copy(S, P + 1, MaxInt);
      F := TPixelFormat(GetEnumValue(TypeInfo(TPixelFormat), V));
      {   }
      if F in AllowedFormats then
        {   }
        with FPixelFormats do
        begin
          Index := ItemIndex(F);
          if Index = -1 then
          begin
            Index := FCount;
            FCount := FCount + 1;
          end;
          FItems[Index].Value := F;
          FItems[Index].Name := N;
        end;
    end;
  end;
  {    }
  with FPixelFormats do
    for I := 0 to FCount - 1 do
    begin
      Index := I;
      {     }
      for J := I + 1 to FCount - 1 do
        if FItems[Index].Value > FItems[J].Value then Index := J;
      {    }
      if Index <> I then
      begin
        E := FItems[I];
        FItems[I] := FItems[Index];
        FItems[Index] := E;
      end;
    end;
  {    }
  L := TStringList.Create;
  try
    {   }
    with FPixelFormats do
      for I := 0 to FCount - 1 do
      begin
        {   }
        V := GetEnumName(TypeInfo(TPixelFormat), Ord(FItems[I].Value));
        N := FItems[I].Name;
        S := Format('%s=%s', [V, N]);
        {    }
        L.Add(S);
      end;
    {   }
    with FPaletteList do
    begin
      OnChange := nil;
      try
        Assign(L);
      finally
        OnChange := PaletteListChange;
      end;
    end;
  finally
    L.Free;
  end;
end;

procedure TExportPictureDialog.SetPaletteList(Value: TStringList);
begin
  FPaletteList.Assign(Value);
end;

procedure TExportPictureDialog.DoClose;
begin
  inherited DoClose;
  { Hide any hint windows left behind }
  Application.HideHint;
end;

type
  THackWinControl = class(TWinControl);

procedure TExportPictureDialog.DoShow;
var
  ColorsRect: TRect;
begin
  {      }
  GetClientRect(Handle, ColorsRect);
  {      }
  ColorsRect.Top := GetStaticRect.Bottom - 7;
  {     }
  FColorsPanel.BoundsRect := ColorsRect;
  FColorsPanel.ParentWindow := Handle;
  {      }
  THackWinControl(FColorsPanel).ScaleControls(ColorsRect.Right - ColorsRect.Left, 420);
  {   }
  FColorsLabel.Caption := FPaletteLabel;
  {  }
  with FColorsCombo do
  begin
    Items.Assign(FPixelFormats);
    ItemIndex := FPixelFormats.ItemIndex(FPixelFormat);
  end;
  inherited DoShow;
end;

function TExportPictureDialog.Execute;
begin
  if NewStyleControls and not (ofOldStyleDialog in Options) then
    Template := 'EXDLGTEMPLATE'
  else
    Template := nil;
  Result := inherited Execute;
end;

{$ENDIF}

{ TSplashDialog }

constructor TSplashDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  {   }
  FPicture := TPicture.Create;
  FPicture.OnChange := PictureChange;
  {    }
  FAutoShow := True;
  FAutoHide := True;
end;

destructor TSplashDialog.Destroy;
begin
  {   }
  Hide;
  {   }
  FPicture.OnChange := nil;
  FPicture.Free;
  {  }
  FTimer.Free;
  {    }
  inherited Destroy;
end;

procedure TSplashDialog.AppIdle(Sender: TObject; var Done: Boolean);
begin
  {     }
  if HideDelay <= 1 then
  begin
    Hide;
    Exit;
  end;
  {    }
  FTimer := TTimer.Create(nil);
  FTimer.Interval := HideDelay * 1000;
  FTimer.OnTimer := HideTime;
end;

procedure TSplashDialog.DialogHide(Sender: TObject);
begin
  DoHide;
end;

procedure TSplashDialog.DialogShow(Sender: TObject);
begin
  DoShow;
end;

procedure TSplashDialog.HideTime(Sender: TObject);
begin
  Hide;
end;

procedure TSplashDialog.PictureChange(Sender: TObject);
begin
  if FAutoShow then Show;
end;

procedure TSplashDialog.PictureMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Hide;
end;

procedure TSplashDialog.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
end;

procedure TSplashDialog.DoHide;
begin
  if Assigned(FOnHide) then FOnHide(Self);
end;

procedure TSplashDialog.DoShow;
begin
  if Assigned(FOnShow) then FOnShow(Self);
end;

procedure TSplashDialog.Hide;
begin
  {      ,    }
  if FDialog <> nil then
  begin
    {    }
    if FAutoHide then Application.OnIdle := nil;
    {   }
    FDialog.Hide;
    {   }
    FDialog.Free;
    FDialog := nil;
  end;
end;

type
  TSplashForm = class(TForm)
  protected
    procedure WndProc(var Message: TMessage); override;
  end;

procedure TSplashForm.WndProc(var Message: TMessage);
begin
  if Message.Msg <> WM_CLOSE then inherited WndProc(Message);
end;

procedure TSplashDialog.Show;
var
  Style: Longint;
begin
  {       }
  if not (csDesigning in ComponentState) and (FDialog = nil) then
  begin
    {   }
    FDialog := TSplashForm.CreateNew(nil);
    {    }             
    with FDialog do
    begin
      {   }
      OnHide := DialogHide;
      OnShow := DialogShow;
      {    }
      AutoScroll := False;
      {     }              
      with TImage.Create(FDialog) do
      begin
        Parent := FDialog;
        Picture := FPicture;
        Autosize := True;
        {   }
        if HideOnClick then OnMouseDown := PictureMouseDown;
      end;
      {   }
      FormStyle := fsStayOnTop;
      Position := poScreenCenter;
      {   }
      case FBorderStyle of
        sbNone:
          {   }
          begin
            {  }
            BorderStyle := Forms.bsNone;
            {   }
            ClientWidth := FPicture.Width;
            ClientHeight := FPicture.Height;
          end;
        sbSingle:
          {    }
          begin
            {   }
            ClientWidth := FPicture.Width;
            ClientHeight := FPicture.Height;
            {  }
            BorderStyle := Forms.bsDialog;
            {   }
            Style := GetWindowLong(Handle, GWL_STYLE);
            SetWindowLong(Handle, GWL_STYLE, Style and (not WS_CAPTION));
            {   }
            Width := Width - (GetSystemMetrics(SM_CYFRAME) - 3) * 2;
            Height := Height - GetSystemMetrics(SM_CYCAPTION) - (GetSystemMetrics(SM_CYFRAME) - 3) * 2;
          end;
      end;
    end;
    {   }
    FDialog.Show;
    FDialog.Update;
    {      }
    if FAutoHide then Application.OnIdle := AppIdle;
  end;
end;

end.
