{
    

     

   . 
  E-mail: roman@sar.nnov.ru
}

unit Ex_File;

interface

{$I EX.INC}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ComCtrls, CommCtrl, Menus {$IFDEF EX_D4_UP}, ImgList {$ENDIF};

type
  TFileDialogForm = class(TForm)
    FolderLabel: TLabel;
    FolderCombo: TComboBox;
    UpButton: TSpeedButton;
    CreateButton: TSpeedButton;
    ListButton: TSpeedButton;
    ReportButton: TSpeedButton;
    FileList: TListView;
    NameLabel: TLabel;
    NameEdit: TEdit;
    TypeLabel: TLabel;
    TypeCombo: TComboBox;
    OpenButton: TButton;
    CancelButton: TButton;
    FileImages: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FolderComboDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure FolderComboDropDown(Sender: TObject);
    procedure FolderComboMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
    procedure FileListColumnClick(Sender: TObject; Column: TListColumn);
    procedure FileListDblClick(Sender: TObject);
    procedure ListButtonClick(Sender: TObject);
    procedure ReportButtonClick(Sender: TObject);
  private
    FFolderText: string;
    FSortDirect: Integer;
  public
    { Public declarations }
  end;

var
  FileDialogForm: TFileDialogForm;

implementation

{$R *.DFM}
{$R *.RES}

procedure TFileDialogForm.FormCreate(Sender: TObject);
begin
  FSortDirect := -1;
  {      }
  FileImages.ResourceLoad(rtBitmap, 'BM_FILEDLG', clFuchsia);
  {      }
  with UpButton do
  begin
    Width := 23;
    Height := 22;
{$IFDEF EX_D2}
    Layout := blGlyphTop;
    Spacing := -14;
{$ENDIF}
  end;
  with CreateButton do
  begin
    Left := UpButton.Left + 30;
    Width := 23;
    Height := 22;
{$IFDEF EX_D2}
    Layout := blGlyphTop;
    Spacing := -14;
{$ENDIF}
  end;
  with ListButton do
  begin
    Left := CreateButton.Left + 30;
    Width := 23;
    Height := 22;
{$IFDEF EX_D2}
    Layout := blGlyphTop;
    Spacing := -14;
{$ENDIF}
  end;
  with ReportButton do
  begin
    Left := ListButton.Left + 23;
    Width := 23;
    Height := 22;
{$IFDEF EX_D2}
    Layout := blGlyphTop;
    Spacing := -14;
{$ENDIF}
  end;
end;

procedure TFileDialogForm.FolderComboDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
const
  D = DT_SINGLELINE or DT_VCENTER or DT_CALCRECT;
var
  R: TRect;
  I: Integer;
  T: string;
begin
  {   }
  R := Rect;
  {  }
  with FolderCombo.Canvas do
  begin
    {   }
    Brush.Color := clWindow;
    FillRect(Rect);
    {    }
    R.Right := R.Left + FileImages.Width + 2;
    {    }
    with FolderCombo do
    begin
      {   }
      T := Items[Index];
      {       }
      if (not DroppedDown) or (T = FFolderText) then
        {    }
        if odFocused in State then
          I := 4
        else
          I := 2
      else
        {    }
        if odFocused in State then
          I := 3
        else
          I := 1;
    end;
    {   }
    FileImages.Draw(FolderCombo.Canvas, R.Left + 2, R.Top, I);
    {     }
    if odFocused in State then
    begin
      Brush.Color := clHighlight;
      Font.Color := clHighlightText
    end else
    begin
      Brush.Color := clWindow;
      Font.Color := Font.Color;
    end;
    {    }
    R.Left := R.Right + 4;
    R.Right := Rect.Right;
    DrawText(Handle, PChar(T), Length(T), R, D);
    {  }
    R.Right := R.Right + 2;
    R.Bottom := R.Bottom + 2;
    {   }
    FillRect(R);
    TextRect(R, R.Left + 1, R.Top + 1, T);
    {         }
    if odFocused in State then
    begin
      DrawFocusRect(Rect);
      DrawFocusRect(R);
    end;
  end;
end;

procedure TFileDialogForm.FolderComboDropDown(Sender: TObject);
begin
  FFolderText := FolderCombo.Text;
end;

procedure TFileDialogForm.FolderComboMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
begin
  Height := Canvas.TextHeight('W') + 3;
end;

function CustomSortProc(Item1, Item2: TListItem; ParamSort: integer): Integer; stdcall;

  function Compare(const S1, S2: string): Integer;
  begin
    Result := AnsiCompareStr(S1, S2) * TFileDialogForm(Item1.Owner.Owner.Owner).FSortDirect;
  end;

begin
  Result := 0;
  {    }
  if ParamSort > 0 then
  try
    Result := Compare(Item1.Subitems[ParamSort - 1], Item2.Subitems[ParamSort - 1]);
  except
    {   }                                            
  end;
  {    }
  if Result = 0 then Result := Compare(Item1.Caption, Item2.Caption);
end;

procedure TFileDialogForm.FileListColumnClick(Sender: TObject; Column: TListColumn);
begin
  FSortDirect := FSortDirect * -1;
  FileList.CustomSort(@CustomSortProc, Column.Index);
end;

procedure TFileDialogForm.FileListDblClick(Sender: TObject);
begin
  if FileList.Selected <> nil then OpenButton.Click;
end;

procedure TFileDialogForm.ListButtonClick(Sender: TObject);
begin
  FileList.ViewStyle := vsList;
  ListButton.Down := True;
end;

procedure TFileDialogForm.ReportButtonClick(Sender: TObject);
begin
  FileList.ViewStyle := vsReport;
  ReportButton.Down := True;
end;

end.
