{
    

     Delphi IDE

   . 
  E-mail: roman@sar.nnov.ru
}

unit Ex_Reg;

interface

uses
  Windows, SysUtils, Classes, Forms, Dialogs, DsgnIntf;

type

{ TDialogEditor }

  TDialogEditor = class(TDefaultEditor)
  protected
    procedure Test; virtual;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

{ TIconDialogEditor }

  TIconDialogEditor = class(TDialogEditor)
  protected
    procedure Test; override;
  end;

{ TAboutDialogEditor }

  TAboutDialogEditor = class(TDialogEditor)
  protected
    procedure Test; override;
  end;

{ TFolderDialogEditor }

  TFolderDialogEditor = class(TDialogEditor)
  protected
    procedure Test; override;
  end;

{ TFileDialogEditor }

  TFileDialogEditor = class(TDialogEditor)
  protected
    procedure Test; override;
  end;

{ TIconFileProperty }

  TIconFileProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

{ TLogFileProperty }

  TLogFileProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;

implementation

uses
  Ex_Controls, Ex_Dialogs;

{ TDialogEditor }

procedure TDialogEditor.Test;
begin
end;

procedure TDialogEditor.ExecuteVerb(Index: Integer);
begin
  if Index = 0 then Test;
end;

function TDialogEditor.GetVerb(Index: Integer): AnsiString;
begin
  Result := 'Execute dialog...';
end;

function TDialogEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TIconDialogEditor }

procedure TIconDialogEditor.Test;
begin
  if (Component as TIconDialog).Execute then Designer.Modified;
end;

{ TAboutDialogEditor }

procedure TAboutDialogEditor.Test;
begin
  if (Component as TAboutDialog).Execute then Designer.Modified;
end;

{ TFolderDialogEditor }

procedure TFolderDialogEditor.Test;
begin
  if (Component as TFolderDialog).Execute then Designer.Modified;
end;

{ TFileDialogEditor }

procedure TFileDialogEditor.Test;
begin
  if (Component as TFileDialog).Execute then Designer.Modified;
end;

{ TIconFileProperty }

procedure TIconFileProperty.Edit;
begin
  with TOpenDialog.Create(nil) do
  try
    {      }
    DefaultExt := 'exe';
    FileName := GetValue;
    Filter := '  |*.exe;*.dll;*.cpl;*.ico;*.cur;*.ani|' +
      ' (*.exe)|*.exe| (*.dll)|*.dll|' +
      '   (*.cpl)|*.cpl| (*.ico)|*.ico|' +
      ' (*.cur)|*.cur|  (*.ani)|*.ani|' +
      '  (*.*)|*.*';
    Options := [ofHideReadOnly, ofPathMustExist, ofFileMustExist];
    {   }
    if Execute then
    begin
      SetValue(FileName);
      Modified;
    end;
  finally
    Free;
  end;
end;

function TIconFileProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog];
end;

{ TLogFileProperty }

procedure TLogFileProperty.Edit;
begin
  with TOpenDialog.Create(nil) do
  try
    {      }
    FileName := '';
    Filter := '  (*.log)|*.log|  (*.txt)|*.txt|  (*.*)|*.*';
    Options := [ofHideReadOnly, ofPathMustExist, ofFileMustExist];
    {   }
    if Execute then
    begin
      SetValue(FileName);
      Modified;
    end;
  finally
    Free;
  end;
end;

function TLogFileProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog];
end;

procedure Register;
begin
  RegisterComponents('Extended', [TFormSizer]);
  RegisterComponents('Extended', [TFormPlacement]);
  RegisterComponents('Extended', [TFormPreventer]);
  RegisterComponents('Extended', [TFormHook]);
  RegisterComponents('Extended', [TFormEdge]);

  RegisterComponents('Extended', [TAppPreventer]);
  RegisterComponents('Extended', [TAppHook]);
  RegisterComponents('Extended', [TAppInstance]);
  RegisterComponents('Extended', [TAppHelp]);

  RegisterComponents('Extended', [TSplitPanel]);

  RegisterComponents('Extended', [TTrayIcon]);
  RegisterComponents('Extended', [TThreadedTimer]);

  RegisterComponents('Extended', [TCheckList]);
  RegisterComponents('Extended', [TCheckTree]);

  RegisterComponents('Extended', [TIconBox]);
  RegisterComponents('Extended', [TIconDialog]);

  RegisterComponents('Extended', [TAboutDialog]);
  RegisterComponents('Extended', [TFolderDialog]);
  RegisterComponents('Extended', [TFileDialog]);
  RegisterComponents('Extended', [TExportPictureDialog]);
  RegisterComponents('Extended', [TSplashDialog]);

  RegisterComponents('Extended', [TRecentFileList]);

  RegisterComponents('Extended', [TListButton]);
  RegisterComponents('Extended', [TButtonStyler]);
  RegisterComponents('Extended', [TUpDownBox]);

  RegisterComponents('Extended', [TLogView]);

  RegisterComponentEditor(TIconDialog, TIconDialogEditor);
  RegisterComponentEditor(TAboutDialog, TAboutDialogEditor);
  RegisterComponentEditor(TFolderDialog, TFolderDialogEditor);
  RegisterComponentEditor(TFileDialog, TFileDialogEditor);

  RegisterPropertyEditor(TypeInfo(string), TIconBox, 'IconFile', TIconFileProperty);
  RegisterPropertyEditor(TypeInfo(string), TIconDialog, 'IconFile', TIconFileProperty);

  RegisterPropertyEditor(TypeInfo(string), TLogView, 'FileName', TLogFileProperty);
end;

end.
