{
   "" 
   1997-2000 

   

   . 
  E-mail: roman@sar.nnov.ru
}

unit ExtUtils;

interface

{$B-} // Complete Boolean expression evaluation
{$X+} // Delphi's extended syntax
{$H+} // Long strings
{$P+} // Open strings parameters

{$IFDEF VER130}                             
  {$DEFINE EX_D5}    // Delphi 5.0
  {$DEFINE EX_D5_UP}
  {$DEFINE EX_D4_UP}
  {$DEFINE EX_D3_UP}
  {$DEFINE EX_D2_UP}
{$ENDIF}

{$IFDEF VER120}
  {$DEFINE EX_D4}    // Delphi 4.0
  {$DEFINE EX_D4_UP}
  {$DEFINE EX_D3_UP}
  {$DEFINE EX_D2_UP}
{$ENDIF}

{$IFDEF VER100}
  {$DEFINE EX_D3}    // Delphi 3.0
  {$DEFINE EX_D3_UP}
  {$DEFINE EX_D2_UP}
{$ENDIF}

{$IFDEF VER90}
  {$DEFINE EX_D2}    // Delphi 2.0
{$ENDIF}

uses
  Windows, ShellAPI, ShlObj, Messages, SysUtils, Classes, Controls,
  Graphics, Forms, Registry, RegStr, IniFiles, Math, StdCtrls, ExtCtrls;

{                                               
        
}

type

  { WndProc hook record }

  TWndHook = record
    Control: TWinControl; { ,    Hook }
    Handle: THandle;      {  ,    Hook }
    WndProc: TWndMethod;  {     }
    Instance: Pointer;    {  }
    OldProc: Longint;     {  }
  end;

{ Hook WndProc of specified window. }

function CreateWndHook(Control: TWinControl; Handle: THandle; WndProc: TWndMethod): TWndHook;

{ Hook Application WndProc. }

function CreateAppHook(WndProc: TWndMethod): TWndHook;

{ Clear window hook, restore old WndProc. }

procedure FreeWndHook(var Hook: TWndHook);

{ Calling previos WndProc. }

procedure CallWndHook(var Hook: TWndHook; var Message: TMessage);

{   ,    . }

function HookHandle(Hook: TWndHook): THandle;

{ ,    . }

function HookAllocated(Hook: TWndHook): Boolean;

{
        
}

{   . }

function StartProcess(const Command, Params, CurrentDir: string): Boolean;
function StartProcessEx(const Command, Params, CurrentDir: string; var Process: TProcessInformation): Boolean;

{  .   ThreadID   ,  
      ,   
  WM_CLOSE (  Delphi )  WM_QUIT.    ,
        $FFFFFFFF. }

function StopProcess(Process: TProcessInformation; TimeOut: DWORD; AllowTerminate: Boolean): Boolean;
function StopProcessID(ProcessID, ThreadID: DWORD; TimeOut: DWORD; AllowTerminate: Boolean): Boolean;

{      . }

function TerminateProcessID(ProcessID: DWORD): Boolean;

{   . }

function CloseProcessHandles(Process: TProcessInformation): Boolean;

{    . }

function WaitProcess(Process: TProcessInformation; Timeout: DWORD): Boolean;
function WaitProcessID(ProcessID: DWORD; Timeout: DWORD): Boolean;

{   .   , 
         }

function IsValidProcessID(ProcessID: DWORD): Boolean;

{
        
}

{   . }

{$IFDEF EX_D4_UP}
function FileSize(const FileName: string): Int64;
{$ELSE}
function FileSize(const FileName: string): Longint;
{$ENDIF}

{   . ,   ,   
     *?"<>|      ":"   
      (..    ).     
  "."  "..",        . }

function IsValidFileName(const Name: string): Boolean;

{     . }

function IsFolder(const Name: string): Boolean;

{      . }

function IsFloppy(const Name: string): Boolean;

{    . }

function IsFolderEmpty(const Name: string; Mask: string): Boolean;

{     . }

function DirectoryExists(const Name: string): Boolean;

{      . }

function ForceDirectories(Dir: string): Boolean;

{      .    .
        . }

function GetFileList(const Path: string; Strings: TStrings): Integer;

{   BAK   .    
   :   ,    
   "~",       
  . ,   FileUtils.pas  BAK  
  FileUtils.~pas }

function ExtractBakName(const FileName: string): string;

{    .     ,
      ExtractBakName.  
     }

function CreateBakFile(const FileName: string): Boolean;

{   .     CopyName  , 
   . }

function CreateFileCopy(const FileName, CopyName: string): Boolean;

{        . 
      ,      
  .     C:\...\Name.exe }

function CompressFilePath(const Path: string; Len: Integer): string;

{        DOS. }

function GetLongFileName(const ShortName: string): string;

{     (  )    DOS. }

function GetLongPathName(const ShortName: string): string;

{       .  
       Prefix. :  
        Windows API,
         3 . }

function GetTemporaryFileName(const BaseFileName, Prefix: string): string;
function GetTemporaryFileNameEx(const BaseFileName, Prefix: string; const DefDir: string): string;

{         . }

function ExtractFileNameEx(const FileName: string; IncludeExtension: Boolean): string;

{   ,    .   
      "".       ,
       .      
  *.* (..     ). }

function UpdateFileStr(const S: string; const DefPath, DefMask: string): string;

{
        
}

{       :\\, ( 
       ). }

function ExtractIconFile(const IconPath: string): string;
function ExtractIconIndex(const IconPath: string): Integer;
function ExpandIconPath(const IconFile: string; IconIndex: Integer): string;

{        :\\, (,
     ). }

function LoadIconFromFile(const IconPath: string): HICON;

function LoadLargeIconFromFile(const IconPath: string): HICON;
function LoadSmallIconFromFile(const IconPath: string): HICON;

{
         
}

{    .      ,
     . }

function StrToTimeDef(const S: string; Default: TDateTime): TDateTime;

{    .      ,
     . }

function StrToDateDef(const S: string; Default: TDateTime): TDateTime;

{      (Delphi  
      ). }

procedure FixRussianMonthNames;

{    . }

procedure RestoreDefaultMonthNames;

{    .    . }

function MSecToStr(Time: Longint): string;
function MSecToStrFmt(Time: Longint; const Format: string): string;

{     Unix. }

function UnixTimeToDateTime(UnixTime: Longint): TDateTime;
function DateTimeToUnixTime(DateTime: TDateTime): Longint;

{
        
}

{   Substr   S.   MatchCase  
  False,       . }

function CasePos(Substr: string; S: string; MatchCase: Boolean): Integer;

{    S  C1   C2. }

function ReplaceChar(const S: string; C1, C2: Char): string;

{    S  ,    C1   C2. }

function ReplaceChars(const S: string; C1: array of Char; C2: Char): string;

{    S    S1   S2. 
       . }

function ReplaceStr(const S: string; S1, S2: string): string;

{       S  S1   S2.
       S1    
   . }

function ReplaceStrEx(const S: string; S1, S2: string; ReplaceAll, MatchCase: Boolean): string;

{    S  ,    C. }

function RemoveChars(const S: string; C: array of Char): string;

{     .    
  . }

function RemoveLineBreaks(const S: string): string;

{     . }

function RemoveDoubleSpace(const S: string): string;

{       S   C. }

function TrimChar(const S: string; C: Char): string;

{     S   C. }

function TrimCharLeft(const S: string; C: Char): string;

{     S   C. }

function TrimCharRight(const S: string; C: Char): string;

{   S   C   Len. }

function InsertCharLeft(const S: string; C: Char; Len: Integer): string;

{   S   C   Len. }

function InsertCharRight(const S: string; C: Char; Len: Integer): string;

{   S    MaxLen.    
   ,     . }

function TruncLeft(const S: string; MaxLen: Integer): string;

{   S    MaxLen.    
   ,     . }

function TruncRight(const S: string; MaxLen: Integer): string;

{     (Exception): 
   ,    . }

function ExceptionMsg(E: Exception): string;

{        
   =.     
      StringList. }

function ExtractParamName(const S: string; Delimiter: Char): string;
function ExtractParamValue(const S: string; Delimiter: Char): string;

{    . }

function StringsEqual(List: array of string; MatchCase: Boolean): Boolean;

{         . }

function StringsEmpty(List: array of string): Boolean;

{       . }

function GetLineCount(const S: string): Integer;

{$IFDEF EX_D2}

{ Returns the smallest and largest value in the data array (MIN/MAX) }

function MinIntValue(const Data: array of Integer): Integer;
function MaxIntValue(const Data: array of Integer): Integer;

type
  TIdentMapEntry = record
    Value: Integer;
    Name: String;
  end;

function IdentToInt(const Ident: string; var Int: Longint; const Map: array of TIdentMapEntry): Boolean;
function IntToIdent(Int: Longint; var Ident: string; const Map: array of TIdentMapEntry): Boolean;

{$ENDIF}

{   Ident       
    Map.      ,
      Default. }

function IdentToIntDef(const Ident: string; Default: Longint; const Map: array of TIdentMapEntry): Longint;

{   Int       
    Map.      ,
      Default. }

function IntToIdentDef(Int: Longint; const Default: string; const Map: array of TIdentMapEntry): string;

{    Name   Map.  
    ,    . }

function GetIdentNameIndex(const Name: string; const Map: array of TIdentMapEntry): Integer;
function GetIdentNameIndexDef(const Name: string; DefIndex: Integer; const Map: array of TIdentMapEntry): Integer;

{    Value   Map.     ,
     . }

function GetIdentValueIndex(Value: Longint; const Map: array of TIdentMapEntry): Integer;
function GetIdentValueIndexDef(Value: Longint; DefIndex: Integer; const Map: array of TIdentMapEntry): Integer;

{      Map. 
       Proc     Map.
      . }

function GetIdentsList(const Map: array of TIdentMapEntry; Proc: TGetStrProc): Integer;

{   Strings    Map. }

function GetIdentsStringList(const Map: array of TIdentMapEntry; Strings: TStrings): Integer;

{
         TWinControl
}

{        . }

procedure InitControlHandle(Control: TWinControl; Recurse: Boolean);

{       . }

function IsControlVisible(Control: TWinControl): Boolean;

{        . }

function InvalidateControl(Control: TWinControl): Boolean;
function InvalidateControlRect(Control: TWinControl; Rect: TRect; Erase: Boolean): Boolean;

{
          Ini 
}

{      INI   StringList.  
    =. }

procedure IniReadSection(const FileName, Section: string; Strings: TStrings);

{       StringList    INI
  .        =. }

procedure IniWriteSection(const FileName, Section: string; Strings: TStrings);

{          }

procedure RegEraseKey(Root: HKEY; const Key: string);
procedure RegEraseKeyEx(Root: HKEY; const Key: string; SubKeys: Boolean);

{     . }

procedure RegEraseSubKeys(Root: HKEY; const Key: string);

{        StringList. 
     =. }

procedure RegReadKey(Root: HKEY; const Key: string; Strings: TStrings);

{       StringList    .
         =. }

procedure RegWriteKey(Root: HKEY; const Key: string; Strings: TStrings);

{       .    Strings
     ,    
    ,      (..  
      ).  }

procedure RegMergeKeys(Root: HKEY; const Keys: array of string; Strings: TStrings);

{     . :    
    . }

procedure RegImport(const FileName: string);
procedure RegExport(Root: HKEY; const Key: string; const FileName: string);

{          ( "\\"  "\"). }

function StrToRegStr(const Value: string): string;
function RegStrToStr(const Value: string): string;

{    (HKEY_XXX) - . }

function RegRootKeyToStr(Root: HKEY): string;
function RegStrToRootKey(const S: string): HKEY;
function RegStrToRootKeyDef(const S: string; Default: HKEY): HKEY;

{
          Windows
}

{      . }

function ShutDownComputer(const Message: string; Delay: Longint; Reboot: Boolean): Boolean;

{      Windows.  
  WinAPI,    ,     
   . }

function GetCompName: string;
function GetCompUser: string;

{
        
}

{     . ,  
  ,        
  . }

function ParamExists(const Param: string): Boolean;

{   .  ,   
   . ,   -F   
   -FAppUtils.pas   AppUtils.pas }

function GetParamValue(const Param: string): string;
function GetParamValueDef(const Param: string; const Default: string): string;

{   API  MessageBox.   
      . }

function CreateAppMessageBox(const AText, ACaption: string; Flags: Longint): TForm;

function AppMessageBox(const Text, Caption: string; Flags: Longint): Integer;
function AppMessageBoxFmt(const TextFormat, Caption: string; Flags: Longint; const Args: array of const): Integer;

{  ( Delay  TP).  ~5 .   
        CallBack, 
     (   )  
  ,      . }

type
  TDelayProc = procedure(var Cancel: Boolean) of object;

procedure AppDelay(TimeOut: Longint);
procedure AppDelayEx(TimeOut: Longint; AppTerminate, AppMessages: Boolean; DelayCursor: HCURSOR; DelayProc: TDelayProc);

{  .exe    ( ). }

function AppExeName: string;

{   .    .
   Delphi  3.0      TScreen.SetCursor:  
    crDefault     
     .     
  ""  ,        . }

function SetScreenCursor(Value: TCursor): TCursor;

{
     
}

{      .     Key
   ,    .

       Key:

    CompanyName - 
    FileDescription -  
    FileVersion -  
    InternalName -  
    LegalCopyright -  ( )
    LegalTrademarks -  
    OriginalFilename -   
    ProductName -  
    ProductVersion -  
    Comments - 
}

function GetVersionStr(const FileName, Key, Default: string): string;

{
      WinAPI
}

{     ,     Windows
  (   ).   
    (Windows  poDefault   
       ). }

function GetDefFormPos: TPoint;
function GetDefFormBounds(Width, Height: Integer): TRect;

{ /   " "  
    .      
    " ". :    FormStyle. }

procedure SetTopMostWindow(Wnd: HWND; TopMost, Activate: Boolean);

{ ,      " ". }

function IsTopMostWindow(Wnd: HWND): Boolean;

{    .     ,
     " <>". }

function GetSystemErrorStr(Error: Integer; const Params: array of const): string;
function GetLastErrorStr(const Params: array of const): string;

{
        
}

{     50%     
  Handle.       (
   ,  ). }

procedure PaintResizeRect(Handle: THandle; Rect: TRect);

{      (    ). }

procedure PaintBtnFrame(DC: HDC; Rect: TRect; Pressed: Boolean);
procedure PaintBtnFrameEx(DC: HDC; Rect: TRect; Pressed: Boolean; SideFlags: Integer);

{     ( -   
  ,  - ) }

procedure PaintBtnComboBox(DC: HDC; Rect: TRect; Pressed: Boolean);
procedure PaintBtnComboBox2(DC: HDC; Rect: TRect; Pressed: Boolean);

{     }

procedure PaintBtnEllipsis(DC: HDC; Rect: TRect; Pressed: Boolean);

{     Canvas.TextHeight }

function GetFontHeight(Font: TFont): Integer;

{
         
}

{  ()    . 
    MaxFileCount    ,
     . }

function GetNextArchiveIndex(const Folder, Prefix, Ext: string; MaxFileCount: Integer): Integer;

{       .  
    : PrefixXXXXXXXX.Ext,  Prefix -  ,
  XXXXXXXX -   (  ), Ext - . }

function FormatArchiveFileName(const Folder, Prefix, Ext: string; Index: Integer): string;

{          . }

function FormatArchiveDateTime(DateTime: TDateTime): string;

{         .
          .
  !        
  .       Values 
  Lengths. }

procedure FormatArchiveBuff(const Values: array of string; const Lengths: array of Integer; Buff: Pointer; Size: Integer);
procedure FormatArchiveStr(const Values: array of string; const Lengths: array of Integer; var S: string);

implementation

uses
  Consts;

function CreateWndHook(Control: TWinControl; Handle: THandle; WndProc: TWndMethod): TWndHook;
begin
  {   }
  Result.Control := Control;
  {    }
  if Assigned(Control) then
  begin
    InitControlHandle(Control, True);
    Result.Handle := Control.Handle;
  end
  else
    Result.Handle := Handle;
  {     }
  Result.WndProc := WndProc;
  Result.Instance := MakeObjectInstance(WndProc);
  {   }
  Result.OldProc := SetWindowLong(Result.Handle, GWL_WNDPROC, Longint(Result.Instance));
end;

function CreateAppHook(WndProc: TWndMethod): TWndHook;
begin
  Result := CreateWndHook(nil, Application.Handle, WndProc);
end;

procedure FreeWndHook(var Hook: TWndHook);
var
  H: THandle;
begin
  with Hook do
  begin
    {   }
    H := HookHandle(Hook);
    {   }
    if H <> INVALID_HANDLE_VALUE then
    begin
      {     }
      if OldProc <> 0 then
      begin
        SetWindowLong(H, GWL_WNDPROC, OldProc);
        OldProc := 0;
      end;
      {   }
      Handle := INVALID_HANDLE_VALUE;
    end;
    {    }
    if Instance <> nil then
    begin
      FreeObjectInstance(Instance);
      Instance := nil;
    end;
    {    }
    WndProc := nil;
    Control := nil;
  end;
end;

type
  THackControl = class(TWinControl);

procedure CallWndHook(var Hook: TWndHook; var Message: TMessage);
var
  H: THandle;
  P: Pointer;
begin
  with Hook, Message do
  begin
    {   }
    H := HookHandle(Hook);
    {   }
    if H <> INVALID_HANDLE_VALUE then
    begin
      {    (    ) }
      P := Pointer(OldProc);
      {      }
      if (Msg = WM_DESTROY) or (Msg = CM_RELEASE) then FreeWndHook(Hook);
      {    }
      if Assigned(P) then
        Result := CallWindowProc(P, H, Msg, wParam, lParam)
      else if Control <> nil then
        Result := CallWindowProc(THackControl(Control).DefWndProc, H, Msg, wParam, lParam)
      else
        DefWindowProc(H, Msg, wParam, lParam);
    end;
  end;
end;

function HookHandle(Hook: TWndHook): THandle;
begin
  with Hook do
    if Control = nil then
      {   - ,   }
      Result := Handle
    else if Control.HandleAllocated then
      {       -   }
      Result := Control.Handle
    else
      {   }
      Result := INVALID_HANDLE_VALUE;
end;

function HookAllocated(Hook: TWndHook): Boolean;
begin
  Result := Hook.Instance <> nil;
end;

{    }

function StartProcess(const Command, Params, CurrentDir: string): Boolean;
var
  Process: TProcessInformation;
begin
  if not StartProcessEx(Command, Params, CurrentDir, Process) then
  begin
    Result := False;
    Exit;
  end;
  Result := CloseProcessHandles(Process);
end;

function StartProcessEx(const Command, Params, CurrentDir: string; var Process: TProcessInformation): Boolean;
var
  CmdLine: string;
  Startup: TStartupInfo;

  function CurrentDirPtr: PChar;
  begin
    if Length(CurrentDir) <> 0 then Result := PChar(CurrentDir) else Result := nil;
  end;

begin
  {   }
  CmdLine := Trim(Format('"%s" %s', [Command, Params]));
  {   STARTUPINFO }
  FillChar(Startup, SizeOf(TStartupInfo), 0);
  with Startup do
  begin
    cb := SizeOf(TStartupInfo);
    dwFlags := STARTF_FORCEONFEEDBACK;
  end;
  {   }
  Result := CreateProcess(nil, PChar(CmdLine), nil, nil, False, 0, nil,
    CurrentDirPtr, Startup, Process);
end;

function DoCloseAppWindow(Window: HWND; Data: lParam): BOOL; stdcall;
var
  AppClass: array[0..255] of Char;
  WndClass: array[0..255] of Char;
begin
  if IsWindowEnabled(Window) then
  begin
    {      (    ;) }
    if GetWindow(Window, GW_OWNER) = 0 then
    begin
      {    }
      FillChar(WndClass, SizeOf(WndClass), 0);
      if GetClassName(Window, WndClass, 255) <> 0 then
      begin
        FillChar(AppClass, SizeOf(AppClass), 0);
        AppClass := 'TApplication';
        {      }
        if StrLComp(WndClass, AppClass, 255) = 0 then
          {      }
          if PostMessage(Window, WM_CLOSE, 1, 0) then Inc(PLongint(Data)^);
      end;
    end;
  end;
  Result := True;
end;

{   }

{$IFDEF EX_D2}

const
  PROCESS_QUERY_INFORMATION = $0400;
  PROCESS_ALL_ACCESS        = (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or $FFF);

{$ENDIF}  

function DoStopProcess(hProcess: THandle; ThreadID: DWORD; TimeOut: DWORD; AllowTerminate: Boolean): Boolean;
var
  CloseCount: Longint;
begin
  {    }
  if ThreadID <> 0 then
  begin
    CloseCount := 0;
    {      WM_CLOSE }
    EnumThreadWindows(ThreadID, @DoCloseAppWindow, lParam(@CloseCount));
    {  }
    if WaitForSingleObject(hProcess, TimeOut) = WAIT_OBJECT_0 then
    begin
      Result := True;
      Exit;
    end;
    {     WM_CLOSE  ,    
      ,     ,   WM_QUIT }
    if (CloseCount = 0) or AllowTerminate then
    begin
      PostThreadMessage(ThreadID, WM_QUIT, 0, 0);
      {   }
      if WaitForSingleObject(hProcess, TimeOut) = WAIT_OBJECT_0 then
      begin
        Result := True;
        Exit;
      end;
    end;
  end;
  {      ,    }
  if AllowTerminate and (not TerminateProcess(hProcess, UINT(-1))) then
  begin
    Result := False;
    Exit;
  end;
  {  }
  Result := not IsValidProcessID(hProcess);
end;

function StopProcess(Process: TProcessInformation; TimeOut: DWORD; AllowTerminate: Boolean): Boolean;
begin
  Result := DoStopProcess(Process.hProcess, Process.dwThreadID, TimeOut, AllowTerminate);
end;

function StopProcessID(ProcessID, ThreadID: DWORD; TimeOut: DWORD; AllowTerminate: Boolean): Boolean;
var
  Handle: THandle;
begin
  Handle := OpenProcess(PROCESS_ALL_ACCESS, False, ProcessID);
  try
    Result := DoStopProcess(Handle, ThreadID, TimeOut, AllowTerminate);
  finally
    CloseHandle(Handle);
  end;
end;

{       }

function TerminateProcessID(ProcessID: DWORD): Boolean;
var
  Handle: THandle;
begin
  Handle := OpenProcess(PROCESS_ALL_ACCESS, False, ProcessID);
  try
    Result := TerminateProcess(Handle, UINT(-1));
  finally
    CloseHandle(Handle);
  end;
end;

{    }

function CloseProcessHandles(Process: TProcessInformation): Boolean;
var
  T, P: Boolean;
begin
  {   }
  T := CloseHandle(Process.hThread);
  P := CloseHandle(Process.hProcess);
  {  }
  Result := T and P;
end;

{     }

function DoWaitProcess(hProcess: THandle; TimeOut: DWORD): Boolean;
begin
  Result := WaitForSingleObject(hProcess, Timeout) = WAIT_OBJECT_0;
end;

function WaitProcess(Process: TProcessInformation; Timeout: DWORD): Boolean;
begin
  Result := DoWaitProcess(Process.hProcess, Timeout);
end;

function WaitProcessID(ProcessID: DWORD; Timeout: DWORD): Boolean;
var
  Handle: THandle;
begin
  Handle := OpenProcess(PROCESS_ALL_ACCESS, False, ProcessID);
  try
    Result := DoWaitProcess(Handle, Timeout);
  finally
    CloseHandle(Handle);
  end;
end;

{    }

function IsValidProcessID(ProcessID: DWORD): Boolean;
var
  Handle: THandle;
  ExitCode: DWORD;
begin
  {      }
  if ProcessID = 0 then
  begin
    Result := False;
    Exit;
  end;
  {   }
  Handle := OpenProcess(PROCESS_QUERY_INFORMATION, False, ProcessID);
  try
    {      }
    if not GetExitCodeProcess(Handle, ExitCode) then
    begin
      Result := False;
      Exit;
    end;
    { ,     }
    Result := ExitCode = STILL_ACTIVE;
  finally
    CloseHandle(Handle);
  end;
end;

{    }

{$IFDEF EX_D4_UP}
function FileSize(const FileName: string): Int64;
{$ELSE}
function FileSize(const FileName: string): Longint;
{$ENDIF}
var
  Handle: Integer;
begin
  Handle := FileOpen(FileName, fmOpenRead or fmShareDenyNone);
  if Handle < 0 then
  begin
    Result := 0;
    Exit;
  end;
  try
    Result := FileSeek(Handle, 0, 2);
  finally
    FileClose(Handle);
  end;
end;

{    }

function IsValidFileName(const Name: string): Boolean;
const
  C: string = '*?"<>|';
var
  I, P: Integer;
begin
  P := Pos(':', Name);
  if (P <> 0) and (P <> 2) then
  begin
    Result := False;
    Exit;
  end;
  for I := 1 to Length(C) do
  begin
    P := Pos(C[I], Name);
    if P <> 0 then
    begin
      Result := False;
      Exit;
    end;
  end;
  if (Name = '.') or (Name = '..') then { ! only for this release }
  begin
    Result := False;
    Exit;
  end;
  Result := True;
end;

{      }

function IsFolder(const Name: string): Boolean;
var
  SR: TSearchRec;
begin
  Result := False;
  if FindFirst(TrimCharRight(Name, '\'), faDirectory, SR) = 0 then
  try
    Result := SR.Attr and faDirectory <> 0;
  finally
    FindClose(SR);
  end;
end;

{       }

function IsFloppy(const Name: string): Boolean;
var
  Info: TSHFileInfo;
begin
  SHGetFileInfo(PChar(Name), 0, Info, SizeOf(Info), SHGFI_ATTRIBUTES);
  Result := Info.dwAttributes and SFGAO_REMOVABLE <> 0;
end;

{     }

function IsFolderEmpty(const Name: string; Mask: string): Boolean;
var
  Info: TSHFileInfo;
  SR: TSearchRec;
begin
  SHGetFileInfo(PChar(Name), 0, Info, SizeOf(Info), SHGFI_ATTRIBUTES);
  if Info.dwAttributes and SFGAO_HASSUBFOLDER <> 0 then
  begin
    Result := False;
    Exit;
  end;
  if FindFirst(Name + Mask, faAnyFile and not faSysFile, SR) = 0 then
  try
    Result := False;
    Exit;
  finally
    FindClose(SR);
  end;
  Result := True;
end;

{      }

function DirectoryExists(const Name: string): Boolean;
var
  Code: DWORD;
begin
  Code := GetFileAttributes(PChar(Name));
  Result := (Code <> $FFFFFFFF) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;

{       }

function ForceDirectories(Dir: string): Boolean;
begin
  {   }
  if Length(Dir) = 0 then
  begin
    Result := False;
    Exit;
  end;
  {  "\"    }
  Dir := TrimCharRight(Dir, '\');
  {      }
  if (Length(Dir) < 3) or DirectoryExists(Dir) or (ExtractFilePath(Dir) = Dir) then
  begin
    Result := True;
    Exit;
  end;
  {    }
  if not ForceDirectories(ExtractFilePath(Dir)) then
  begin
    Result := False;
    Exit;
  end;
  {   }
  Result := CreateDir(Dir);
end;

{       }

function GetFileList(const Path: string; Strings: TStrings): Integer;
const
  Attr = faAnyFile and (not faSysFile) and (not faDirectory);
var
  SR: TSearchRec;
begin
  {      }
  if FindFirst(Path, Attr, SR) = 0 then
  try
    {  ,     }
    repeat
      if IsValidFileName(SR.Name) then Strings.Add(SR.Name);
    until FindNext(SR) <> 0;
  finally
    FindClose(SR);
  end;
  {    }
  Result := Strings.Count;
end;

{   BAK  }

function ExtractBakName(const FileName: string): string;
var
  Ext: string;
  I: Integer;
begin
  {    }
  I := Length(FileName);
  while (I > 0) and not (FileName[I] in ['.', '\', ':']) do Dec(I);
  {   }
  if (I > 0) and (FileName[I] = '.') then
  begin
    Ext := Copy(FileName, I + 1, 255);
    Result := Copy(FileName, 1, I - 1) + '.~' + Ext;
  end
  else
    Result := FileName + '.~';
end;

{     }

function CreateBakFile(const FileName: string): Boolean;
var
  BakName: string;
begin
  {    }
  BakName := ExtractBakName(FileName);
  {     }
  if FileExists(BakName) and (not DeleteFile(BakName)) then
  begin
    Result := False;
    Exit;
  end;
  {   }
  if FileExists(FileName) and (not RenameFile(FileName, BakName)) then
  begin
    Result := False;
    Exit;
  end;
  {    }
  Result := True;
end;

{    }

function CreateFileCopy(const FileName, CopyName: string): Boolean;
begin
  {     }
  if FileExists(CopyName) and (not DeleteFile(CopyName)) then
  begin
    Result := False;
    Exit;
  end;
  {    }
  if FileExists(FileName) and (not CopyFile(PChar(FileName), PChar(CopyName), False)) then
  begin
    Result := False;
    Exit;
  end;
  {    }
  Result := True;
end;

{         }

function CompressFilePath(const Path: string; Len: Integer): string;
var
  L, I, P1, P2: Integer;
begin
  {  }
  Result := Path;
  {    }
  L := Length(Path);
  {   }
  if L > Len then
  begin
    {    }
    while Length(Result) > Len - 4 do
    begin
      {     }
      P1 := Pos('\', Result);
      {     }
      if P1 = 0 then Exit;
      {   }
      P2 := P1;
      for I := P1 + 1 to Length(Result) do
        if (P2 = P1) and (Result[I] = '\') then
        begin
          P2 := I;
          Break;
        end;
      {     }
      if P2 = P1 then Exit;
      {   }
      Delete(Result, P1 + 1, P2 - P1);
    end;
    {   }
    Insert('...\', Result, 4);
  end;
end;

{        DOS. }

function GetLongFileName(const ShortName: string): string;
var
  SearchHandle: THandle;
  FindData: TWin32FindData;
begin
  {    }
  Result := ShortName;
  {   }
  SearchHandle := FindFirstFile(PChar(ShortName), FindData);
  {    -    }
  if SearchHandle <> INVALID_HANDLE_VALUE then
  begin
    Result := FindData.cFileName;
    if Result = '' then Result := FindData.cAlternateFileName;
  end;
  {   }
  Windows.FindClose(SearchHandle);
end;

{     }

function GetLongPathName(const ShortName: string): string;
var
  LastSlash: PChar;
  PathStr: string;
  PathName: string;
  SearchHandle: THandle;
  FindData: TWin32FindData;
begin
  Result := '';
  SetString(PathStr, PChar(ShortName), Length(ShortName));
  LastSlash := StrRScan(PChar(PathStr), '\');
  {   }
  while LastSlash <> nil do
  begin
    {    }
    SearchHandle := FindFirstFile(PChar(PathStr), FindData);
    try
      {    -     }
      if SearchHandle <> INVALID_HANDLE_VALUE then
      begin
        {    }
        PathName := FindData.cFileName;
        if PathName = '' then PathName := FindData.cAlternateFileName;
        {     }
        Result := '\' + PathName + Result;
      end
      else
        {    -       }
        Break;
    finally
      Windows.FindClose(SearchHandle);
    end;
    {     }
    if LastSlash <> nil then
    begin
      SetLength(PathStr, LastSlash - PChar(PathStr));
      LastSlash := StrRScan(PChar(PathStr), '\');
    end;
  end;
  {  }
  Result := PathStr + Result;
end;

{        }

function GetTemporaryFileName(const BaseFileName, Prefix: string): string;
begin
  Result := GetTemporaryFileNameEx(BaseFileName, Prefix, ExtractFileDir(BaseFileName));
end;

function GetTemporaryFileNameEx(const BaseFileName, Prefix: string; const DefDir: string): string;
var
  Dir: string;
  Buffer: array[0..MAX_PATH] of Char;
begin
  {   }
  Dir := ExtractFileDir(BaseFileName);
  if Length(Dir) = 0 then Dir := DefDir;
  {     }
  if Windows.GetTempFileName(PChar(Dir), PChar(Prefix), 0, @Buffer) <> 0 then
  begin
    Result := Buffer;
    Exit;
  end;
  {    }
  repeat
    Result := Format('%s\%s%d.tmp', [Dir, Prefix, Random(MaxWord)]);
  until not FileExists(Result);
end;

{          }

function ExtractFileNameEx(const FileName: string; IncludeExtension: Boolean): string;
var
  I: Integer;
begin
  {    }
  Result := ExtractFileName(FileName);
  {   }
  if not IncludeExtension then
  begin
    I := Length(Result);
    while (I > 0) and not (Result[I] in ['.', '\', ':']) do Dec(I);
    if (I > 0) and (Result[I] = '.') then Result := Copy(Result, 1, I - 1);
  end;
end;

{   ,     }

function UpdateFileStr(const S: string; const DefPath, DefMask: string): string;
var
  ResDir: string;
begin
  Result := S;
  {    }
  if Length(ExtractFileName(Result)) = 0 then Result := TrimCharRight(Result, '\') + DefMask;
  {    -     }
  if Length(ExtractFileExt(Result)) = 0 then  Result := Result + ExtractFileExt(DefMask);
  {   }
  ResDir := ExtractFileDir(Result);
  if (Length(ResDir) > 0) and (not DirectoryExists(ResDir)) then Result := TrimCharRight(DefPath, '\');
  {    }
  Result := TrimChar(Result, '\');
  {  '/'  '\' }
  if FileExists(Result) then Result := ReplaceChar(Result, '/', '\');
  {     }
  if Length(ExtractFileName(Result)) = 0 then Result := DefMask;
end;

{      }

function ExtractIconFile(const IconPath: string): string;
var
  I: Integer;
begin
  I := Length(IconPath);
  while (I > 0) and not (IconPath[I] in [',']) do Dec(I);
  if (I > 0) and (IconPath[I] = ',') then
    Result := Trim(Copy(IconPath, 1, I - 1)) else
    Result := Trim(IconPath);
end;

function ExtractIconIndex(const IconPath: string): Integer;
var
  I: Integer;
begin
  I := Length(IconPath);
  while (I > 0) and not (IconPath[I] in [',']) do Dec(I);
  if (I > 0) and (IconPath[I] = ',') then
    Result := StrToIntDef(Trim(Copy(IconPath, I + 1, 255)), 0) else
    Result := StrToIntDef(Trim(IconPath), 0);
end;

function ExpandIconPath(const IconFile: string; IconIndex: Integer): string;
begin
  Result := Format('%s, %d', [IconFile, IconIndex]);
end;

{     }

function LoadIconFromFile(const IconPath: string): HICON;
var
  IconFile: string;
  IconIndex: Integer;
begin
  {       }
  IconFile := ExtractIconFile(IconPath);
  IconIndex := ExtractIconIndex(IconPath);
  {   }
  Result := ExtractIcon(HInstance, PChar(IconFile), IconIndex);
end;

function LoadLargeIconFromFile(const IconPath: string): HICON;
var
  IconFile: string;
  IconIndex: Integer;
  LargeIcon, SmallIcon: HICON;
begin
  {       }
  IconFile := ExtractIconFile(IconPath);
  IconIndex := ExtractIconIndex(IconPath);
  {    }
  if ExtractIconEx(PChar(IconFile), IconIndex, LargeIcon, SmallIcon, 1) = 0 then
  begin
    Result := 0;
    Exit;
  end;
  {     }
  Result := LargeIcon;
end;

function LoadSmallIconFromFile(const IconPath: string): HICON;
var
  IconFile: string;
  IconIndex: Integer;
  LargeIcon, SmallIcon: HICON;
begin
  {       }
  IconFile := ExtractIconFile(IconPath);
  IconIndex := ExtractIconIndex(IconPath);
  {    }
  if ExtractIconEx(PChar(IconFile), IconIndex, LargeIcon, SmallIcon, 1) = 0 then
  begin
    Result := 0;
    Exit;
  end;
  {     }
  Result := SmallIcon;
end;

{     }

function StrToTimeDef(const S: string; Default: TDateTime): TDateTime;
begin
  try
    Result := StrToTime(S);
  except
    Result := Default;
  end;
end;

{     }

function StrToDateDef(const S: string; Default: TDateTime): TDateTime;
begin
  try
    Result := StrToDate(S);
  except
    Result := Default;
  end;
end;

{      }

{$IFDEF EX_D3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}
  SMonthName1 = '';
  SMonthName2 = '';
  SMonthName3 = '';
  SMonthName4 = '';
  SMonthName5 = '';
  SMonthName6 = '';
  SMonthName7 = '';
  SMonthName8 = '';
  SMonthName9 = '';
  SMonthName10 = '';
  SMonthName11 = '';
  SMonthName12 = '';

const
  RusMonthNames: array[1..12] of string = (
    SMonthName1, SMonthName2, SMonthName3, SMonthName4,
    SMonthName5, SMonthName6, SMonthName7, SMonthName8,
    SMonthName9, SMonthName10, SMonthName11, SMonthName12);

  EngMonthNames: array[1..12] of string = (
    '', '', '', '', '', '', '', '', '', '', '', '');

procedure FixRussianMonthNames;
var
  I: Integer;
begin
  for I := 1 to 12 do
  begin
    EngMonthNames[I] := LongMonthNames[I];
    LongMonthNames[I] := RusMonthNames[I]
  end;
end;

{      }

procedure RestoreDefaultMonthNames;
var
  I: Integer;
begin
  for I := 1 to 12 do
    if Length(EngMonthNames[I]) <> 0 then
      LongMonthNames[I] := EngMonthNames[I];
end;

{    .  }

function MSecToStr(Time: Longint): string;
var
  MSec, Sec, Min, Hour: Integer;
begin
  {   }
  if Time <= 0 then
  begin
    Result := '?';
    Exit;
  end;
  {   ,    }
  Hour := Time div 3600000;
  Min := (Time - Hour * 3600000) div 60000;
  Sec := (Time - Hour * 3600000 - Min * 60000) div 1000;
  MSec := (Time - Hour * 3600000 - Min * 60000 - Sec * 1000) div 10;
  {   }
  if Sec > 0 then
    if (Time < 10000) and (MSec > 10) then
      Result := IntToStr(Sec) + DecimalSeparator + IntToStr(MSec) + ' .'
    else
      Result := IntToStr(Sec) + ' .'
  else
    Result := '';
  if Min > 0 then
    if Length(Result) > 0 then
      Result := IntToStr(Min) + ' . ' + Result
    else
      Result := IntToStr(Min) + ' .';
  if Hour > 0 then
    if Length(Result) > 0 then
      Result := IntToStr(Hour) + ' . ' + Result
    else
      Result := IntToStr(Hour) + ' .';
end;

function MSecToStrFmt(Time: Longint; const Format: string): string;
var
  MSec, Sec, Min, Hour: Integer;
begin
  {   }
  if Time <= 0 then
  begin
    Result := '?';
    Exit;
  end;
  {   ,    }
  Hour := Time div 3600000;
  Min := (Time - Hour * 3600000) div 60000;
  Sec := (Time - (Hour * 3600000 + Min * 60000)) div 1000;
  MSec := Time - (Hour * 3600000 + Min * 60000 + Sec * 1000);
  {   }
  Result := FormatDateTime(Format, EncodeTime(Hour, Min, Sec, MSec));
end;

{     Unix }

function UnixTimeToDateTime(UnixTime: Longint): TDateTime;
begin
  Result := EncodeDate(1970, 1, 1) + UnixTime / SecsPerDay;
end;

function DateTimeToUnixTime(DateTime: TDateTime): Longint;
var
  Time70: TDateTime;
begin
  {   01.01.1970 }
  Time70 := EncodeDate(1970, 1, 1);
  {    }
  if DateTime < Time70 then
  begin
    Result := 0;
    Exit;
  end;
  {   }
  Result := Round((DateTime - Time70) * SecsPerDay);
end;

{   Substr   S }

function CasePos(Substr: string; S: string; MatchCase: Boolean): Integer;
begin
  if not MatchCase then
  begin
    {     }
    Substr := AnsiUpperCase(Substr);
    S := AnsiUpperCase(S);
  end;
  {  }
{$IFDEF EX_D2}
  Result := Pos(Substr, S);
{$ELSE}
  Result := AnsiPos(Substr, S);
{$ENDIF}
end;

{    S  C1   C2 }

function ReplaceChar(const S: string; C1, C2: Char): string;
var
  I: Integer;
begin
  {      }
  Result := S;
  {   }
  for I := 1 to Length(Result) do
    if Result[I] = C1 then Result[I] := C2;
end;

{    S  ,    C1   C2 }

function ReplaceChars(const S: string; C1: array of Char; C2: Char): string;
var
  I, J: Integer;
begin
  {      }
  Result := S;
  {   }
  for I := 1 to Length(Result) do
    for J := Low(C1) to High(C1) do
      if Result[I] = C1[J] then Result[I] := C2;
end;

{    S    S1   S2 }

function ReplaceStr(const S: string; S1, S2: string): string;
begin
  Result := ReplaceStrEx(S, S1, S2, False, False);
end;

{       S  S1   S2 }

function ReplaceStrEx(const S: string; S1, S2: string; ReplaceAll, MatchCase: Boolean): string;
var
  P: Integer;
begin
  Result := S;
  P := CasePos(S1, Result, MatchCase);
  while P <> 0 do
  begin
    Delete(Result, P, Length(S1));
    Insert(S2, Result, P);
    P := CasePos(S1, Result, MatchCase);
  end;
end;

{    S  ,    C }

function RemoveChars(const S: string; C: array of Char): string;
var
  I, J, K, L, N: Integer;
begin
  {   }
  L := Length(S);
  {       }
  SetString(Result, nil, L);
  N := 0;
  {    }
  for I := 1 to L do
  begin
    {       }
    K := 0;
    for J := Low(C) to High(C) do
      if S[I] = C[J] then
      begin
        Inc(K);
        Break;
      end;
    {  -     }
    if K = 0 then
    begin
      Inc(N);
      Result[N] := S[I];
    end;
  end;
  {      }
  SetLength(Result, N);
end;

{      }

function RemoveLineBreaks(const S: string): string;
var
  I, L, N: Integer;
begin
  {   }
  L := Length(S);
  {       }
  SetString(Result, nil, L);
  N := 0;
  {    }
  I := 1;
  while I <= L do
  begin
    Inc(N);
    {        }
    if S[I] in [#13, #10] then
    begin
      {  -     }
      Result[N] := ' ';
      {     }
      while (I < L) and (S[I + 1] in [#13, #10]) do Inc(I);
    end
    else
      {  -   }
      Result[N] := S[I];
    {   }
    Inc(I);
  end;
  {      }
  SetLength(Result, N);
end;

{      }

function RemoveDoubleSpace(const S: string): string;
var
  I, L, N: Integer;
begin
  {   }
  L := Length(S);
  {       }
  SetString(Result, nil, L);
  N := 0;
  {    }
  I := 1;
  while I <= L do
  begin
    Inc(N);
    {      }
    if S[I] = ' ' then
    begin
      {  -   }
      Result[N] := ' ';
      {    }
      while (I < L) and (S[I + 1] = ' ') do Inc(I);
    end
    else
      {  -   }
      Result[N] := S[I];
    {   }
    Inc(I);
  end;
  {      }
  SetLength(Result, N);
end;

{       S   C }

function TrimChar(const S: string; C: Char): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] = C) do Inc(I);
  if I > L then
  begin
    Result := '';
    Exit;
  end;
  while S[L] = C do Dec(L);
  Result := Copy(S, I, L - I + 1);
end;

{     S   C. }

function TrimCharLeft(const S: string; C: Char): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] = C) do Inc(I);
  Result := Copy(S, I, Maxint);
end;

{     S   C. }

function TrimCharRight(const S: string; C: Char): string;
var
  I: Integer;
begin
  I := Length(S);
  while (I > 0) and (S[I] = C) do Dec(I);
  if I <> 0 then Result := Copy(S, 1, I) else Result := '';
end;

{   S   C   Len }

function InsertCharLeft(const S: string; C: Char; Len: Integer): string;
var
  L: Integer;
  A: string;
begin
  L := Length(S);
  {   }
  if L >= Len then
  begin
    Result := S;
    Exit;
  end;
  {   }
  SetString(A, nil, Len - L);
  FillChar(Pointer(A)^, Len - L, Byte(C));
  {  }
  Result := A + S;
end;

{   S   C   Len. }

function InsertCharRight(const S: string; C: Char; Len: Integer): string;
var
  L: Integer;
  A: string;
begin
  {    }
  L := Length(S);
  {   }
  if L >= Len then
  begin
    Result := S;
    Exit;
  end;
  {   }
  SetString(A, nil, Len - L);
  FillChar(Pointer(A)^, Len - L, Byte(C));
  {  }
  Result := S + A;
end;

{   S    MaxLen }

function TruncLeft(const S: string; MaxLen: Integer): string;
var
  L: Integer;
begin
  {    }
  L := Length(S);
  {    -    }
  if L > MaxLen then
  begin
    Result := Copy(S, MaxIntValue([1, L - MaxLen]), MaxLen);
    Exit;
  end;
  {     }
  Result := S;
end;

{   S    MaxLen }

function TruncRight(const S: string; MaxLen: Integer): string;
var
  L: Integer;
begin
  {    }
  L := Length(S);
  {    -    }
  if L > MaxLen then
  begin
    Result := Copy(S, 1, MaxLen);
    Exit;
  end;
  {     }
  Result := S;
end;

{     }

function ExceptionMsg(E: Exception): string;
begin
  Result := RemoveLineBreaks(TrimCharRight(E.Message, '.'));
end;

{         } 

function ExtractParamName(const S: string; Delimiter: Char): string;
var
  P: Integer;
begin
  Result := S;
{$IFDEF EX_D2}
  P := Pos(Delimiter, Result);
{$ELSE}
  P := AnsiPos(Delimiter, Result);
{$ENDIF}
  if P <> 0 then
    SetLength(Result, P - 1)
  else
    SetLength(Result, 0);
end;

function ExtractParamValue(const S: string; Delimiter: Char): string;
begin
  Result := Copy(S, Length(ExtractParamName(S, Delimiter)) + 2, MaxInt);
end;

{    . }

function StringsEqual(List: array of string; MatchCase: Boolean): Boolean;
var
  I: Integer;
  S1, S2: string;
begin
  Result := False;
  {    }
  S1 := List[Low(List)];
  if not MatchCase then S1 := AnsiUpperCase(S1);
  {  }
  for I := Low(List) + 1 to High(List) do
  begin
    {    }
    S2 := List[I];
    if not MatchCase then S2 := AnsiUpperCase(S2);
    {  }
    if AnsiCompareStr(S1, S2) <> 0 then Exit;
  end;
  {   }
  Result := True;
end;

{          }

function StringsEmpty(List: array of string): Boolean;
var
  I: Integer;
begin
  {  }
  for I := Low(List) to High(List) do
    {   }
    if Length(List[I]) = 0 then
    begin
      Result := False;
      Exit;
    end;
  {   }
  Result := True;
end;

{        }

function GetLineCount(const S: string): Integer;
var
  P: PChar;
begin
  Result := 0;
  {    }
  P := Pointer(S);
  while P^ <> #0 do
  begin
    while not (P^ in [#0, #10, #13]) do Inc(P);
    {   }
    Inc(Result);
    {    }
    if P^ = #13 then Inc(P);
    if P^ = #10 then Inc(P);
  end;
end;

{$IFDEF EX_D2}

{ Returns the smallest and largest value in the data array (MIN/MAX) }

function MinIntValue(const Data: array of Integer): Integer;
var
  I: Integer;
begin
  Result := Data[Low(Data)];
  for I := Low(Data) + 1 to High(Data) do
    if Result > Data[I] then Result := Data[I];
end;

function MaxIntValue(const Data: array of Integer): Integer;
var
  I: Integer;
begin
  Result := Data[Low(Data)];
  for I := Low(Data) + 1 to High(Data) do
    if Result < Data[I] then Result := Data[I];
end;

function IdentToInt(const Ident: string; var Int: Longint; const Map: array of TIdentMapEntry): Boolean;
var
  I: Integer;
begin
  for I := Low(Map) to High(Map) do
    if CompareText(Map[I].Name, Ident) = 0 then
    begin
      Result := True;
      Int := Map[I].Value;
      Exit;
    end;
  Result := False;
end;

function IntToIdent(Int: Longint; var Ident: string; const Map: array of TIdentMapEntry): Boolean;
var
  I: Integer;
begin
  for I := Low(Map) to High(Map) do
    if Map[I].Value = Int then
    begin
      Result := True;
      Ident := Map[I].Name;
      Exit;
    end;
  Result := False;
end;

{$ENDIF}

{   Ident       Map }

function IdentToIntDef(const Ident: string; Default: Longint; const Map: array of TIdentMapEntry): Longint;
begin
  if not IdentToInt(Ident, Result, Map) then Result := Default;
end;

{   Int       Map }

function IntToIdentDef(Int: Longint; const Default: string; const Map: array of TIdentMapEntry): string;
begin
  if not IntToIdent(Int, Result, Map) then Result := Default;
end;

{    Name   Map }

function GetIdentNameIndex(const Name: string; const Map: array of TIdentMapEntry): Integer;
begin
  Result := GetIdentNameIndexDef(Name, -1, Map);
end;

function GetIdentNameIndexDef(const Name: string; DefIndex: Integer; const Map: array of TIdentMapEntry): Integer;
var
  I: Integer;
begin
  for I := Low(Map) to High(Map) do
    if CompareText(Map[I].Name, Name) = 0 then
    begin
      Result := I;
      Exit;
    end;
  Result := DefIndex;
end;

{    Value   Map }

function GetIdentValueIndex(Value: Longint; const Map: array of TIdentMapEntry): Integer;
begin
  Result := GetIdentValueIndexDef(Value, -1, Map);
end;

function GetIdentValueIndexDef(Value: Longint; DefIndex: Integer; const Map: array of TIdentMapEntry): Integer;
var
  I: Integer;
begin
  for I := Low(Map) to High(Map) do
    if Map[I].Value = Value then
    begin
      Result := I;
      Exit;
    end;
  Result := DefIndex;
end;

{      Map. 
       Proc     Map. }

function GetIdentsList(const Map: array of TIdentMapEntry; Proc: TGetStrProc): Integer;
var
  I: Integer;
begin
  Result := 0;
  for I := Low(Map) to High(Map) do
  begin
    Proc(Map[I].Name);
    Inc(Result);
  end;
end;

{   Strings   Map. }

function GetIdentsStringList(const Map: array of TIdentMapEntry; Strings: TStrings): Integer;
type
  TGetStrFunc = function(const S: string): Integer of object;
var
  Proc: TGetStrFunc;
begin
  Proc := Strings.Add;
  Result := GetIdentsList(Map, TGetStrProc(Proc));
end;

{    }

procedure InitControlHandle(Control: TWinControl; Recurse: Boolean);
var
  I: Integer;
  ChildControl: TControl;
begin
  {    }
  Control.HandleNeeded;
  {     }
  if Recurse then
    for I := 0 to Control.ControlCount - 1 do
    begin
      ChildControl := Control.Controls[I];
      if ChildControl is TWinControl then
        InitControlHandle(TWinControl(ChildControl), True);
    end;
end;

{    }

function IsControlVisible(Control: TWinControl): Boolean;
begin
  with Control do
  begin
    {      }
    if (not HandleAllocated) or (not Visible) then
    begin
      Result := False;
      Exit;
    end;
    {       }
    if csDesigning in ComponentState then
    begin
      Result := True;
      Exit;
    end;
    {  ,    }
    Result := (Parent <> nil) and (Parent.Visible);
  end;
end;

{    }

function InvalidateControl(Control: TWinControl): Boolean;
var
  Rect: TRect;
begin
  with Control do
  begin
    Rect := ClientRect;
    Result := InvalidateControlRect(Control, Rect, not (csOpaque in ControlStyle));
  end;
end;

function InvalidateControlRect(Control: TWinControl; Rect: TRect; Erase: Boolean): Boolean;
begin
  {    }
  if not IsControlVisible(Control) then
  begin
    Result := False;
    Exit;
  end;
  {   }
  Result := InvalidateRect(Control.Handle, @Rect, Erase);
end;

{      INI   StringList}

procedure IniReadSection(const FileName, Section: string; Strings: TStrings);
var
  I: Integer;
  Names: TStringList;
  Value: string;
begin
  with TIniFile.Create(FileName) do
  try
    Strings.Clear;
    {     }
    Names := TStringList.Create;
    try
      {   }
      ReadSection(Section, Names);
      {   }
      for I := 0 to Names.Count - 1 do
      begin
        {   }
        Value := ReadString(Section, Names[I], '');
        {   }
        Strings.Add(Format('%s=%s', [Names[I], Value]));
      end;
    finally
      Names.Free;
    end;
  finally
    Free;
  end;
end;

{       StringList  INI  }

procedure IniWriteSection(const FileName, Section: string; Strings: TStrings);
var
  I: Integer;
begin
  with TIniFile.Create(FileName) do
  try
    {   }
    with Strings do
      {   }
      for I := 0 to Count - 1 do
        {  }
        WriteString(Section, Names[I], Values[Names[I]]);
  finally
    Free;
  end;
end;

{          }

procedure RegEraseKey(Root: HKEY; const Key: string);
begin
  RegEraseKeyEx(Root, Key, True);
end;

procedure RegEraseKeyEx(Root: HKEY; const Key: string; SubKeys: Boolean);
begin
  {   }
  if SubKeys then RegEraseSubKeys(Root, Key);
  {    }
  with TRegistry.Create do
  try
    {    }
    RootKey := Root;
    {   }
    DeleteKey(PChar(Key));
  finally
    Free;
  end;
end;

{      }

type
  THackRegistry = class(TRegistry);

procedure RegEraseSubKeys(Root: HKEY; const Key: string);
var
  Registry: THackRegistry;

  procedure DoErase(const Key: string; SubIndex: Integer);
  var
    I: Integer;
    OldKey, NewKey: HKEY;
    Strings: TStringList;
  begin
    with Registry do
    begin
      {    }
      OldKey := CurrentKey;
      {    }
      NewKey := GetKey(Key);
      if NewKey <> 0 then
      try
        {     }
        SetCurrentKey(NewKey);
        {    }
        Strings := TStringList.Create;
        try
          {    }
          GetKeyNames(Strings);
          {   }
          for I := Strings.Count - 1 downto 0 do
            DoErase(Strings[I], SubIndex + 1);
        finally
          Strings.Free;
        end;
      finally
        {    }
        SetCurrentKey(OldKey);
        {    }
        RegCloseKey(NewKey);
      end;
      {    }
      if SubIndex > 1 then DeleteKey(PChar(Key));
    end;
  end;

begin
  {     }
  Registry := THackRegistry.Create;
  {  }
  with Registry do
  try
    {    }
    RootKey := Root;
    {   }
    DoErase(Key, 1);
  finally
    Registry.Free;
  end;
end;

{        StringList }

procedure RegReadKey(Root: HKEY; const Key: string; Strings: TStrings);
var
  I: Integer;
  Names: TStringList;
  Info: TRegDataInfo;
  Value: string;
begin
  with TRegistry.Create do
  try
    {    }
    RootKey := Root;
    {   }
    if OpenKey(Key, False) then
    begin
      Strings.Clear;
      {     }
      Names := TStringList.Create;
      try
        {   }
        GetValueNames(Names);
        {   }
        for I := 0 to Names.Count - 1 do
          {    }
          if GetDataInfo(Names[I], Info) then
          begin
            {      }
            case Info.RegData of
              rdString, rdExpandString:
                {  }
                Value := ReadString(Names[I]);
              else
                {     }
                Continue;
            end;
            {   }
            Strings.Add(Format('%s=%s', [Names[I], Value]));
          end;
      finally
        Names.Free;
      end;
    end;
  finally
    Free;
  end;
end;

{       StringList     }

procedure RegWriteKey(Root: HKEY; const Key: string; Strings: TStrings);
var
  I: Integer;
begin
  with TRegistry.Create do
  try
    {    }
    RootKey := Root;
    {   }
    if OpenKey(Key, True) then
      {   }
      with Strings do
        {   }
        for I := 0 to Count - 1 do
          {  }
          WriteString(Names[I], Values[Names[I]]);
  finally
    Free;
  end;
end;

{        }

procedure RegMergeKeys(Root: HKEY; const Keys: array of string; Strings: TStrings);
var
  I, J: Integer;
  S: TStringList;
begin
  S := TStringList.Create;
  try
    {     }
    RegReadKey(Root, Keys[0], Strings);
    {     }
    for I := Low(Keys) + 1 to High(Keys) do
    begin
      {    }
      RegReadKey(Root, Keys[I], S);
      {     }
      for J := 0 to S.Count - 1 do
        {     }
        if Strings.IndexOfName(S.Names[J]) = -1 then Strings.Add(S[J]);
    end;
  finally
    S.Free;
  end;
end;

{      }

const
  RegSignature = 'REGEDIT4';

procedure RegImport(const FileName: string);
var
  RegFile: TextFile;
  Registry: TRegistry;
  Line: string;

  procedure DoImportValue;
  var
    P: Integer;
    Name, Value: string;
    StrValue: string;
  begin
    with Registry do
    try
      {   }
      P := Pos('=', Line);
      if P <> 0 then
      begin
        {    }
        Name := Copy(Line, 2, P - 3);
        {   }
        Line := Copy(Line, P + 1, Length(Line) - P);
        {    -   }
        if Length(Line) > 0 then
        begin
          {    }
          P := Pos('"', Line);
          if P = 1 then
          begin
            {   }
            Value := Copy(Line, P + 1, Length(Line) - P - 1);
            {   }
            StrValue := StrToRegStr(Value);
            {    }
            WriteString(Name, StrValue);
          end;
          {   DWORD }
          P := Pos('dword:', Line);
          if P = 1 then
          begin
          end;
          {   HEX }
          P := Pos('hex:', Line);
          if P = 1 then
          begin
          end;
        end;
      end;
    except
      Exit;
    end;
  end;

  procedure DoImportKey;
  var
    P: Integer;
    Root: HKEY;
    Key: string;
  begin
    with Registry do
    try
      {   }
      P := Pos('[', Line);
      if P = 1 then
      begin
        {     }
        P := Pos('\', Line);
        if P <> 0 then
        begin
          {     }
          Root := RegStrToRootKey(Copy(Line, 2, P - 2));
          {    }
          Key := Copy(Line, P + 1, Length(Line) - P - 1);
          {     }
          RootKey := Root;
          if OpenKey(Key, False) then
          try
            {    }
            while not EOF(RegFile) do
            begin
              {   }
              Readln(RegFile, Line);
              {       -  }
              if (Length(Line) = 0) or (Line[1] = '[') then Exit;
              {   }
              DoImportValue;
            end;
          finally
            CloseKey;
          end;
        end;
      end;
    except
      Exit;
    end;
  end;

begin
  {   }
  AssignFile(RegFile, FileName);
  try
    {   }
    Reset(RegFile);
    {    }
    if not EOF(RegFile) then
    begin
      {   }
      Readln(RegFile, Line);
      {   }
      if CompareText(Line, RegSignature) = 0 then
      begin
        {     }
        Registry := TRegistry.Create;
        try
          {   }
          while not EOF(RegFile) do
          begin
            {   }
            Readln(RegFile, Line);
            {   }
            DoImportKey;
          end;
        finally
          Registry.Free;
        end;
      end;
    end;
  finally
    CloseFile(RegFile);
  end;
end;

procedure RegExport(Root: HKEY; const Key: string; const FileName: string);
var
  RegFile: TextFile;
  Registry: THackRegistry;

  procedure DoSave(const Key, Path: string);
  var
    I: Integer;
    OldKey, NewKey: HKEY;
    Strings: TStringList;
    Line: string;
    Info: TRegDataInfo;
    StrValue: string;
  begin
    with Registry do
    begin
      {    }
      OldKey := CurrentKey;
      {    }
      NewKey := GetKey(Key);
      if NewKey <> 0 then
      try
        {     }
        SetCurrentKey(NewKey);
        {  -  }
        Writeln(RegFile);
        {    }
        Line := Format('[%s\%s]', [Path, Key]);
        {    }
        Writeln(RegFile, Line);
        {    }
        Strings := TStringList.Create;
        try
          {    }
          GetValueNames(strings);
          {   }
          for I := 0 to Strings.Count - 1 do
            {    }
            if GetDataInfo(Strings[I], Info) then
            begin
              {      }
              case Info.RegData of
                rdString, rdExpandString:
                  {  }
                  begin
                    {   }
                    StrValue := ReadString(Strings[I]);
                    {   }
                    StrValue := RegStrToStr(StrValue);
                    {   }
                    Line := Format('"%s"="%s"', [Strings[I], StrValue]);
                  end;
                rdInteger:
                  { DWORD }
                  begin
                  end;
                rdBinary:
                  { HEX }
                  begin
                  end;
                else
                  {     }
                  Continue;
              end;
              {   }
              Writeln(RegFile, Line);
            end;
        finally
          Strings.Free;
        end;
        {    }
        Strings := TStringList.Create;
        try
          {   }
          GetKeyNames(Strings);
          {   }
          for I := 0 to Strings.Count - 1 do
            DoSave(Strings[I], Format('%s\%s', [Path, Key]));
        finally
          Strings.Free;
        end;
      finally
        {    }
        SetCurrentKey(OldKey);
        {    }
        RegCloseKey(NewKey);
      end;
    end;
  end;

begin
  {   }
  AssignFile(RegFile, FileName);
  try
    {   }
    Rewrite(RegFile);
    {    }
    Writeln(RegFile, RegSignature);
    {     }
    Registry := THackRegistry.Create;
    {  }
    with Registry do
    try
      {    }
      RootKey := Root;
      {   }
      DoSave(Key, RegRootKeyToStr(Root));
    finally
      Free;
    end;
  finally
    CloseFile(RegFile);
  end;
end;

{          }

function StrToRegStr(const Value: string): string;
var
  I: Integer;
begin
  {  }
  Result := Value;
  {  "\\"  "\" }
  I := Length(Result) - 1;
  while I > 0 do
  begin
    {   "\" }
    if (Result[I] = '\') and (Result[I + 1] = '\') then Delete(Result, I, 1);
    {   }
    Dec(I);
  end;
end;

function RegStrToStr(const Value: string): string;
var
  I: Integer;
begin
  {  }
  Result := Value;
  {  "\"  "\\" }
  I := Length(Result);
  while I > 0 do
  begin
    {   "\" }
    if Result[I] = '\' then Insert('\', Result, I + 1);
    {   }
    Dec(I);
  end;
end;

{    (HKEY_XXX) -  }

type
  TRootEntry = record
    Value: HKEY;
    Name: string;
  end;

const
  RootList: array[0..6] of TRootEntry = (
    (Value: HKEY_CLASSES_ROOT; Name: 'HKEY_CLASSES_ROOT'),
    (Value: HKEY_CURRENT_USER; Name: 'HKEY_CURRENT_USER'),
    (Value: HKEY_LOCAL_MACHINE; Name: 'HKEY_LOCAL_MACHINE'),
    (Value: HKEY_USERS; Name: 'HKEY_USERS'),
    (Value: HKEY_PERFORMANCE_DATA; Name: 'HKEY_PERFORMANCE_DATA'),
    (Value: HKEY_CURRENT_CONFIG; Name: 'HKEY_CURRENT_CONFIG'),
    (Value: HKEY_DYN_DATA; Name: 'HKEY_DYN_DATA'));

function RegRootKeyToStr(Root: HKEY): string;
var
  I: Integer;
begin
  for I := Low(RootList) to High(RootList) do
    if RootList[I].Value = Root then
    begin
      Result := RootList[I].Name;
      Exit;
    end;
  Result := IntToStr(Root);
end;

function RegStrToRootKey(const S: string): HKEY;
var
  I: Integer;
begin
  for I := Low(RootList) to High(RootList) do
    if CompareText(RootList[I].Name, S) = 0 then
    begin
      Result := RootList[I].Value;
      Exit;
    end;
  Result := StrToInt(S);
end;

function RegStrToRootKeyDef(const S: string; Default: HKEY): HKEY;
begin
  try
    Result := RegStrToRootKey(S);
  except
    Result := Default;
  end;
end;

{   }

function ShutDownComputer(const Message: string; Delay: Longint; Reboot: Boolean): Boolean;
var
  TokenHandle:  THandle;
  Luid: TLargeInteger;
  Newstate: TTokenPrivileges;
  Buffer: array [0..1023] of Byte;
  PreviousState: TTokenPrivileges absolute Buffer;
  ReturnLength: DWORD;
begin
  {      }
{$IFDEF EX_D3_UP}
  if OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, TokenHandle) then
{$ELSE }
  if OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, @TokenHandle) then
{$ENDIF}
  begin
    {       }
    if LookupPrivilegeValue(nil, 'SeShutdownPrivilege', Luid) then
    begin
      { One privilege to set }
      NewState.PrivilegeCount := 1;
      NewState.Privileges[0].Luid := LUID;
      NewState.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
    end
    else
    begin
      {    }
      Result := False;
      Exit;
    end;
    {      }
    ReturnLength := 0;
    AdjustTokenPrivileges(TokenHandle, False, NewState, 1024, PreviousState, ReturnLength);
    {   (    AdjustTokenPrivileges) }
    if GetLastError <> ERROR_SUCCESS then
    begin
      {    }
      Result := False;
      Exit;
    end;
    {   }
    if not InitiateSystemShutdown(nil, PChar(Message), Delay, True, Reboot) then
    begin
      {    }
      Result := False;
      Exit;
    end;
  end;
  {  }
  Result := True;
end;

{   }

function GetCompName: string;
var
  nSize: DWORD;
  lpBuffer: array[0..MAX_COMPUTERNAME_LENGTH] of Char;
begin
  {      }
  nSize := MAX_COMPUTERNAME_LENGTH;
  {     API }
  if GetComputerName(lpBuffer, nSize) then
  begin
    SetString(Result, lpBuffer, nSize);
    Exit;
  end;
  {   -    }
  with TRegistry.Create do
  try
    RootKey := HKEY_LOCAL_MACHINE;
    if OpenKey(REGSTR_PATH_COMPUTRNAME, False) then
      if ValueExists(REGSTR_VAL_COMPUTRNAME) then
      begin
        Result := ReadString(REGSTR_VAL_COMPUTRNAME);
        Exit;
      end;
  finally
    Free;
  end;
  {    }
  Result := '';
end;

{   Windows }

function GetCompUser: string;
var
  nSize: DWORD;
  lpBuffer: array[0..MAX_COMPUTERNAME_LENGTH] of Char;
begin
  {      }
  nSize := MAX_COMPUTERNAME_LENGTH;
  {    }
  if GetUserName(lpBuffer, nSize) then
  begin
    SetString(Result, lpBuffer, nSize - 1);
    Exit;
  end;
  {  }
  Result := '';
end;

{      }

function ParamExists(const Param: string): Boolean;
var
  I, P: Integer;
  S: string;
begin
  {     }
  for I := 1 to ParamCount do
  begin
    {   }
    S := ParamStr(I);
    {     }
    P := CasePos(Param, S, False);
    if P = 1 then
    begin
      {   -  }
      Result := True;
      Exit;
    end;
  end;
  {   }
  Result := False;
end;

{    }

function GetParamValue(const Param: string): string;
var
  I, P: Integer;
  S: string;
begin
  {     }
  for I := 1 to ParamCount do
  begin
    {   }
    S := ParamStr(I);
    {     }
    P := CasePos(Param, S, False);
    if P = 1 then
    begin
      {   -  }
      Result := Copy(S, P + Length(Param), 255);
      Exit;
    end;
  end;
  {   }
  Result := '';
end;

function GetParamValueDef(const Param: string; const Default: string): string;
begin
  Result := GetParamValue(Param);
  if Length(Result) = 0 then Result := Default;
end;

{   API  MessageBox }

function GetAveCharSize(Canvas: TCanvas): TPoint;
var
  I: Integer;
  Buffer: array[0..51] of Char;
begin
  for I := 0 to 25 do Buffer[I] := Chr(I + Ord('A'));
  for I := 0 to 25 do Buffer[I + 26] := Chr(I + Ord('a'));
  GetTextExtentPoint(Canvas.Handle, Buffer, 52, TSize(Result));
  Result.X := Result.X div 52;
end;

type
  TAppMsgBtn = (mbYes, mbNo, mbOK, mbCancel, mbAbort, mbRetry, mbIgnore);
  TAppMsgButtons = set of TAppMsgBtn;

const
  ButtonNames: array[TAppMsgBtn] of string = (
    'Yes', 'No', 'OK', 'Cancel', 'Abort', 'Retry', 'Ignore');
{$IFDEF VER90}
  ButtonCaptions: array[TAppMsgBtn] of Word = (
    SMsgDlgYes, SMsgDlgNo, SMsgDlgOK, SMsgDlgCancel, SMsgDlgAbort,
    SMsgDlgRetry, SMsgDlgIgnore);
{$ELSE}
  ButtonCaptions: array[TAppMsgBtn] of string = (
    SMsgDlgYes, SMsgDlgNo, SMsgDlgOK, SMsgDlgCancel, SMsgDlgAbort,
    SMsgDlgRetry, SMsgDlgIgnore);
{$ENDIF}
  ButtonWidths: array[TAppMsgBtn] of Integer = (
    0, 0, 0, 0, 0, 0, 0);
  ModalResults: array[TAppMsgBtn] of Integer = (
    mrYes, mrNo, mrOk, mrCancel, mrAbort, mrRetry, mrIgnore);

function CreateAppMessageBox(const AText, ACaption: string; Flags: Longint): TForm;
const
  mcHorzMargin = 8;
  mcVertMargin = 8;
  mcHorzSpacing = 10;
  mcVertSpacing = 10;
  mcButtonWidth = 50;
  mcButtonHeight = 14;
  mcButtonSpacing = 4;
  mcMaxWidthInc = 15;
var
  Button: TButton;
  Buttons: TAppMsgButtons;
  DialogUnits: TPoint;
  HorzMargin, VertMargin, HorzSpacing, VertSpacing, MaxWidthInc, ButtonWidth,
  ButtonHeight, ButtonSpacing, ButtonCount, ButtonGroupWidth,
  IconTextWidth, IconTextHeight, X, ALeft: Integer;
  B: TAppMsgBtn;
  IconID: PChar;
  TextRect: TRect;
begin
  Result := TForm.CreateNew(Application);
  with Result do
  begin
    BorderStyle := bsDialog;
    Canvas.Font := Font;
    DialogUnits := GetAveCharSize(Canvas);
    {   }
    HorzMargin := MulDiv(mcHorzMargin, DialogUnits.X, 4);
    VertMargin := MulDiv(mcVertMargin, DialogUnits.Y, 8);
    HorzSpacing := MulDiv(mcHorzSpacing, DialogUnits.X, 4);
    VertSpacing := MulDiv(mcVertSpacing, DialogUnits.Y, 8);
    MaxWidthInc := MulDiv(mcMaxWidthInc, DialogUnits.Y, 8);
    {   }
    case Flags and MB_TYPEMASK of
      MB_OKCANCEL: Buttons := [mbOK, mbCancel];
      MB_ABORTRETRYIGNORE: Buttons := [mbAbort, mbRetry, mbIgnore];
      MB_YESNOCANCEL: Buttons := [mbYes, mbNo, mbCancel];
      MB_YESNO: Buttons := [mbYes, mbNo];
      MB_RETRYCANCEL: Buttons := [mbRetry, mbCancel];
    else
      Buttons := [mbOK];
    end;
    {   }
    ButtonWidth := MulDiv(mcButtonWidth, DialogUnits.X, 4) - 4;
    for B := Low(TAppMsgBtn) to High(TAppMsgBtn) do
    begin
      if not (B in Buttons) then Continue;
      {    }
      if ButtonWidths[B] = 0 then
      begin
        TextRect := Rect(0,0,0,0);
        Windows.DrawText(Canvas.handle,
{$IFDEF VER90}
          PChar(LoadStr(ButtonCaptions[B])), -1,
{$ELSE}
          PChar(ButtonCaptions[B]), -1,
{$ENDIF}
          TextRect, DT_CALCRECT or DT_LEFT or DT_SINGLELINE);
        with TextRect do
          ButtonWidths[B] := Right - Left + 4;
      end;
      {    }
      if ButtonWidths[B] > ButtonWidth then
        ButtonWidth := ButtonWidths[B];
    end;
    ButtonHeight := MulDiv(mcButtonHeight, DialogUnits.Y, 8);
    ButtonSpacing := MulDiv(mcButtonSpacing, DialogUnits.X, 4) + 1;
    {   }
    SetRect(TextRect, 0, 0, Screen.Width div 2 + MaxWidthInc, 0);
    DrawText(Canvas.Handle, PChar(AText), Length(AText) + 1, TextRect,
      DT_EXPANDTABS or DT_CALCRECT or DT_WORDBREAK);
    {  }
    case Flags and MB_ICONMASK of
      MB_ICONWARNING: IconID := IDI_WARNING;
      MB_ICONQUESTION: IconID := IDI_QUESTION;
      MB_ICONERROR: IconID := IDI_ERROR;
      MB_ICONINFORMATION: IconID := IDI_INFORMATION;
    else
      IconID := nil;
    end;
    IconTextWidth := TextRect.Right;
    IconTextHeight := TextRect.Bottom;
    if IconID <> nil then
    begin
      Inc(IconTextWidth, 32 + HorzSpacing);
      if IconTextHeight < 32 then IconTextHeight := 32;
    end;
    {   }
    ButtonCount := 0;
    for B := Low(TAppMsgBtn) to High(TAppMsgBtn) do
      if B in Buttons then Inc(ButtonCount);
    ButtonGroupWidth := 0;
    if ButtonCount <> 0 then
      ButtonGroupWidth := ButtonWidth * ButtonCount +
        ButtonSpacing * (ButtonCount - 1);
    ClientWidth := MaxIntValue([IconTextWidth, ButtonGroupWidth]) + HorzMargin * 2 - 5;
    ClientHeight := IconTextHeight + ButtonHeight + VertSpacing +
      VertMargin * 2 - 3;
    Left := (Screen.Width div 2) - (Width div 2);
    Top := (Screen.Height div 2) - (Height div 2);
    {  }
    Caption := ACaption;
    {    }
    if IconID <> nil then
      with TImage.Create(Result) do
      begin
        Name := 'Image';
        Parent := Result;
        Picture.Icon.Handle := LoadIcon(0, IconID);
        SetBounds(HorzMargin - 1, VertMargin - 2, 32, 32);
      end;
    {    }
    with TLabel.Create(Result) do
    begin
      Name := 'Message';
      Parent := Result;
      WordWrap := True;
      Caption := AText;
      BoundsRect := TextRect;
      ALeft := IconTextWidth - TextRect.Right + HorzMargin;
      SetBounds(ALeft, VertMargin - 2, TextRect.Right, TextRect.Bottom);
      if IconID <> nil then
        Top := Top + MaxIntValue([0, (32 - TextRect.Bottom) div 2 - 1]);
    end;
    {  }
    X := (ClientWidth - ButtonGroupWidth) div 2;
    ButtonCount := 0;
    for B := Low(TAppMsgBtn) to High(TAppMsgBtn) do
    begin
      if not (B in Buttons) then Continue;
      Inc(ButtonCount);
      {  }
      Button := TButton.Create(Result);
      with Button do
      begin
        Name := ButtonNames[B];
        Parent := Result;
{$IFDEF VER90}
        Caption := LoadStr(ButtonCaptions[B]);
{$ELSE}
        Caption := ButtonCaptions[B];
{$ENDIF}
        ModalResult := ModalResults[B];
        {    }
        case Flags and MB_DEFMASK of
          MB_DEFBUTTON1: if ButtonCount = 1 then ActiveControl := Button;
          MB_DEFBUTTON2: if ButtonCount = 2 then ActiveControl := Button;
          MB_DEFBUTTON3: if ButtonCount = 3 then ActiveControl := Button;
          MB_DEFBUTTON4: if ButtonCount = 4 then ActiveControl := Button;
        end;
        {   }
        case Flags and MB_TYPEMASK of
          MB_OKCANCEL: Cancel := B = mbCancel;
          MB_ABORTRETRYIGNORE: Cancel := False;
          MB_YESNOCANCEL: Cancel := B = mbCancel;
          MB_YESNO: Cancel := False;
          MB_RETRYCANCEL: Cancel := B = mbCancel;
        else
          Cancel := B = mbOK;
        end;
        {     }
        SetBounds(X, IconTextHeight + VertMargin + VertSpacing - 1,
          ButtonWidth, ButtonHeight);
        Inc(X, ButtonWidth + ButtonSpacing);
      end;
    end;
  end;
end;

function AppMessageBox(const Text, Caption: string; Flags: Longint): Integer;
begin
  with CreateAppMessageBox(Text, Caption, Flags) do
  try
    Result := ShowModal;
  finally
    Free;
  end;
end;

function AppMessageBoxFmt(const TextFormat, Caption: string; Flags: Longint; const Args: array of const): Integer;
begin
  Result := AppMessageBox(Format(TextFormat, Args), Caption, Flags);
end;

{  ( Delay  TP) }

procedure AppDelay(TimeOut: Longint);
begin
  AppDelayEx(TimeOut, False, True, 0, nil);
end;

function KeyboardProc(Code: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; far; stdcall;
begin
  Result := 1;
end;

function MouseProc(Code: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; far; stdcall;
begin
  Result := 1;
end;

procedure AppDelayEx(TimeOut: Longint; AppTerminate, AppMessages: Boolean; DelayCursor: HCURSOR; DelayProc: TDelayProc);
var
  K, M: HHOOK;
  T: Longint;
  C: Boolean;
begin
  {     }
  if AppMessages then
  begin
    {      }
    K := SetWindowsHookEx(WH_KEYBOARD, @KeyboardProc, 0, GetCurrentThreadID);
    M := SetWindowsHookEx(WH_MOUSE, @MouseProc, 0, GetCurrentThreadID);
  end
  else
  begin
    K := 0;
    M := 0;
  end;
  {   }
  if DelayCursor = 0 then DelayCursor := Screen.Cursors[Screen.Cursor];
  {  }
  try
    C := False;
    {    }
    T := GetTickCount;
    {   }
    while True  do
    begin
      {   }
      if Abs(Longint(GetTickCount) - T) > TimeOut then Break;
      { ,      }
      if AppTerminate then if Application.Terminated then Break;
      {   }
      Windows.SetCursor(DelayCursor);
      {   }
      if AppMessages then Application.ProcessMessages;
      {    }
      if Assigned(DelayProc) then
      begin
        DelayProc(C);
        if C then Break;
      end;
      {     }
      Sleep(5);
    end;
    {    }
    if not AppMessages then
    begin
      Application.ProcessMessages;
      Application.HideHint;
    end;
  finally
    if K <> 0 then UnhookWindowsHookEx(K);
    if M <> 0 then UnhookWindowsHookEx(M);
  end;
end;

{  .exe    }

function AppExeName: string;
begin
  Result := ExtractFileName(GetLongFileName(ParamStr(0)));
end;

{    }

{$IFDEF EX_D5_UP}

function SetScreenCursor(Value: TCursor): TCursor;
begin
  Result := Screen.Cursor;
  Screen.Cursor := Value;
end;

{$ELSE}

function SetScreenCursor(Value: TCursor): TCursor;
var
  Pos: TPoint;
  Handle: THandle;
  Code: Integer;
begin
  {  }
  Result := Screen.Cursor;
  {   }
  if Screen.Cursor <> Value then
  begin
    {   }
    Screen.Cursor := Value;
    {    VCL }
    if Value = crDefault then
    begin
      {    }
      GetCursorPos(Pos);
      {   }
      Handle := GetCapture;
      if Handle = 0 then Handle := WindowFromPoint(Pos);
      {      "" }
      if (Handle <> 0) and (GetWindowThreadProcessId(Handle, nil) = GetCurrentThreadId) then
      begin
        { ,       }
        Code := SendMessage(Handle, WM_NCHITTEST, 0, LongInt(PointToSmallPoint(Pos)));
        SendMessage(Handle, WM_SETCURSOR, Handle, MakeLong(Code, WM_MOUSEMOVE));
      end;
    end;
  end;
end;

{$ENDIF}

{       }

function GetVersionStr(const FileName, Key, Default: string): string;
const
  SLang = '\\VarFileInfo\\Translation';
  SBlock = '\\StringFileInfo\\%.4x%.4x\\%s';
type
  PLangList = ^TLangList;
  TLangList = array[0..MAXINT div SizeOf(LongRec) - 1] of LongRec;
var
  Handle: DWORD;
  Size: DWORD;
  Data: Pointer;
  Buffer: Pointer;
  Len: UINT;
  LangCount, I: Integer;
  Lang, CharSet: Word;
  Block: string;
begin
  Result := Default;
  Size := GetFileVersionInfoSize(PChar(FileName), Handle);
  if Size > 0 then
  begin
    GetMem(Data, Size);
    if Data <> nil then
    try
      if not GetFileVersionInfo(PChar(FileName), Handle, Size, Data) then Exit;
      if not VerQueryValue(Data, '\\', Buffer, Len) then Exit;
      if not VerQueryValue(Data, SLang, Buffer, Len) then Exit;
      LangCount := Len div SizeOf(LongRec);
      for I := 0 to LangCount - 1 do
      begin
        Lang := LongRec(PLangList(Buffer)^[I]).Lo;
        CharSet := LongRec(PLangList(Buffer)^[I]).Hi;
        Block := Format(SBlock, [Lang, CharSet, Key]);
        if VerQueryValue(Data, PChar(Block), Buffer, Len) then
        begin
          Len := StrLen(PChar(Buffer));
          if Len > 0 then
          begin
            SetString(Result, PChar(Buffer), Len);
            Exit;
          end;
        end;
      end;
    finally
      FreeMem(Data, Size);
    end;
  end;
end;

{      }

var
  FPosCount: Integer = 0;

function GetDefFormPos: TPoint;
var
  X, Y, C: Integer;
begin
  {     }
  X := GetSystemMetrics(SM_CXFRAME);
  Y := GetSystemMetrics(SM_CYFRAME);
  C := GetSystemMetrics(SM_CYCAPTION);
  {   }
  Result.X := (X + C) * FPosCount;
  Result.Y := (Y + C) * FPosCount;
  {    }
  Inc(FPosCount);
  {   ( 6 ) }
  if FPosCount > 5 then FPosCount := 0;
end;

function GetDefFormBounds(Width, Height: Integer): TRect;
var
  P: TPoint;
begin
  {      }
  P := GetDefFormPos;
  {  }
  Result := Bounds(P.X, P.Y, Width, Height);
end;

{ /   " " }

type
  PTopMostEnumInfo = ^TTopMostEnumInfo;
  TTopMostEnumInfo = record
    TopWindow: HWND;
    TopMostList: TList;
  end;

function GetTopMostWindows(Handle: HWND; Info: Pointer): BOOL; stdcall;
begin
  Result := True;
  {     }
  if GetWindow(Handle, GW_OWNER) = Application.Handle then
    {    }
    if (GetWindowLong(Handle, GWL_EXSTYLE) and WS_EX_TOPMOST <> 0) then
      {  ,  " " }
      PTopMostEnumInfo(Info).TopMostList.Add(Pointer(Handle))
    else
    begin
      {    }
      PTopMostEnumInfo(Info).TopWindow := Handle;
      Result := False;
    end;
end;

procedure SetTopMostWindow(Wnd: HWND; TopMost, Activate: Boolean);
const
  Flags: array[Boolean] of Integer = (
    SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE,
    SWP_NOMOVE or SWP_NOSIZE);
var
  I: Integer;
  TopMostEnumInfo: TTopMostEnumInfo;
begin
  {       " " -    }
  if TopMost then
  begin
    SetWindowPos(Wnd, HWND_TOPMOST, 0, 0, 0, 0, Flags[Activate]);
    Exit;
  end;
  {    ,  "" }
  TopMostEnumInfo.TopMostList := TList.Create;
  try
    with TopMostEnumInfo do
    begin
      {    }
      TopWindow := Application.Handle;
      EnumWindows(@GetTopMostWindows, Longint(@TopMostEnumInfo));
      {     }
      TopWindow := GetWindow(TopWindow, GW_HWNDPREV);
      if IsTopMostWindow(TopWindow) then TopWindow := HWND_NOTOPMOST;
      for I := TopMostList.Count - 1 downto 0 do
        SetWindowPos(HWND(TopMostList[I]), TopWindow, 0, 0, 0, 0, Flags[False]);
      {      }
      TopMostList.Remove(Pointer(Wnd));
      {     }
      for I := TopMostList.Count - 1 downto 0 do
        SetWindowPos(HWND(TopMostList[I]), HWND_TOPMOST, 0, 0, 0, 0, Flags[False]);
    end;
    {   }
    if Activate then SetActiveWindow(Wnd);
  finally
    TopMostEnumInfo.TopMostList.Free;
  end;
end;

{ ,      " " }

function IsTopMostWindow(Wnd: HWND): Boolean;
begin
  Result := GetWindowLong(Wnd, GWL_EXSTYLE) and WS_EX_TOPMOST <> 0;
end;

{     }

function GetSystemErrorStr(Error: Integer; const Params: array of const): string;
var
  Buffer: PChar;
begin
  Result := '';
  {   }
  if FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_ARGUMENT_ARRAY, nil, Error, LANG_USER_DEFAULT, @Buffer, 0, @Params) > 0 then
  try
    {   , ,  }
    Result := Trim(RemoveLineBreaks(Buffer));
    Result := TrimCharRight(Result, '.');
  finally
    LocalFree(Integer(Buffer));
  end;
  {     }
  if Length(Result) = 0 then Result := Format(' %d', [Error]);
end;

function GetLastErrorStr(const Params: array of const): string;
begin
  Result := GetSystemErrorStr(GetLastError, Params);
end;

{     50%  }

var
  FPatternBitmap: TBitmap;

function PatternBitmap: TBitmap;
const
  C: array[Boolean] of TColor = (clBlack, clWhite);
var
  X, Y: Integer;
begin
  if FPatternBitmap = nil then
  begin
    FPatternBitmap := TBitmap.Create;
    with FPatternBitmap do
    begin
      Monochrome := TRUE;
      Width := 8;
      Height := 8;
      for X := 0 to 7 do
        for Y := 0 to 7 do
          Canvas.Pixels[X, Y] := C[(X and 1) <> (Y and 1)];
    end;
  end;
  Result := FPatternBitmap;
end;

procedure PaintResizeRect(Handle: THandle; Rect: TRect);
var
  DC: HDC;
  NewBrush, OldBrush: HBRUSH;
{$IFDEF EX_D2}
  Point: TPoint;
{$ENDIF}
begin
  DC := GetDCEx(Handle, 0, DCX_LOCKWINDOWUPDATE);
  try
    SetTextColor(DC, ColorToRGB(clWhite) );
    SetBkColor(DC, ColorToRGB(clBlack) );
    SetBkMode(DC, OPAQUE );
    SetRop2(DC, R2_COPYPEN );
    NewBrush := CreatePatternBrush(PatternBitmap.Handle);
    UnrealizeObject(NewBrush);
{$IFDEF EX_D2}
    SetBrushOrgEx(DC, 0, 0, Point);
{$ELSE}
    SetBrushOrgEx(DC, 0, 0, nil);
{$ENDIF}
    OldBrush := SelectObject(DC, NewBrush);
    with Rect do PatBlt(DC, Left, Top, Right - Left, Bottom - Top, PATINVERT);
    DeleteObject(SelectObject(DC, OldBrush));
  finally
    ReleaseDC(Handle, DC);
  end;
end;

{      }

procedure PaintBtnFrame(DC: HDC; Rect: TRect; Pressed: Boolean);
begin
  PaintBtnFrameEx(DC, Rect, Pressed, BF_RECT);
end;

procedure PaintBtnFrameEx(DC: HDC; Rect: TRect; Pressed: Boolean; SideFlags: Integer);
begin
  if not Pressed then
  begin
    DrawEdge(DC, Rect, BDR_RAISEDOUTER, SideFlags and (not BF_TOPLEFT));
    if SideFlags and BF_BOTTOM <> 0 then Dec(Rect.Bottom);
    if SideFlags and BF_RIGHT <> 0 then Dec(Rect.Right);
    DrawEdge(DC, Rect, BDR_RAISEDINNER, SideFlags and (not BF_BOTTOMRIGHT));
    if SideFlags and BF_TOP <> 0 then Inc(Rect.Top);
    if SideFlags and BF_LEFT <> 0 then Inc(Rect.Left);
    DrawEdge(DC, Rect, BDR_RAISEDINNER, SideFlags and (not BF_TOPLEFT));
    if SideFlags and BF_BOTTOM <> 0 then Dec(Rect.Bottom);
    if SideFlags and BF_RIGHT <> 0 then Dec(Rect.Right);
    DrawEdge(DC, Rect, BDR_RAISEDOUTER, SideFlags and (not BF_BOTTOMRIGHT));
  end
  else
    DrawEdge(DC, Rect, BDR_SUNKENOUTER, SideFlags or BF_FLAT);
end;

{     }

procedure PaintBtnComboBox(DC: HDC; Rect: TRect; Pressed: Boolean);
var
  Flags: Integer;
begin
  Flags := 0;
  if Pressed then Flags := DFCS_FLAT or DFCS_PUSHED;
  DrawFrameControl(DC, Rect, DFC_SCROLL, Flags or DFCS_SCROLLCOMBOBOX);
end;

procedure PaintBtnComboBox2(DC: HDC; Rect: TRect; Pressed: Boolean);
var
  Flags, DX: Integer;
begin
  Flags := 0;
  if Pressed then Flags := DFCS_FLAT;
  DrawEdge(DC, Rect, EDGE_RAISED, BF_RECT or BF_MIDDLE or Flags);
  Flags := (Rect.Right - Rect.Left) div 2 - 1 + Ord(Pressed);
  DX := (Rect.Right - Rect.Left) mod 2 - 1;
  PatBlt(DC, Rect.Left + Flags - 2 + DX, Rect.Top + Flags - 1, 7, 1, BLACKNESS);
  PatBlt(DC, Rect.Left + Flags - 1 + DX, Rect.Top + Flags + 0, 5, 1, BLACKNESS);
  PatBlt(DC, Rect.Left + Flags - 0 + DX, Rect.Top + Flags + 1, 3, 1, BLACKNESS);
  PatBlt(DC, Rect.Left + Flags + 1 + DX, Rect.Top + Flags + 2, 1, 1, BLACKNESS);
end;

{     }

procedure PaintBtnEllipsis(DC: HDC; Rect: TRect; Pressed: Boolean);
var
  Flags: Integer;
begin
  Flags := 0;
  if Pressed then Flags := BF_FLAT;
  DrawEdge(DC, Rect, EDGE_RAISED, BF_RECT or BF_MIDDLE or Flags);
  Flags := (Rect.Right - Rect.Left) div 2 - 1 + Ord(Pressed);
  PatBlt(DC, Rect.Left + Flags, Rect.Top + Flags, 2, 2, BLACKNESS);
  PatBlt(DC, Rect.Left + Flags - 3, Rect.Top + Flags, 2, 2, BLACKNESS);
  PatBlt(DC, Rect.Left + Flags + 3, Rect.Top + Flags, 2, 2, BLACKNESS);
end;

{    }

function GetFontHeight(Font: TFont): Integer;
var
  DC: HDC;
  Canvas: TCanvas;
begin
  {    }
  DC := GetDC(0);
  try
    {   }
    Canvas := TCanvas.Create;
    try
      {   }
      Canvas.Handle := DC;
      Canvas.Font := Font;
      {  }
      Result := Canvas.TextHeight('^j');
    finally
      Canvas.Free;
    end;
  finally
    ReleaseDC(0, DC);
  end;
end;

{  ()     }

function GetNextArchiveIndex(const Folder, Prefix, Ext: string; MaxFileCount: Integer): Integer;
var
  I, P: Integer;
  Strings: TStringList;
  S: string;
begin
  {     }
  Result := 0;
  {      }
  Strings := TStringList.Create;
  try
    {    }
    if DirectoryExists(Folder) then
    begin
      {    }
      GetFileList(Format('%s\%s*.%s', [TrimCharRight(Folder, '\'), Prefix, Ext]), Strings);
      {   }
      Strings.Sorted := True;
      {   }
      for I := Strings.Count - 1 downto 0 do
      begin
        {        }
        S := ExtractFileNameEx(Strings[I], False);
        {   }
        P := Length(Prefix);
        if P > 0 then S := Copy(S, P, 255);
        {    }
        P := StrToIntDef(S, -1);
        {   }
        if P <> -1 then
        begin
          Result := P;
          Break;
        end;
      end;
      {      }
      if MaxFileCount >= 0 then
        {    }
        while Strings.Count > MaxFileCount do
        begin
          {   }
          DeleteFile(Format('%s\%s', [TrimCharRight(Folder, '\'), Strings[0]]));
          {     }
          Strings.Delete(0);
        end;
    end;
  finally
    Strings.Free;
  end;
  {      }
  Inc(Result);
end;

{     }

function FormatArchiveFileName(const Folder, Prefix, Ext: string; Index: Integer): string;
begin
  Result := Format('%s\%s%8.8d.%s', [Folder, Prefix, Index, Ext]);
end;

{           }

function FormatArchiveDateTime(DateTime: TDateTime): string;
begin
  Result := FormatDateTime('dd/mm/yyyy hh:mm:ss', DateTime);
end;

{          }

procedure FormatArchiveBuff(const Values: array of string; const Lengths: array of Integer; Buff: Pointer; Size: Integer);
var
  I, Len, Offset: Integer;
  Val: string;

  function Min(A, B: Integer): Integer;
  begin
    if A < B then Result := A else Result := B;
  end;

begin
  {   }
  Offset := 0;
  {   }
  for I := Low(Values) to High(Values) do
  begin
    {      }
    Val := Values[I];
    Len := Min(Length(Val), Min(Lengths[I], Size - Offset));
    {   }
    Move(Pointer(Val)^, Pointer(PChar(Buff) + Offset)^, Len);
    {     }
    Offset := Offset + Lengths[I];
  end;
end;

procedure FormatArchiveStr(const Values: array of string; const Lengths: array of Integer; var S: string);
var
  I: Integer;
  Size: integer;
begin
  {       }
  Size := 0;
  for I := Low(Lengths) to High(Lengths) do Inc(Size, Lengths[I]);
  {   }
  if Size = 0 then
  begin
    S := '';
    Exit;
  end;
  {         }
  SetLength(S, Size);
  FillChar(Pointer(S)^, Size, ' ');
  {   }
  FormatArchiveBuff(Values, Lengths, Pointer(S), Size);
end;

initialization
  FPatternBitmap := nil;

finalization
  FPatternBitmap.Free;
  FPatternBitmap := nil;

end.
